<?
require_once('includes/conf.php');
enforcedSessionStart();

require_once('includes/portalutils.php');
require_once('password_strength.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/backend/axis/ActivateAccountMessage.php');

//Use the uid provided to get the appropriate patient, username, and activation token
$pat = "";
if (isset($_POST['pat'])) {
	$pat = $_POST['pat'];
} else {
	$pat = $_GET['pat'];
}
$user = "";
if (isset($_POST['user'])) {
	$user = $_POST['user'];
} else {
	$user = $_GET['user'];
}
$token = "";
if (isset($_POST['token'])) {
	$token = $_POST['token'];
} else {
	$token = $_GET['token'];
}
//The URL thinks it's being smart when it replaces "+" with " ", but this actually breaks the token.
$token = str_replace(' ', '+', $token);

if ($pat != null) {
	//$patient = getPatientByCredentials($user, $pat);
	$patient = getPatientFromDB('cec', $pat, false, null);
	if ($patient == null || $patient->getFieldValue('uid') == null) {
		$error = "The Patient record from the activation link was not found.  Be sure
				 that you only access this page via the activation e-mail link.";
	} else {
		$user = getPatUsername($patient);
	}
} else {
	$error = "You must specify a patient record in order to activate. Be sure
			 that you only access this page via the activation e-mail link.";
}
if ($error == null) {
	if ($patient == null) {
		$error = "The chosen patient does not match any on file. Be sure that
				 you only access this page via the activation e-mail link.";
	} else if ($token == null) {
		$error = "The given activation ID does not match any on file. Be sure that
				 you only access this page via the activation email link.";
	} else if (isset($_POST['stage']) && $_POST['stage'] == 'process') {
		//Process the form - first check that new and confirm passwords are both set
		if (!isset($_POST['password']) || !isset($_POST['password2']) || $_POST['password'] == "" || $_POST['password2'] == "") {
			$error = "Both password fields are required.  Please enter all information and retry.";
		} else if ($_POST['password'] != $_POST['password2']) {
			$error = "New password and confirm password must be equal.  Please retry.";
		} else if ($_POST['birthday'] == null) {
			$error = "You must enter your birthday for verification purposes.";
		} else if ($_POST['zip'] == null) {
			$error = "You must enter your current zip code for verification purposes.";
		} else {
			$invalid = verifyPasswordStrength($_POST['password']);
			if ($invalid != null) {
				$error = $invalid;
			} else {
				$msg = new ActivateAccountMessage('cec_portal');
				try {
					$birthday = date('Y-m-d', strtotime($_POST['birthday']));
					$zip = $_POST['zip'];
					if ($msg->activateAccount($patient->getFieldValue('uid'), $token, $_POST['password'], $birthday, $zip)) {
						//Activated - double check by trying to log in.
						if (!logIn($user, $_POST['password'])) {
							$error = "An unknown error occurred. Please try again.";
						} else {
							//Successful login - go to the success page
							header('location:activate_success.php');
						}
					} else {
						$error = "An error occurred while saving the new password. Please try again.";
					}
				} catch (Exception $e) {
					if ($e->getMessage() != null && stripos($e->getMessage(), 'Demographics') !== false) {
						$error = "The birthday or zip code you entered do not match the ones on file.  Please verify them both and try again.";
					} else if ($e->getMessage() != null && stripos($e->getMessage(), 'already') !== false && stripos($e->getMessage(), 'activated') !== false) {
						$error = "The account with this username already exists.  If you do not remember your password, please <a href=\"reset_password.php\">reset your password</a>.";
					} else {
						$error = "An error occurred while saving the new password. Please try again.";
					}
					//This includes a plain-text password!  Do not log the exception dump!
					//klog(dump($e), KLogger::ERROR);
					klog('Error saving new password for patient ' . $patient->getFieldValue('uid') . ' - ' . $e->getMessage() . '.', KLogger::ERROR);
				}
			}/*  else if (!setPatientPassword($patient, $_POST['password'])) {
				$error = "An error occurred while saving the new password. Please try again.";
			} else if (!logIn($user, $_POST['password'])) {
				$error = "An unknown error occurred. Please try again.";
			} else {
				$msg = new SendWelcomeEmailMessage('cec_portal');
				$msg->sendWelcomeEmail($patient->getFieldValue('uid'));
				header('location:activate_success.php');
			} */
		}
	}
}

$drawArrow = false;

//Include the header info
$title='EyeCare Associates - Activate Your Account';
include("template.php");

$subMenu = "portal_menu.jpg";
//Don't show timeout warnings on the activate page.
$initializeTimeout = false;
include("head.php");

?>

<h1>Activate Your Account</h1>
<p><? echo (isset($error)) ? $error : ""; ?></p>
<form action="<? echo $_SERVER['PHP_SELF'];?>" method="post" id="activateform" name="activateform">
  <input type="hidden" name="stage" value="process" />
	<input type="hidden" name="pat" value="<? echo $pat; ?>" />
	<input type="hidden" name="user" value="<? echo $user; ?>" />
	<input type="hidden" name="token" value="<? echo $token; ?>" />
	<table width="800" class="formLines1">
		<?
			echo "<tr><td>Username: </td><td class=\"user-username\">$user</td><td rowspan=\"4\" style=\"padding-left: 10px;\">";
			echo showPasswordRequirements('password');
			echo "</td></tr>";
		?>
		<tr><td><label for="password">
		  <div class="smallItem">New Password*: </div></label></td><td><input id="password" type="password" name="password" /></td></tr>
		<tr><td><label for="password2">
		  <div class="smallItem">Confirm Password*: </div></label></td><td><input id="password2" type="password" name="password2" /></td></tr>
		<tr><td><label for="birthday">
		  <div class="smallItem">Confirm Birthday*: <br />
	      (MM/DD/YYYY)&nbsp;format</div></label></td><td><input id="birthday" type="text" name="birthday" /></td></tr>
		<tr><td><label for="zip">
		  <div class="smallItem">Confirm Zip Code*: </div></label></td><td><input style="float: left;" id="zip" type="text" name="zip" /></td></tr>
		<tr><td colspan="2"><input type="submit" value="Submit" /></td></tr>
	</table>
</form>

<br />
<?  include "foot.php"; ?>
