<?
require_once('includes/conf.php');
enforcedSessionStart();

require_once('includes/portalutils.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/saleslogformatter.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/currencyformatter.php');

$errorFlag = 0;

if (defined('PORTAL_BILLING_DOWN') && PORTAL_BILLING_DOWN) {
	$fatalError = "Online bill pay is temporarily unavailable.  We are currently working to restore the service as quickly as possible.  We apologize for the inconvenience.";
}

if (isset($fatalError)) {
	include("head.php");
	echo "<div class=\"error\" style=\"font-size:12pt;\">$fatalError<p><a href=\"portal_main.php\">Back to Portal Home</a></p></div>";
} else {
if (isset($_GET['error'])) {
	if ($_GET['error'] == 'superbill') {
		$error = "An error occurred while updating your invoice, and you may still have been billed.
		         Please do not try to submit the payment again. EyeCare Associates has been notified of the error,
				 and will try to rectify it as soon as possible. We're sorry for any inconvenience.";
	} else if (isset($_SESSION['error'])) {
		$error = "An error occurred while charging your card: " . $_SESSION['error'] . "<br>\nPlease make sure your
		          billing information is correct and try again. If this error occurs again, please send an e-mail
				  to info@webeca.com regarding the issue and we'll help you to resolve the problem. We're
				  sorry for any inconvenience.";
		unset($_SESSION['error']);
	} else {
		$error = "An unknown error occurred while billing your invoice. Please try again. If this error
	              occurs again, please send an e-mail to info@webeca.com regarding the issue and
			      we'll help you to resolve the problem. We're sorry for any inconvenience.";
	}
}

//First see if the form has already been submitted:
if (isset($_POST['stage']) && $_POST['stage'] == 'process') {
	//The form has been submitted.
	//if there is new billto data, store it
	if (!isset($_POST['usepatientaddress'])) {
		//if one of them is set, they all are thanks to the JS check
		$_SESSION['billto']['firstname'] = strtoupper($_POST['billfirstname']);
		$_SESSION['billto']['lastname'] = strtoupper($_POST['billlastname']);
		$_SESSION['billto']['address'] = strtoupper($_POST['billaddress']);
		$_SESSION['billto']['city'] = strtoupper($_POST['billcity']);
		$_SESSION['billto']['state'] = strtoupper($_POST['billstate']);
		$_SESSION['billto']['zip'] = strtoupper($_POST['billzip']);
		$_SESSION['billto']['homephone'] = strtoupper($_POST['billphone']);
	} else {	
		unset($_SESSION['billto']);
		//session_unregister('billto');	
	}
	header('location:review.php');
}

//Check that a patient has logged in (or at least chosen a superbill)
$patient = getPatient();

//Check that a superbill has been selected
$superbill = getSuperbill();
if (!isset($patient) || !isset($superbill)) {
	header('location:choose_invoice.php');
} else {
//All patient needs to be "logged in" is to have their uid and superbill set
$logged_in = true;

$totals = $superbill->total();
$patBalance = $totals['PAT_BALANCE'];
$formatter = new CurrencyFormatter();

$drawArrow = true;
$arrowPos = 349;

//Include the header info
$title='EyeCare Associates - Pay Bill (invoice #' . $superbill->getSuperbillNumber() . ')';
include("template.php");

$topMenu = "insurancetop.swf";
$topMenuName = "insurancetop";
$subMenu = "billpay_menu.jpg";
$subMenuName = "billpay_menu";
$allowToChoose = isLoggedIn($patient);
$whichPageNum = 2;
include("head.php");

if (!userCanSeeSuperbill($patient, $superbill)) {
	echo "<h2 class=\"error\">You are not authorized to view this invoice. Please go back and 
	      <a href=\"choose_invoice.php\" class=\"basicLink\">Select an Invoice</a></h2>";
} else {

if (isset($error)) {
	echo "<div class=\"error\" style=\"font-size:12pt;\">$error</div>";
}

//Set the billing info defaults array based on either previously set billing info or the patient's array
if (isset($_SESSION['billto'])) {
	$billingArray = $_SESSION['billto'];
} else {
	$billingArray = $patient->getFields(array('firstname', 'lastname', 'address', 'city', 'state', 'zip', 'homephone'));
}

?>

<h1>Invoice (#<? echo $superbill->getSuperbillNumber(); ?>):</h1>
<?
	echo "\n" . $superbill->getSalesLogTable() . "\n";
	echo $superbill->getDateAndBalanceHTML();
?>
<!-- <div class="billBalance">Patient Balance: <? echo $formatter->format($patBalance); ?></div> -->

<?
if ($patBalance < 0.01 || $superbill->codeExists(SalesLog::$COLLECTIONS_CODE)) {
	if ($superbill->codeExists(SalesLog::$COLLECTIONS_CODE)) {
		$note = Superbill::$COLLECTIONS_STRING;
	} else {
		$note = "This invoice has no balance due";
	}
	echo "<div class=\"returnInfo\"><h2 class=\"orange\">" . $note . "</h2>\n";
	echo "<a href=\"choose_invoice.php\">Click Here</a> to return to the invoice select screen</div>\n";
} else {
	//Only show the rest of the page if the patient has some balance
?>

<script type="text/javascript">
	function submitForm() {
		var isOkay = true;
		if(!document.getElementById('usepatientaddress').checked) {
			//if sameas is not checked, the patient has a different shipping address than billing address. 
			var ids = "#billfirstname,#billlastname,#billaddress,#billcity,#billstate,#billzip,#billphone,#expmonth,#expyear,#ccnumber,#cardname";
			
			$(ids).each(function() {
				if ($(this).val() == "") {
					//Slide down info box moderately fast
					$('#missingBillTo').hide();
					$('#missingBillTo').text("Please fill in all of the required Bill To fields.");
					$('#missingBillTo').slideDown(400);
					isOkay = false;
					return false;
				}
			});
		}
		
		if (isOkay) {
			document.forms[0].submit();
		}
	}
	
	function fixForm() {
		//Enable or disable the billing inputs appropriately
		var ckd = (document.getElementById('usepatientaddress').checked);
		$('#billfirstname,#billlastname,#billaddress,#billcity,#billstate,#billzip,#billphone').attr('disabled', ckd);
	}
</script>

<h1>Billing Information</h1>
<form action="<?php echo $_SERVER['PHP_SELF'];?>" method="post" id="billingForm" name="billingForm">
	<input type="hidden" name="stage" value="process" />
	<input type="hidden" id="patBalance" name="patBalance" value="<? echo $patBalance; ?>" />
	
	<p style="font-weight: bold">Bill To</p>
	<p>
	<?
		$checked = ((!isset($_SESSION['billto'])) ? ' checked="checked"' : '');
		echo '<input type="checkbox" name="usepatientaddress" id="usepatientaddress"' .
		     $checked . ' onclick="fixForm();" /> Same as this Account\'s Patient';
	?>
	</p>
	<!-- ********************************************* Billing Address Info ********************************************* -->
	<table class="formLines1" id="billingTable" cellspacing="3" cellpadding="3" border="0">
		<tr>
			<td>First Name</td>
			<td><input name="billfirstname" id="billfirstname" type="text" size="40" value="<? echo $billingArray['firstname']; ?>" /></td>
		</tr>
		<tr>
			<td>Last Name</td>
			<td><input name="billlastname" id="billlastname" type="text" size="40" value="<? echo $billingArray['lastname']; ?>" /></td>
		</tr>
		<tr>
			<td>Address</td>
			<td><input name="billaddress" id="billaddress" type="text" size="40" value="<? echo $billingArray['address']; ?>" /></td>
		</tr>
		<tr>
			<td>City</td>
			<td><input name="billcity" id="billcity" type="text" size="40" value="<? echo $billingArray['city']; ?>" /></td>
		</tr>
		<tr>
			<td>State</td>
			<td><select name='billstate' id="billstate" size="1">
				<?php
					foreach ($_SESSION['stateArray'] as $abbr => $name) {
						if ($billingArray['state'] == $abbr) {
							echo '<option value="'.$abbr.'" selected="selected">'.ucwords(strtolower($name)).'</option>';
						} else {
							echo '<option value="'.$abbr.'">'.ucwords(strtolower($name)).'</option>';
						}
					}
				 ?>
				</select>				
			</td>
		</tr>
		<tr>
			<td>Zip</td>
			<td><input name="billzip" id="billzip" type="text" size="10" value="<? echo $billingArray['zip']; ?>" /></td>
		</tr>
		<tr>
			<td>Phone Number</td>
			<td><input name="billphone" id="billphone" type="text" size="40" value="<? echo $billingArray['homephone']; ?>" /></td>
		</tr>
	</table>
	<p id="missingBillTo" class="error" style="display:none;"></p>
	<p style="text-align: center;">
		<input type="button" onclick="submitForm()" value="Next" />
	</p>
</form>

<script type="text/javascript">
	fixForm();
</script>
<?
} //end if balance != 0
} //end if patient is correct
} //end if patient and superbill are set
} //End if no fatal error
?>
<br>
<?  include "foot.php"; ?>
