<?

require_once('includes/portalutils.php');
require_once('password_strength.php');

//$newPassword holds the new password to try, $confirmPassword holds the confirmation one.  $oldPassword holds their current password.
//Returns a message with the results and a message class indicating response type. This file requires $patient to be set with the patient 
//whose username is to change.  Message class assumed to default to error.

if (!isset($newPassword) || $newPassword == "" || !isset($confirmPassword) || $confirmPassword == "") {
	$message = "Must enter a new password and confirmation. Please enter these fields and try again.";
} else if ($newPassword != $confirmPassword) {
	$message = "The new password and confirm password you entered did not match. Please try again.";
} else {
	$invalid = verifyPasswordStrength($newPassword);
	if ($invalid != null) {
		$message = $invalid;
	} else if (setPatientPassword($patient, $oldPassword, $newPassword)) {
		//Log back in with the new info
		setSessionPassword($newPassword);
		$message = "Password successfully changed!";
		$messageClass = "success";
	}
}

?>