<?
require_once('includes/conf.php');
enforcedSessionStart();

require_once('includes/includes.php');
require_once('includes/portalutils.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/superbillexcluder.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/saleslog.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/fullnameformatter.php');
require_once(GLOBAL_INCLUDES_DIR . 'crystalLake/uitools.php');

$mainPatient = getPatient();

if ($mainPatient != null) {
	$logged_in = isLoggedIn($mainPatient);

	//The user must be logged in to access this page
	if (!$logged_in) {
		$_SESSION['referral_page'] = $_SERVER['PHP_SELF'];
		header("location:login.php");
	} else {
		$currencyFormatter = new CurrencyFormatter();
		$fnf = new FullNameFormatter(null, false);
		$superbillExcluder = new SuperbillExcluder();

		$drawArrow = true;
		$arrowPos = 228;

		//Include the header info
		$title='EyeCare Associates - View Active Invoices';
		include("template.php");
		
		$topMenu = "insurancetop.swf";
		$topMenuName = "insurancetop";
		$subMenu = "billpay_menu.jpg";
		$subMenuName = "billpay_menu";
		$allowToChoose = true;
		$whichPageNum = 1;
		include("head.php");
?>



		<h1>View & Pay Open Invoices</h1>
		<p>Below you'll find a complete list of open invoices. </p>
		<?
		$patients = getAllUnderAccount($mainPatient);
		$patientMap = array();
		$num = 0;
		$numClosed = 0;
		foreach ($patients as $patient) {
			$dpls = getSuperbillsForPatient($patient);
		?><hr align="left" width="50%" />
			
<h3 id="patient-name">Patient:  <? echo $fnf->format($patient) ?></h3>

			<?
			//Loop through each superbill and show relevant ones
			foreach ($dpls as $dpl) {
				$superbill = new Superbill($dpl->getDatabaseName());
				$superbill->load($dpl->getFieldValue('superbill'));
				//Only show the superbill if there's a reason to show it.
				if (!$superbillExcluder->exclude($superbill)) {
	
					echo "<div class=\"invoice\">\n";
					//Show the superbill as an expandable box
					echo UITools::getExpandableBox($superbill->getSalesLogTable(), "invoiceTable_$num",
								"Invoice #" . $superbill->getSuperbillNumber() . ":", 'orange');
					$totals = $superbill->total();
					$patBalance = $totals['PAT_BALANCE'];
					
					//Show the date of service and account balance
					echo $superbill->getDateAndBalanceHTML();
					
					//Show the "account placed under collections" info if applicable
					if ($superbill->codeExists(SalesLog::$COLLECTIONS_CODE)) {
						echo "<div class=\"collectionsInfo\">" . Superbill::$COLLECTIONS_STRING . "</div>\n";
					}
					
					//Add the form that allows users to pay the bill
					echo "<form class=\"paySuperbill\" id=\"paySuperbill_$num\" action=\"billing_info.php\" method=\"post\">\n";
					echo "<input type=\"hidden\" name=\"superbill\" value=\"" . $superbill->getSuperbillNumber() . "\" />\n";
					echo "<input type=\"hidden\" name=\"superbill_db\" value=\"" . $dpl->getDatabaseName() . "\" />\n";
					echo "<input type=\"submit\" value=\"Pay This Bill\" />\n";
					echo "</form>\n";
					echo "</div>\n";
					$num++;
				}
				//Uncomment below if we're showing old invoices here as well
				/*else {
					//Superbill is excluded - add it to the other div
					$uid = $patient->getFieldValue('uid');
					$patientMap[$uid] = $patient;
					$hiddenInvoices[$uid][] = UITools::getExpandableBox($superbill->getSalesLogTable(), "oldInvoiceTable_$numClosed",
								"Invoice #" . $superbill->getSuperbillNumber() . ":", 'orange') . $superbill->getDateAndBalanceHTML();
					$numClosed++;
				} //end if superbill not excluded
				*/
			} //end foreach dpl
		} //end foreach patient
		
		//Now show closed invoices (stored as HTML)
		/*echo "<br><br>\n<h1>Closed Invoices</h1>";
		foreach ($hiddenInvoices as $patUID=>$patInvoices) {
			echo "<h2>For patient: " . $fnf->format($patientMap[$patUID]) . "</h2>";
			foreach ($patInvoices as $invoiceHTML) {
				echo $invoiceHTML . "\n";
			}
		}*/
		
		if ($num > 0) {
			//If any were added, expand the first:
			echo "<script type=\"text/javascript\">expandItem('invoiceTable_0');</script>\n";
		}

		echo "<br>\n";
		include "foot.php";
	} //end if is logged in
} //end if patient != null
?>