<?
require_once('includes/conf.php');
enforcedSessionStart();

require_once('includes/portalutils.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/location.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/holderfieldkeygenerator.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/dataholderfieldcomparator.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/dateformatter.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/fullnameformatter.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/backend/axis/getpateducationmessage.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/backend/axis/geteducationresourcemessage.php');

//Include the header info
$title='EyeCare Associates - Educational Resources';
include("template.php");

$subMenu = "portal_menu.jpg";
$subMenuName = "portal_menu";
$mainPatient = getPatient(true);
if ($mainPatient != null) {
	$drawArrow = false;
	$rightPadding = 10;
	include("head.php");
	
	$patients = getAllUnderAccount($mainPatient);
	$patientNum = $_GET['patientNum'];
	$chosenPatient = null;
	if (!isset($patientNum)) {
		$patientNum = 0;
		$chosenPatient = $mainPatient;
	}
	
	$fnf = new FullNameFormatter(null, false);
	echo "<h1>Patient Education</h1>";
	$num = 0;
	
	//Only list patients under the account if > 1
	if (isset($patients) && count($patients) > 1) {
		echo "<h2 class=\"orange\">Choose Patient</h2>\n<div class=\"spaced\">";
		foreach ($patients as $patient) {
			echo "<div class=\"basicMedium boldText\">";
			if ($num == $patientNum) {
				//This is the chosen patient; just show their name
				$chosenPatient = $patient;
				echo "-&gt;" . $fnf->format($patient);
			} else {
				//This is another patient, allow user to choose them
				echo "<a class=\"basicLink boldLink\" href=\"" . $_SERVER['PHP_SELF'] . "?patientNum=$num\">" . $fnf->format($patient) . "</a>";
			}
			echo "</div>\n";
			$num++;
		}
		echo "</div><br />\n<!-- End div: Choose Patient -->";
	} else if (isset($chosenPatient)) {
		echo "<h3 id=\"patient-name\" class=\"darkorange\">" . $fnf->format($chosenPatient) . "</h3>";
	}
	
	if ($chosenPatient != null) {
		if (isset($_GET['date'])) {
			$resourceDate = strtotime($_GET['date']);
		}
		$dateFormatter = new DateFormatter('m/d/Y');
		$isoDateFormatter = new DateFormatter('Y-m-d');
		$msg = new GetPatEducationMessage('cec_patedu');
		if (isset($resourceDate)) {
			$resources = $msg->getPatEducationEntries($chosenPatient->getFieldValue('uid'), $_GET['date']);
		} else {
			$resources = $msg->getPatEducationEntries($chosenPatient->getFieldValue('uid'));
		}
		
		foreach ($resources as $resource) {
			$entryUID = $resource->getFieldValue('resource');
			if ($entryUID != null) {
				//The entry has an education resource attached - load it to get more data.
				$msg = new GetEducationResourceMessage('cec_patedu');
				try {
					$resEntry = $msg->getEducationResourceEntry($entryUID);
				} catch (Exception $e) {
					echo dump($e);
				}
				if ($resEntry != null) {
					$resource->setResourceEntry($resEntry);
					//Set these values in the pat entry as well so uniquifying works.
					$resource->setFieldValue('title', $resEntry->getFieldValue('title'));
					$resource->setFieldValue('url', $resEntry->getFieldValue('url'));
					$resource->setFieldValue('source', $resEntry->getFieldValue('source'));
				}
			}
		}
		
		?>
		<!-- Script that filters by date -->
		<script type="text/javascript">
			function filterResources(date) {
				var filterLink = "a#filter_all";
				if (date == null) {
					//Show all entries
					$("div.dateEntries").show();
				} else {
					//Show only entries for the provided date
					$("div.dateEntries").hide();
					$("div#entries_" + date).show();
					filterLink = "a#filter_" + date;
				}
				//Show basic links for all filters
				$("a.resourceFilter").removeClass("basicMedium");
				$("a.resourceFilter").addClass("basicLink boldLink");
				
				//The selected filter should be white
				$(filterLink).removeClass("basicLink boldLink");
				$(filterLink).addClass("basicMedium");
			}
		</script>
		<?
		if ($resources != null && count($resources) > 0) {
			//For each date, we only want the same title/URL/source combination to appear once
			$resources = uniquifyHolders($resources, array('date', 'title', 'url', 'source'));
			$keyGen = new HolderFieldKeyGenerator('date');
			$resourcesByDate = splitListToMap($resources, $keyGen);
			//Sort by most recent date first
			krsort($resourcesByDate);
			//Add filters so the user can look at specific dates only (don't show filters if there's only one date).
			if (count($resourcesByDate) > 1) {
				//Add a filter that shows all resources
				$linkClass = ($resourceDate == null ? "basicMedium" : "basicLink boldLink");
				echo "<div><a id=\"filter_all\" href=\"javascript:filterResources(null);\" class=\"$linkClass resourceFilter\">All Resources</a></div>";
				foreach ($resourcesByDate as $date=>$entries) {
					$isoDate = $isoDateFormatter->format($date);
					//Add the filters that allow the user to select specific dates.
					$linkClass = "basicLink boldLink";
					if ($resourceDate != null) {
						$linkClass = ($resourceDate == $isoDate ? "basicMedium" : "basicLink boldLink");
					}
					$dateStr = $dateFormatter->format($isoDate);
					echo "<div><a id=\"filter_$isoDate\" href=\"javascript:filterResources('$isoDate');\" class=\"$linkClass resourceFilter\">Resources for $dateStr</a></div>";
				}
			} else if ($resourceDate != null) {
				echo "<div><a id=\"filter_all\" href=\"education.php\" class=\"basicLink boldLink\">Show All Resources</a></div>";
			}
			
			//Add each date in a collapsible pane.
			foreach ($resourcesByDate as $date=>$entries) {
				$isoDate = $isoDateFormatter->format($date);
				//Add the div that disappears on filter
				echo "<div class=\"dateEntries\" id=\"entries_$isoDate\">";
				$comparator = new DataHolderFieldComparator('title');
				usort($entries, $comparator->getCallback());
				$dateStr = $dateFormatter->format($date);
				//Add the div that expands/shrinks when the "+/-" icon is pressed
				echo "<h3 class=\"orange expander\" onclick=\"expandItem('container_$isoDate');\"><img src=\"/Image/minus.jpg\" alt=\"hide\" id=\"plus_container_$isoDate\" style=\"margin-right: 6px;\" />Education Entries for $dateStr</h1><div id=\"container_$isoDate\">";
				$keyGen = new HolderFieldKeyGenerator('source');
				$entriesBySource = splitListToMap($entries, $keyGen);
				foreach ($entriesBySource as $source=>$subEntries) {
					if ($source == null) {
						$source = "an unknown source";
					}
					echo "<h3>Resources from $source</h3><ul>";
					foreach ($subEntries as $entry) {
						$resEntry = $entry->getResourceEntry();
						if ($resEntry == null) {
							$title = $entry->getFieldValue('title');
							$url = $entry->getFieldValue('url');
							$desc = null;
						} else {
							$title = $resEntry->getFieldValue('title');
							$url = $resEntry->getFieldValue('url');
							$desc = $resEntry->getFieldValue('description');
						}
						//Add the description if one was found
						$descStr = (isset($desc) ? "<div>$desc</div>" : "");
						
						echo "<li><div><a href=\"$url\" class=\"basicLink mediumLink\" target=\"_blank\">$title</a></div>$descStr</li>";
					}
					echo "</ul>";
				}
				echo "</div></div>";
			}
		} else {
			//No resources found
			$dateStr = ($resourceDate == null ? "" : " for this date");
			echo "<h1 class=\"orange\">No resources found$dateStr</h1><div>We couldn't find any educational resources for you$dateStr.  This page only includes resources your eyecare provider has specifically chosen for you, so they may not have chosen any.  If you came here from a secure email sent from your provider, we may be experiencing technical difficulties that should be resolved soon.  Please try again later.  We apologize for any inconvenience this may have caused you.</div>";
		}
	} else {
		echo "<div class=\"bigorange spaced\">Education Resources not Found</div>\n";
		echo "<div class=\"smallItem\">Your educational resources could not be found.  Please try again.</div>";
	} //End if chosenPatient == null
?>

<?
	echo "<br />\n";
	include "foot.php";
} //End if mainPatient != null
?>
