<?
require_once('includes/conf.php');
enforcedSessionStart();

require_once('includes/portalutils.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/dateformatter.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/fullnameformatter.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/donothingformatter.php');

//Include the header info
$title='EyeCare Associates - Email Opt Out';
include("template.php");

$subMenu = "opt_out_menu.jpg";
$subMenuName = "opt_out_menu";
$drawArrow = false;
$rightPadding = 0;
$includeLogin = false;
include("head.php");

$patientUID = $_GET['patient'];
$error = false;
$manualEntry = false;
if (!isset($patientUID)) {
	//No patient - we can't do anything here.
	$error = true;
} else {
	$serverNames = unserialize(SERVER_NAMES);
	$patientsFound = false;
	foreach ($serverNames as $serverName) {
		$patient = getPatientFromDB($serverName, $patientUID, false, null);
		if (isset($patient) && $patient->getFieldValue('firstname') != null && $patient->getFieldValue('firstname') != '') {
			//Checking for firstname ensures that the patient was loaded properly
			$patientsFound = true;
			//$patient->setFieldValue('no_call', 'TRUE');
			$prefContact = $patient->getFieldValue('preferred_contact');
			if ($prefContact != null && strtoupper($prefContact) == 'EMAIL') {
				$patient->setFieldValue('preferred_contact', 'PHONE');
			}
			auditOptOut($patient->getDatabaseName(), $patient->getFieldValue('uid'), LOCATION_STAMP);
			$validation = $patient->saveData();
			if (isset($validation) && is_array($validation) && count($validation) > 0) {
				//Don't show the patients an error - just log it and send an email to someone at the call center about the error
				$manualEntry = true;
				$fullNameFormatter = new FullNameFormatter(new DoNothingFormatter(), true);
				$dateFormatter = new DateFormatter('m/d/Y');
				klog("Error saving patient with no_call flag: " . $fullNameFormatter->format($patient) . " ($patientUID)", KLogger::ERROR);
				
				$to = SCHEDULE_MAIL_TO;
				$subject = "Opt-Out Patient Emails";
				$message = "The patient couldn't be opted out of receiving EyeCare Associates emails due to an error while " .
						"saving the patient record.  Please check their \"No Communication\" box manually.\n\n" .
						"Patient: " . $fullNameFormatter->format($patient) . "\nBirthday: " .
								$dateFormatter->format($patient->getFieldValue('birthday')) .
								"\nE-mail: " . $patient->getFieldValue('email') . "\n\n" .
								"CEC or VC? " . strtoupper($patient->getDatabaseName());
				$headers = array("From" => "opt_out@Webeca.com", "X-Mailer" => "PHP/" . phpversion(), "Subject" => $subject);
				if (!pearMail(SMTP_HOST, SMTP_PORT, SMTP_USERNAME, SMTP_PASSWORD, $to, $message, $headers)) {
					klog("Error sending error email for patient $patientUID", KLogger::ERROR);
				}
			}
		}
	}
	if (!$patientsFound) {
		//No patients were found with that UID - we can't do anything here
		$error = true;
	}
}

if ($error) {
	echo "<div class=\"error\">There was an unexpected error in the opt-out process.  Please <a href=\"/locations/index.html\">call your office</a> in order " .
		"to opt out of future EyeCare Associates emails.</div>";
} else {
	echo "<div class=\"basicMedium\">You have successfully opted out of receiving EyeCare Associates emails.</div>";
	if ($manualEntry) {
		echo "<br><div class=\"basicMedium\">Please note that it may take up to one business day for the change to take effect, " .
				"and you may receive emails from EyeCare Associates in the meantime.  We appreciate your patience.</div>";
	}
}


?>

<?  include "foot.php"; ?>