<?
//********************************************************************
//Parameters (All are required):
//$_POST['examUID'] - The UID of the exam for which to get a clinical summary
//$_POST['date'] - The date of that exam
//$_POST['portalPatient'] - The UID of the patient that is making the request (for user verification)
//$_POST['patientName'] - The name of the patient to be displayed in header info
//$_POST['patientNum'] - The index of the chosen patient on the page
//********************************************************************
require_once('includes/conf.php');
enforcedSessionStart();

require_once('includes/portalutils.php');
require_once(GLOBAL_INCLUDES_DIR . 'config.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/backend/axis/CreateDefaultClinicalSummaryMessage.php');

$mainPatient = getPatient();
$logged_in = isLoggedIn($mainPatient);
$patientNum = $_POST['patientNum'];
if ($mainPatient != null && $logged_in && $mainPatient->getFieldValue('uid') == $_POST['portalPatient']) {
	$msg = new CreateDefaultClinicalSummaryMessage('cec_portal');
	$exceptionOccurred = false;
	try {
		$cdaDoc = $msg->createDefaultClinicalSummary($_POST['examUID'], $mainPatient->getFieldValue('uid'));
	} catch (Exception $e) {
		$exceptionOccurred = true;
	}
	//Show the C-CDA as stylized by the xsl document
	if (isset($cdaDoc)) {
	?>
		<h2 class="orange">Download</h2>
		<p>Click on the "Download" button to download your clinical summary in both human-readable format and in a format that computers can understand.</p>
		<form id="downloadForm" method="post" action="view_clinical_summary.php?patientNum=$patientNum">
			<input type="hidden" name="downloadCDA" value="1" />
			<input type="hidden" id="cdaSaveData" name="cdaSaveData" value="" />
			<input type="hidden" id="examUID" name="examUID" value="<? echo $_POST['examUID']; ?>" />
			<input type="submit" value="Download" />
		</form>
	<?
		$dateStr = date('m/d/Y', strtotime($_POST['date']));
		echo "<h2 class=\"orange\">View Clinical Summary for " . $_POST['patientName'] . " on $dateStr</h2>\n";
		//echo processXSLT(getDOMFromFile(CCDA_STYLE_DOC_LOCATION), $cdaDoc);
		//The C-CDA parsers sometimes add character 160 instead of non-breaking spaces.  Just replace these with ' '
		echo str_replace(chr(160), ' ', processXSLT(getDOMFromFile(CCDA_STYLE_DOC_LOCATION), $cdaDoc));
	} else if ($exceptionOccurred) {
		echo "<div class=\"bigorange spaced\">Clinical summary for " . $_POST['patientName'] . " could not be loaded</div>\n";
		echo "<div class=\"smallItem\">Your clinical summary could not be loaded at this time. Please try again later.</div>";
	} else {
		echo "<div class=\"bigorange spaced\">Clinical summary not found for " . $_POST['patientName'] . "</div>\n";
		echo "<div class=\"smallItem\">Your clinical summary could not be found at this time. Please try again later.</div>";
	}
	echo "<hr />\n";
} else {
	echo "<h4 class=\"error\">You can only access this page from the \"View Exam Summary\" page.</h4>";
}

?>
