<?
//********************************************************************
//Parameters (All are required):
//$_POST['patUID'] - The UID of the patient that is selected
//$_POST['from'] - The start date for activity history
//$_POST['to'] - The end date for activity history
//********************************************************************
require_once('includes/conf.php');
enforcedSessionStart();

require_once('includes/portalutils.php');
require_once(GLOBAL_INCLUDES_DIR . 'config.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/dataholderfieldcomparator.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/backend/axis/GetPatientActivityMessage.php');

$chosenPatient = $_POST['patUID'];
$from = $_POST['from'];
$to = $_POST['to'];
$mainPatient = getPatient();
$logged_in = isLoggedIn($mainPatient);
if ($mainPatient != null && $logged_in && isAuthorizedRep($chosenPatient, $mainPatient->getFieldValue('uid'), 'cec_portal')) {
	$msg = new GetPatientActivityMessage('cec_portal');
	$history = $msg->getPatientActivity($chosenPatient, $from, $to);
	//Show the C-CDA as stylized by the xsl document
	if ((!isset($history)) || count($history) == 0) {
		//Empty history
		echo "<div class=\"bigorange spaced\">No View/Download/Transmit history for this patient.</div>\n";
		echo "<div class=\"smallItem\">Nobody has viewed, downloaded, or transmitted your health information.</div>";
	} else {
		$comparator = new DataHolderFieldComparator(array('created_stamp'));
		usort($history, $comparator->getCallback());
		foreach ($history as $audit) {
			//TODO - Put these in the audit record's constants
			if ($audit->getFieldValue('audit_type') == 'EXPORTED' && $audit->getFieldValue('data1') == 'PATIENT_SUMMARY') {
				//TODO - The portal user's UID isn't stored anywhere.  The only thing I have to work with is the audit reason.  For
				//       now that reason will be "Export Requested by: [Portal User's Name]", but that may not always be the case.
				//       If the user ID in the audit log is ever changed to be a coded value, change this to use that value instead.
				$type = $audit->getFieldValue('data2');
				$reason = $audit->getFieldValue('reason');
				$userName = '[UNKNOWN USER]';
				if (strlen($reason) > 20 && strtolower(substr($reason, 0, 19)) == 'export requested by') {
					$userName = substr($reason, 21);
				}
				if ($type == AuditRecord::$VIEW_EXPORT_METHOD_NAME) {
					$reason = "Viewed";
				} else if ($type == AuditRecord::$DOWNLOAD_EXPORT_METHOD_NAME) {
					$reason = "Downloaded";
				} else if ($type == AuditRecord::$TRANSMIT_EXPORT_METHOD_NAME) {
					$reason = "Transmitted";
				} else if ($type == AuditRecord::$PRINT_EXPORT_METHOD_NAME) {
					$reason = "Printed";
				}
				$timestamp = strtotime($audit->getFieldValue('created_stamp'));
				$date = date('Y-m-d', $timestamp);
				$time = date('h:i:s a', $timestamp);
				echo "<div class=\"activityLogEntry\">$reason by $userName on $date at $time</div>";
			} //End if it's a patient summary export
		} //Next audit
	} //End if there's some history
	echo "<hr />\n";
} else {
	echo "<h4 class=\"error\">You can only access this page from the \"View Exam Summary\" page.</h4>";
}

?>