<?
require_once('includes/conf.php');
enforcedSessionStart();

require_once('includes/portalutils.php');
require_once('mobile_device_detect.php');
require_once(GLOBAL_INCLUDES_DIR . 'crystalLake/uitools.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/backend/axis/findopenslotsmessage.php');

if (defined('DEFAULT_TIME_ZONE')) {
    date_default_timezone_set(DEFAULT_TIME_ZONE);
}

//$isMobile = (isset($_SESSION['showMobile']) && $_SESSION['showMobile'] == 1);
$isMobile = mobile_device_detect(true,false,true,true,true,true,true);


//For now, just artificially fill the array of times
$startTime = strtotime('08:00');
$endTime = strtotime('18:10');

//Can't schedule less than 2 business days in advance (eg. can't schedule for Sat. on Fri, or Mon. on Sat.)
//$dayOfWeek will be 0 for Sunday, 1 for Monday, etc.
$dayOfWeek = date('w');
$daysToSkip = 2;
if ($dayOfWeek == 6) {
	//If it's Saturday, 2 "business days" means 3 days total, because Sunday isn't a business day.
	$daysToSkip = 3;
}
$minScheduleDate = strtotime(date('Y-m-d'));
$minScheduleDate = add_date($minScheduleDate, 0, 0, $daysToSkip);
$week = $_POST['week'];
$maxWeeks = $_POST['maxWeeks'];
if ($week < 0) {
	$week = 0;
}
$weekStart = add_date($minScheduleDate, 0, 0, 7 * $week);

$prevWeek = $weekStart;
$prevWeek = add_date($prevWeek, 0, 0, -7);
$nextWeek = $weekStart;
$nextWeek = add_date($nextWeek, 0, 0, 7);

//Calculate the number of 10 minute slots
$numSlots = ((date('H', $endTime) - date('H', $startTime)) * 6) + ((date('i', $endTime) - date('i', $startTime)) / 10);

$includeSundays = !$isMobile;
$fields = array('time');
$headers = array(' ');
$curDate = $weekStart;
for ($j = 0; $j < 7; $j++) {
	if ($includeSundays || !(date('w', $curDate) == 0)) {
		//Only add the date if not Sunday, or if we're including Sundays
		$fields[] = date('m/d/Y', $curDate);
		$weekdayFormat = ($isMobile ? 'D' : 'l');
		if ($isMobile) {
			//It leaves more space if we put the year on a new line
			$headers[] = date($weekdayFormat, $curDate) . "<br>" . date('m/d/<\b\r>Y', $curDate);
		} else {
			$headers[] = date($weekdayFormat, $curDate) . "<br>" . date('m/d/Y', $curDate);
		}
	}
	$curDate = add_date($curDate, 0, 0, 1);
}
//Subtract a day so curDate = the end date
$curDate = add_date($curDate, 0, 0, -1);

//Get the location for the number passed in, or the session's location if already set
  		$location = null;
  		$locationNumber = $_GET['loc'];
  		if ($locationNumber != null) {
  			if (strlen($locationNumber) == 32) {
  				//Assume it's a UID
                          	$location = getLocationByUID($locationNumber);
  			} else {
  				//Priority goes to $_GET['loc'], so location can be overridden even if already set
  				$location = getLocationByNumber($locationNumber);
  			}
  		} else if (isset($_SESSION['schedule_location']) && isset($_SESSION['schedule_location_db'])) {
  			//If $_GET['loc'] isn't set, it may be that they clicked a back link - see if loc is already set
  			$locationUID = $_SESSION['schedule_location'];
  			$locationDB = $_SESSION['schedule_location_db'];

  			$location = new Location($locationDB);
  			if (!$location->setFromFirstWhere('uid', $locationUID, '=', array($locationDB), true)) {
  				$location = null;
  			}
  		}

//Make sure a valid location is chosen
$providerUID = $_POST['provider'];
$locationUID = $_SESSION['schedule_location'];
$locationDB = $_SESSION['schedule_location_db'];
if ($locationUID == null || $locationDB == null) {
	if (sessionExpired()) {
		die("We're sorry, but your session has been idle too long and has expired.  You must come back here from the patient " .
				"portal's <a class=\"basicLink\" href=\"schedule_choose.php\">Schedule Appointment</a> page, or from the " .
				"<a class=\"basicLink\" href=\"https://www.webeca.com/locations/\">Find a Location</a> page.");
	} else {
		die("Cannot find appointments - No location chosen");
	}
}
//Select the appropriate axis server
/* $server = findAxisServerFor($locationDB);
//Make sure a server was found
if ($server == null) {
	die("Cannot find appointments - could not find the server.  Please refresh the page and try again.");
} */
$server = 'cec_axis';

//Find the open appointment slots
$msg = new FindOpenSlotsMessage($server);
try {
	if ($providerUID == null || $providerUID == '0') {
		$result = $msg->findOpenSlots(date('Y-m-dP', $weekStart), date('Y-m-dP', $curDate), $locationUID);
	} else {
		$result = $msg->findOpenSlots(date('Y-m-dP', $weekStart), date('Y-m-dP', $curDate), $locationUID, $providerUID);
	}
} catch (Exception $e) {
	die("The appointment schedule was temporarily unavailable.  Please <a class=\"basicLink\" " .
			"href=\"javascript:updateSchedule()\">Click here</a> to try again.  If this still " .
			"doesn't work, please wait a few minutes and then refresh the page.");
}

$openSlots = array();
if ($result != null && is_array($result)) {
	foreach ($result as $slot) {
		$date = date('m/d/Y', strtotime($slot->getFieldValue('date')));
		$time = date('H:i', strtotime($slot->getFieldValue('time')));
		if ($slot->isOpen() && $slot->getFieldValue('appType') == COMPREHENSIVE_APP_TYPE &&
				((!array_key_exists($date, $openSlots)) || (!array_key_exists($time, $openSlots[$date])))) {
			$openSlots[$date][$time] = $slot;
		}
	}
}

//Fill in the grid with open times
$times = array();
$showEmpty = true;
if ($result != null && is_array($result) && count($result) > 0) {
	//There is at least one empty slot this week
	$curTime = $startTime;
	for ($timeIndex = 0; $timeIndex < $numSlots; $timeIndex++) {
		$times[$timeIndex] = array('time'=>date('h:i A', $curTime));
		$militaryTime = date('H:i', $curTime);
		for ($dateIndex = 1; $dateIndex < count($fields); $dateIndex++) {
			$date = $fields[$dateIndex];
			$dayOfWeek = date('w', strtotime($date));
			if (array_key_exists($date, $openSlots) && array_key_exists($militaryTime, $openSlots[$date]) && $openSlots[$date][$militaryTime]->isOpen()) {
				$showEmpty = false;
				if ($isMobile) {
					//Don't include AM/PM in the links for mobile
					$time = date('h:i', $curTime);
				} else {
					$time = $times[$timeIndex]['time'];
				}
				$fxnTime = $date . " " . date('H:i', $curTime);
				$slot = $openSlots[$date][$militaryTime];
				$appType = $slot->getFieldValue('appType');
				$slotProvider = $slot->getFieldValue('provider');
				$template = $slot->getFieldValue('templateType');
				$times[$timeIndex][$date] = "<a class=\"scheduleLink\" href=\"javascript:chooseSlot('$fxnTime', '$appType', '$slotProvider', '$template')\">$time</a>";
			} else {
				$times[$timeIndex][$date] = "";
			}
		}
		$curTime = add_date($curTime, 0, 0, 0, 0, 10, 0);
	}
}
?>

<script type="text/javascript">
	function prevWeek() {
		currentWeek --;
		direction = -1;
		updateSchedule();
	}

	function nextWeek() {
		currentWeek++;
		direction = 1;
		updateSchedule();
	}

	function chooseSlot(timeStr, appType, provider, templateType) {
		$("#schedule_time").val(timeStr);
		$("#app_type").val(appType);
		$("#schedule_provider").val(provider);
		$("#template_type").val(templateType);
		$("#selected_provider").val('<? echo $providerUID; ?>');
		$("#timeForm").submit();
	}
</script>
<form id="timeForm" action="schedule_appointment.php" method="post">
	<input type="hidden" id="schedule_time" name="schedule_time" />
	<input type="hidden" id="app_type" name="app_type" />
	<input type="hidden" id="schedule_provider" name="schedule_provider" value="<? echo $_POST['provider']; ?>" />
	<input type="hidden" id="template_type" name="template_type" />
	<input type="hidden" id="selected_provider" name="selected_provider" />
</form>
<?
$maxScheduleDate = add_date($minScheduleDate, 0, 0, 7 * $maxWeeks);
?>
<p class="menuItem hide-from-mobile">You may schedule your eye exam for dates between <? echo date('l, F d, Y', $minScheduleDate); ?> and <? echo date('l, F d, Y', $maxScheduleDate); ?>. If you need to be seen more urgently please call your local office at 
	<span class="phonenum"><? echo $location->getFieldValue('phone1'); ?></span>.</p>

<!--<p class="menuItem hide-from-mobile">Note: Appointments cannot be scheduled online less than 2 business days ahead of time, or more
than < echo $maxWeeks; ?> weeks ahead of time.  The earliest date for which you can schedule online right now is
< echo date('l, F d, Y', $minScheduleDate); ?>, and the latest is < echo date('l, F d, Y', $maxScheduleDate); ?>.
If you need to schedule for a time outside of this date range, please call xxxxx.</p>-->
<p class="menuItem hide-from-desktop">If the appointment time you need isn’t available, please call us at <span class="phonenum"><? echo $location->getFieldValue('phone1'); ?></span> and we will try to accommodate you.</p>
<div id="schedule_wrapper" style="border-width: 2px; border-style: ridge; padding: 4px;">
	<table width="100%"><tr>
		<?
		if ($_POST['week'] > '0') {
			echo "<td width=\"200\"><span id=\"prevWeek\" onclick=\"prevWeek()\" style=\"cursor: pointer;\"><img src=\"/Imagess/left_arrow.png\" title=\"Previous Week\" /> Previous Week</span></td>";
		} else {
			echo "<td width=\"200\"><img src=\"/Imagess/left_arrow_disabled.png\" title=\"Can't schedule before this date\" /> Can't schedule before this date</td>";
		}
		?>
		<td align="center"><h3 align="center">Select a Time</h3></td>
		<?
		if ($_POST['week'] < $maxWeeks) {
			echo "<td align=\"right\" width=\"200\"><span id=\"nextWeek\" onclick=\"nextWeek()\" style=\"cursor: pointer;\">Next Week <img src=\"/Imagess/right_arrow.png\" title=\"Next Week\" /></span></td>";
		} else {
			echo "<td align=\"right\" width=\"200\">Can't schedule after this date <img src=\"/Imagess/right_arrow_disabled.png\" title=\"Can't schedule after this date\" /></td>";
		}
		?>
	</tr></table>

	<?

	if ($showEmpty) {
		echo "<p class=\"menuItem\" id=\"emptyScheduleInfo\">Sorry, there are no open appointments with the ".
				"selected location " . (($providerUID == null || $providerUID == '0') ? "" : "and doctor ") .
				"during the week of " . date('m/d/Y', $weekStart) . " to " . date('m/d/Y', $curDate) . ".</p>";
		if ($_POST['week'] >= $maxWeeks) {
			echo "<p class=\"menuItem\">This is the latest that you can schedule online.  If you would like to go back " .
					"to the latest open appointment times, please click on the \"Previous Week\" arrow.</p>";
		} else if ($_POST['week'] <= 0) {
			echo "<p class=\"menuItem\">This is the earliest that you can schedule online.  If you would like to go " .
					"forward to the earliest open appointment times, please click on the \"Next Week\" arrow.</p>";
		}
		echo "<p class=\"menuItem\">If our online scheduler can't find a time that works for you, please call " .
				"<span class=\"phonenum\">". $location->getFieldValue('phone1') . "</span> and we will help you to find a time that fits your schedule.</p>";
	} else {
		echo UITools::getArrayTable($times, $fields, $headers, array('class'=>'scheduleTable'), null, 'scheduleHeaderCol', null);
	}
	?>
</div>
<!-- Spacer -->
<div>&nbsp;</div>
<script
			  src="https://code.jquery.com/jquery-3.3.1.js"
			  integrity="sha256-2Kok7MbOyxpgUVvAk/HJ2jigOSYS2auK4Pfzbm7uH60="
			  crossorigin="anonymous"></script>
<script type="text/javascript">
$(document).ready(function(){

$(".phonenum").each(function() {
$(this).text(function(i, text) {
text = text.replace(/(\d\d\d)(\d\d\d)(\d\d\d\d)/, "($1) $2-$3");
return text;
});
	
var width = $(window).width();
	
	if (width >= 769) {
	
$( ".scheduleTable" ).find('tr:has(th)').wrapAll('<thead class="tablehead"></thead>'); 
$( ".scheduleTable" ).find('thead.tablehead').prependTo(".scheduleTable"); 
	

//$( ".scheduleTable tr:first-child" ).addClass( "first-row fixed" );
$( ".scheduleTable thead tr:first-child" ).addClass( "first-row" );
	
var cellwidth1 = $(".scheduleTable tbody").find("td:eq(0)").width();
var cellwidth2 = $("tr.first-row").find("th:eq(1)").width();
var cellwidth3 = $("tr.first-row").find("th:eq(2)").width();
var cellwidth4 = $("tr.first-row").find("th:eq(3)").width();
var cellwidth5 = $("tr.first-row").find("th:eq(4)").width();
var cellwidth6 = $("tr.first-row").find("th:eq(5)").width();
var cellwidth7 = $("tr.first-row").find("th:eq(6)").width();
var cellwidth8 = $("tr.first-row").find("th:eq(7)").width();
	
$("table.scheduleTable td:eq(1)").css("width",cellwidth2);
$("table.scheduleTable td:eq(2)").css("width",cellwidth3);
$("table.scheduleTable td:eq(3)").css("width",cellwidth4);
$("table.scheduleTable td:eq(4)").css("width",cellwidth5);
$("table.scheduleTable td:eq(5)").css("width",cellwidth6);
$("table.scheduleTable td:eq(6)").css("width",cellwidth7);
$("table.scheduleTable td:eq(7)").css("width",cellwidth8);
	
$("tr.first-row").find("th:eq(0)").css("width",cellwidth1);
		
		}
	
$( "tr td:first-child:contains('08:')" ).addClass( "single-digit-time" );
$( "tr td:first-child:contains('09:')" ).addClass( "single-digit-time" );
$( "tr td:first-child:contains('01:')" ).addClass( "single-digit-time" );
$( "tr td:first-child:contains('02:')" ).addClass( "single-digit-time" );
$( "tr td:first-child:contains('03:')" ).addClass( "single-digit-time" );
$( "tr td:first-child:contains('04:')" ).addClass( "single-digit-time" );
$( "tr td:first-child:contains('05:')" ).addClass( "single-digit-time" );
$( "tr td:first-child:contains('06:')" ).addClass( "single-digit-time" );
$( "tr td:first-child:contains('07:')" ).addClass( "single-digit-time" );

$( "td a.scheduleLink:contains('08:')" ).addClass( "single-digit-time" );
$( "td a.scheduleLink:contains('09:')" ).addClass( "single-digit-time" );
$( "td a.scheduleLink:contains('01:')" ).addClass( "single-digit-time" );
$( "td a.scheduleLink:contains('02:')" ).addClass( "single-digit-time" );
$( "td a.scheduleLink:contains('03:')" ).addClass( "single-digit-time" );
$( "td a.scheduleLink:contains('04:')" ).addClass( "single-digit-time" );
$( "td a.scheduleLink:contains('05:')" ).addClass( "single-digit-time" );
$( "td a.scheduleLink:contains('06:')" ).addClass( "single-digit-time" );
$( "td a.scheduleLink:contains('07:')" ).addClass( "single-digit-time" );

$("tr td:nth-child(2)").each(function() {
if($.trim($(this).html())=='') {
$(this).parent().addClass("twoblank");
}
});

$("tr td:nth-child(3)").each(function() {
if($.trim($(this).html())=='') {
$(this).parent().addClass("threeblank");
}
});

$("tr td:nth-child(4)").each(function() {
if($.trim($(this).html())=='') {
$(this).parent().addClass("fourblank");
}
});

$("tr td:nth-child(5)").each(function() {
if($.trim($(this).html())=='') {
$(this).parent().addClass("fiveblank");
}
});

$("tr td:nth-child(6)").each(function() {
if($.trim($(this).html())=='') {
$(this).parent().addClass("sixblank");
}
});

$("tr td:nth-child(7)").each(function() {
if($.trim($(this).html())=='') {
$(this).parent().addClass("sevenblank");
}
});

$("tr td:nth-child(8)").each(function() {
if($.trim($(this).html())=='') {
$(this).parent().addClass("eightblank");
}
});

var width = $(window).width();

if (width <= 768) {

//$( ".single-digit-time" ).each(function() {
//var val = $(this).html();
//$(this).html(val.substring(1, val.length));
//});

$( "tr.twoblank.threeblank.fourblank.fiveblank.sixblank.sevenblank" ).each(function() {
$(this).remove();
});

$('th:contains("Sunday")').each(function(){
$(this).html($(this).html().split("day").join(""));
});

$('th:contains("Monday")').each(function(){
$(this).html($(this).html().split("day").join(""));
});

$('th:contains("Tuesday")').each(function(){
$(this).html($(this).html().split("day").join(""));
});

$('th:contains("Wednesday")').each(function(){
$(this).html($(this).html().split("nesday").join(""));
});

$('th:contains("Thursday")').each(function(){
$(this).html($(this).html().split("sday").join(""));
});

$('th:contains("Friday")').each(function(){
$(this).html($(this).html().split("day").join(""));
});

$('th:contains("Saturday")').each(function(){
$(this).html($(this).html().split("urday").join(""));
});

//$('th span:contains("2016")').each(function(){
//$(this).html($(this).html().split("20").join(""));
//});

}

//if (width <= 670) {

//$("table.scheduleTable tr:first-child").clone().insertBefore("table.scheduleTable tr:nth-child(12)");

//}

})});
</script>
