<div id="block">
<?
require_once('includes/conf.php');
enforcedSessionStart();

require_once('secure_message.php');
require_once('includes/portalutils.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/phonenumberformatter.php');

$userMode = $_SESSION['userMode'];
$loggedIn = false;
$uid = "";
if ($userMode == PATIENT_MODE) {
	$patient = getPatient(false);
	$uid = $patient->getFieldValue('uid');
	$toUID = $uid;
	$loggedIn = ($patient != null && isLoggedIn($patient));
	//The toUID may not be the patients themselves; eg. it can be for a child.
	if ($_GET['toUID'] != null) {
		$toUID = $_GET['toUID'];
	} else if ($_POST['toUID'] != null) {
		$toUID = $_POST['toUID'];
	}
} else if ($userMode == EMPLOYEE_MODE) {
	$employee = getEmployee(false);
	$uid = $employee->getFieldValue('uid');
	$toUID = $uid;
	$loggedIn = ($employee != null && isEmployeeLoggedIn($employee));
}

$fullPage = $_GET['fullPage'];
if ($fullPage == null) {
	$fullPage = $_POST['fullPage'];
}
$id = $_GET['id'];
if (!isset($id)) {
	$id = $_POST['id'];
}
if ($fullPage) {
	//Printing full page - show the basic header stuff.
	$pageTitle = "Secure Message - EyeCare Associates Patient Portal";
	require_once("basic_head.php");
	$autoPrint = $_GET['autoPrint'];
	$autoPrintDetailed = $_GET['autoPrintDetailed'];
	if ($autoPrint == null) {
		$autoPrint = $_POST['autoPrint'];
	}
	if ($autoPrintDetailed == null) {
		$autoPrintDetailed = $_POST['autoPrintDetailed'];
	}
	//Whether normal auto-print or auto-print-detailed, do the same action on document.ready()
	if ((isset($autoPrint) && $autoPrint == 1) || (isset($autoPrintDetailed) && $autoPrintDetailed == 1)) {
		echo "
		<script type=\"text/javascript\">
			$(document).ready(function() {
				window.print();
			});
		</script>";
	}
}
if ($loggedIn) {
	if (!isset($id)) {
		//No ID set - the patient/employee came here via an unexpected process.
		$messagesLink = ($userMode == PATIENT_MODE ? "patient_messages.php" : "employee_messages.php");
		echo "Message ID not set.  You must come to this page from the <a href=\"$messagesLink\" class=\"basicLink\">secure messages page</a>.";
	} else {
		//Message ID set - load the message.
		try {
			$message = getSecureMessage($toUID, $id);
			if ($message->isFor($uid) || $userMode == EMPLOYEE_MODE || ($userMode == PATIENT_MODE && patientCanSeeMessage($patient, $message))) {
				//If we're auto-printing a detailed message, show some details above the message.
				if (isset($autoPrintDetailed) && $autoPrintDetailed == 1) {
					//The message is probably from a patient...
					$pat = new Patient(null);
					$pat->setFromFirstWhere('uid', $message->getFieldValue('fromUID'), '=', array($message->getBaseDB()));
					if ($pat->getFieldValue('uid') == null) {
						//But it could also be to a patient.
						$pat = new Patient(null);
						$pat->setFromFirstWhere('uid', $message->getFieldValue('toUID'), '=', array($message->getBaseDB()));
					}
					//Either from or to was a patient.  Add some of their basic details.
					if ($pat->getFieldValue('uid') != null) {
						$patDetails = array('Birthday' => $pat->getFieldValue('birthday'));
						if ($pat->getFieldValue('preferred_contact') != null) {
							$patDetails['Preferred Contact'] = $pat->getFieldValue('preferred_contact');
						}
						if ($pat->getFieldValue('email') != null) {
							$patDetails['Email'] = $pat->getFieldValue('email');
						}
						if ($pat->getFieldValue('preferred_phone') != null) {
							$patDetails['Preferred Phone'] = $pat->getFieldValue('preferred_phone');
						}
						$pnf = new PhoneNumberFormatter();
						if ($pat->getFieldValue('homephone') != null) {
							$patDetails['Home Phone'] = $pnf->format($pat->getFieldValue('homephone'));
						}
						if ($pat->getFieldValue('cell') != null) {
							$patDetails['Cell'] = $pnf->format($pat->getFieldValue('cell'));
						}
						echo getSecureMessageHTML($message, $toUID, !$fullPage, true, $patDetails);
					}
				} else {
					echo getSecureMessageHTML($message, $toUID, !$fullPage);
				}
			} else {
				$childMsg = ($userMode == PATIENT_MODE ? " or your children" : "");
				echo "This message is neither to nor from you$childMsg, and therefore you cannot view it.";
			}
		} catch (Exception $e) {
			echo "Error displaying the message.  Please try again.  The IT department has been informed of the issue and will work to resolve it as quickly as possible.";
		}
	}
} else {
	//Patient not logged in.
	echo "You are not logged in.  Please log into the portal before coming to this page.";
}

if ($fullPage) {
	//Printing full page - show the basic footer stuff.
	require_once("basic_foot.php");
}
?>
</div>