<?
session_start();

require_once(dirname(__FILE__) . '/../includes/includes.php');
require_once(dirname(__FILE__) . '/../includes/portalutils.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/backend/emrdatacenter/healthquery.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/backend/emrdatacenter/emrdatacenterresult.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/backend/emrdatacenter/patientlink.php');

$patient = getPatient();
$logged_in = isLoggedIn($patient);

if (!$logged_in) {
	$_SESSION['referral_page'] = $_SERVER['PHP_SELF'];
	header('location:login.php');
} else {
	$token = $_GET['token'];

	$query = new HealthQuery('Convert', $patient->getFieldValue('uid'));
	$query->setPayload(new PatientLink($patient->getFieldValue('uid'), $token));
	$results = $query->run();
	//echo 'CONVERT RESPONSE: ' . var_dump($results);
	
	$error = false;
	$resultHolder = EMRResultFactory::getSingleResult($results);
	$resultPayload = (isset($resultHolder) ? $resultHolder->getData() : null);
	
	if ((!isset($resultPayload)) || ($resultPayload instanceof InvalidElement)) {
		//The result was empty or an InvalidElement
		$error = true;
	} else {
		$db = $resultHolder->getDatabaseName();
		if ($query->wasResultError($db)) {
			//The result header was an error
			$error = true;
		}
	}
	
	if ($error) {
		header('location:link_failure.php');
	} else {
		$query = new HealthQuery('Link', $patient->getFieldValue('uid'));
		$query->setPayload($resultPayload);
		$results = $query->run();
		$linkResultHolder = EMRResultFactory::getSingleResult($results);
		if ((isset($linkResultHolder)) && $query->wasResultError($linkResultHolder->getDatabaseName())) {
			//The permanent token creation succeeded, but link either failed or didn't return any results
			header('location:link_failure.php');
		} else {
			//Linking succeeded
			$_SESSION['google_action']='link';
			header('location:link_with_google.php');
		}
	}
}

?>