<?
require_once('includes/conf.php');
enforcedSessionStart();


/**
 * Add a single list item to the main portal links
 */
function addListItem($url, $text) {
	$additionalClass = "";
	$idStr = "";
	if (strpos($_SERVER['PHP_SELF'], $url) !== false) {
		$additionalClass = "activeAccordionLink ";
		$idStr = " id=\"activeAccordionLink\"";
	}
	echo "<li class=\"block\"><a$idStr tabindex=\"0\" class=\"" . $additionalClass . "header\" href=\"$url\">$text</a></li>";
}

/**
 * Add all of the list items to the main portal links based on the page-specific options
 */
function addPortalMenu($subMenuName, $isLoggedIn, $whichPageNum, $allowToChoose, $includeLogin) {
	$blockHeaderText = "Patient Portal";
	if ($subMenuName == "schedule_menu") {
		$blockHeaderText .= " - Schedule";
	} else if ($subMenuName == "opt_out_menu") {
		$blockHeaderText = "E-mail Opt Out";
	} else if ($subMenuName != "portal_menu") {
		$blockHeaderText .= " - Bill Pay";
	}
	
	echo "<li class=\"block_header\"><a href=\"portal_main.php\">$blockHeaderText</a></li>";
	$logLink = ($isLoggedIn ? "logout.php" : "login.php");
	$logText = ($isLoggedIn ? "Log Out" : "Log In");
	
	if ($subMenuName == "portal_menu" || ($subMenuName == 'billpay_menu' && $whichPageNum === 1) ||
			($subMenuName == 'schedule_menu' && $whichPageNum === 0)) {
		//This should be the menu for all main pages, and just the first page of the bill pay or scheduler.
		addListItem("portal_main.php", "Home Page");
		addListItem("manage_account.php", "Account Settings");
		addListItem("choose_invoice.php", "Pay My Bills");
		addListItem("schedule_choose.php", "Schedule An Appointment");
		addListItem("patient_messages.php", "Secure Electronic Messages");
		addListItem("invoice_history.php", "Account History");
		addListItem("view_chart.php", "View Health Information");
		addListItem("rx_request.php", "Request Recent Prescriptions");
		addListItem("view_clinical_summary.php", "View Exam Summary");
		addListItem("education.php", "Patient Education");
	} else if ($subMenuName == "schedule_menu") {
		$pageToDisplay = ($allowToChoose ? "portal_main.php" : "login.php");
		addListItem("$pageToDisplay", "Portal Home");
		if ($whichPageNum >= 1) {
			$pageToDisplay = "schedule_start.php";
			addListItem($pageToDisplay, "Patient Details");
		}
		if ($whichPageNum >= 2) {
			addListItem("schedule_appointment.php", "Choose a Time");
		}
		if ($whichPageNum >= 3) {
			addListItem("review_schedule.php", "Review");
		}
	} else if ($subMenuName == "opt_out_menu") {
		//Include nothing - it has no links
	} else if ($subMenuName == "employee_menu") {
		addListItem("employee_portal_main.php", "Home");
		addListItem("employee_messages.php", "Secure Electronic Messages");
		if (!$isLoggedIn) {
			$logLink = "employee_login.php";
		}
	} else {
		$pageToDisplay = ($allowToChoose ? "portal_main.php" : "login.php");
		addListItem($pageToDisplay, "Portal Home");
		if ($whichPageNum >= 1) {
			$pageToDisplay = ($allowToChoose ? "choose_invoice.php" : "login.php");
			addListItem($pageToDisplay, "Choose Invoice");
		}
		if ($whichPageNum >= 2) {
			addListItem("billing_info.php", "Billing Info");
		}
		if ($whichPageNum >= 3) {
			addListItem("review.php", "Review");
		}
	}
	if ($includeLogin) {
		addListItem($logLink, $logText);
	}
}

/* if (!strpos($_SERVER['PHP_SELF'], 'temporarilyDown')) {
	header('location:temporarilyDown.php');
} */

require_once('mobile_device_detect.php');
/*
//Only show mobile version if on a mobile device and 'showMobile' variable is set
if (isset($_GET['showMobile'])) {
	$_SESSION['showMobile'] = $_GET['showMobile'];
}
$isMobile = (isset($_SESSION['showMobile']) && $_SESSION['showMobile'] == 1);
$isMobile = $isMobile && mobile_device_detect(true,false,true,true,true,true,true); */
//Always show mobile version if on a mobile device
$isMobile = mobile_device_detect(true,false,true,true,true,true,true);
if (isset($_GET['showMobile'])) {
	$isMobile = $isMobile || $_GET['showMobile'];
}

//By default, start the timeout process on page load.
if (!isset($initializeTimeout)) {
	$initializeTimeout = true;
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1" />
	<title><? echo $curtitle; ?></title>

	<meta name="Description" content="EyeCare Associates Patient Portal" />
	<meta name="Keywords" content="EyeCare Associates keywords to come" />
	<link href="../css/eca_main2.css" rel="stylesheet" type="text/css" />
	<link href="../css/eca_navmenu2.css" rel="stylesheet" type="text/css" />
	<link href='https://fonts.googleapis.com/css?family=Open+Sans:400,400italic,700,700italic' rel='stylesheet' type='text/css' />
	<link href='https://fonts.googleapis.com/css?family=Open+Sans+Condensed:700,300' rel='stylesheet' type='text/css' />
<? 
//include "config.php"; 
//include "environment.php";
include "scripts.php";
if (!$isMobile) {
	//Main desktop styles
	include "style.php";
} else {
	//Main mobile styles
	include "style_mobile.php";
}

//Find out if user is logged in (based on either $logged_in or, if that is unset, whether or not patient is set).
$isLoggedIn = $logged_in;
if (!isset($logged_in)) {
	if ($_SESSION['userMode'] == PATIENT_MODE) {
		$isLoggedIn = isset($_SESSION['patient']);
	} else if ($_SESSION['userMode'] == EMPLOYEE_MODE) {
		$isLoggedIn = isset($_SESSION['employee']);
	}
}
?>
<!-- Don't let iOS' Safari shrink the whole page to fit - it makes many pages unreasonably tiny -->
<?
if ($fixedSize) {
	echo '<meta name="viewport" content="width=device-width, initial-scale=1, minimum-scale=1, maximum-scale=1, user-scalable=0"/>';
} else {
	echo '<meta name="viewport" content="width=device-width, initial-scale=1, minimum-scale=1, user-scalable=1"/>';
}
?>
<?
if (!$isMobile) {
	//Desktop styles:
?>
	<!-- <link href="/css/nsWork.css" type="text/css" rel="stylesheet" /> -->
	<link rel="stylesheet" type="text/css" href="/css/gateway.css" />
<?
} else {
	//Mobile styles:
?>
	<link rel="stylesheet" type="text/css" href="/css/gateway_mobile.css" />
<?
}
?>
<link rel="shortcut icon" type="image/icon" href="/Images/favicon.ico" />
<link rel="stylesheet" type="text/css" href="/css/overlay.css" />
<link rel="stylesheet" type="text/css" href="/css/secure_messages.css" />

<script src="/Scripts/jquery-1.7.2.min.js" type="text/javascript"></script>
<!-- ========== Start Code Canyon: Accordion ========== -->
        <link href="/css/ts_accordion.css" rel="stylesheet" type="text/css" />
        <link href="/css/ts_accordion_bluestyle.css" rel="stylesheet" type="text/css" />
        <!-- ========== IE FIX ========== -->
        
                <!-- ========== IE6-8 TARGET FALLBACK ========== -->
                <script type="text/javascript" src="/Scripts/jquery.accordion_1.6.1.min.js"></script>
                <!--[if (gte IE 6)&(lte IE 8)]>
                <script type="text/javascript" src="/Scripts/ie-target.js"></script>
                <script type="text/javascript" src="/Scripts/selectivizr-min.js"></script>
				<![endif]-->
<!-- ========== End Code Canyon: Accordion ========== -->
<!-- Network Solutions seal script -->
<!-- This takes forever to load... just leave it commented here, but uncommented in the live version -->
<!-- <script language="JavaScript" src="https://seal.networksolutions.com/siteseal/javascript/siteseal.js" type="text/javascript"></script> -->
<script src="/Scripts/jquery.tools.min.js" type="text/javascript"></script>
<script src="/Scripts/date.format.js" type="text/javascript"></script>
<script src="/Scripts/UniversalScripts.js" type="text/javascript"></script>
<script src="/Scripts/messageScripts.js" type="text/javascript"></script>
<script type="text/javascript">
	$(window).load(function() {
		$("a, button, input, textarea, [tabindex]").focus(function() {
			//Whenever any focusable item is focused, clear all currently focused items
			$('ul#navmenu li').removeClass('focused');
			$('.top_links').removeClass('focused');
			$('#top_appointment').removeClass('focused');
			$('div.radio_container').removeClass('focused');
		});
		//When a nav menu item is focused, show hierarchy as necessary.
		$('ul#navmenu a').focus(function() {
			//Clear all currently focused items
			$('ul#navmenu li').removeClass('focused');
			//Focus on all "li" elements up the hierarchy.
			$(this).parents("li").addClass('focused');
		});
		//When a top link is focused, highlight it as such
		$('.top_links').parent('a').focus(function() {
			$(this).children().addClass('focused');
		});
		//When the top appointment link is focused, highlight it as such
		$('#top_appointment').parent('a').focus(function() {
			$(this).children().addClass('focused');
		});
		$('input[type="radio"]').focus(function() {
			$(this).parents('div.radio_container').addClass('focused');
		});
		<?
		if ($initializeTimeout) {
			echo "initializeDefaultTimeout();\r\n";
		}
		//Mobile has to initialize another set of events
		if ($isMobile) {
		?>
			$('#portalMenuToggle').mousedown(function() {
				if ($('#mainPortalMenuWrapper').hasClass('visibleMenu')) {
					$('#mainPortalMenuWrapper').slideUp(500);
				} else {
					$('#mainPortalMenuWrapper').slideDown(500);
				}
				$('#mainPortalMenuWrapper').toggleClass('visibleMenu');
			});
		<?
		}
		?>
	});
	
	/*
	 * Initialize the session timeout based on system defaults.
	 */
	function initializeDefaultTimeout() {
		//Check every 30 seconds, and warn the user if time left before timeout reaches below one minute.
		initializeTimeout(<?
			//Use gc_maxlifetime as the default.  That param is in seconds, so convert to millis first.
			//Allow 60 seconds in case the page takes a long time to load, plus the 60 second grace period.
			echo ((ini_get('session.gc_maxlifetime') - 120) * 1000);
		?>, 30000, 60000);
	}
</script>
</head>

<body>
<!-- Google Tag Manager (noscript) -->
<noscript><iframe src="https://www.googletagmanager.com/ns.html?id=GTM-WVTK8QH"
height="0" width="0" style="display:none;visibility:hidden"></iframe></noscript>
<!-- End Google Tag Manager (noscript) -->
<div id="waitOverlay" class="simple_overlay modal"></div>
<div id="altWaitOverlay" class="simple_overlay modal"></div>
<noscript><div id="noScriptHeader">JavaScript is disabled in your browser.  This site requires JavaScript in order to perform as expected.</div></noscript>
<div id="skipToContent"><a id="skipToContentLink" href="#mainContent" tabindex="1">Skip to Content</a></div>
<?
if ($isMobile) {
	//For now, the mobile version is really simple
	echo '<div id="mainDiv" align="center" style="padding: 8px;">';
	if ($logged_in || $isLoggedIn) {
		/* if (!$isPortalMain) {
			echo '<div style="float: left; margin-bottom: 8px;"><a class="bigLink" href="portal_main.php">Back To Portal Home</a></div>';
		} */
		
		echo '<div style="float: right; margin-bottom: 8px;"><a class="bigLink" href="logout.php">[Log Out]</a></div>';
		echo "<div id=\"portalMenuToggleWrapperWrapper\" style=\"clear: both;\"><div id=\"portalMenuToggleWrapper\"><a id=\"portalMenuToggle\" href=\"#\"><img src=\"/Images/menu_toggle_icon.png\" style=\"border: none;\" /></a></div>\n";
		echo "<div id=\"mainPortalMenuWrapper\"><ul id=\"mainPortalMenu\">\n";
		addPortalMenu($subMenuName, $isLoggedIn, $whichPageNum, $allowToChoose, $includeLogin);
		echo "</ul></div></div>\n";
	} else if (!$isPortalMain) {
		echo '<div align="center"><a class="bigLink" href="portal_main.php">Back To Portal Home</a></div>';
	}
	echo '<div style="clear: both;" id="content" align="left">';
} else {
?>
	<div id="maincontainer">
	
	<div id="toplogo"><a href="http://www.webeca.com" target="_self">
		<img src="/Imagess/eca-logo.png" alt="EyeCare Associates Home" width="406" height="120" />
	</a></div>
	
	<div id="outertopwrapper">
		<div id="topwrapper">
			
		</div>
	</div>

	<div id="navbar">
	<ul id="navmenu">
	<li><a href="#">Schedule an<br/>Appointment</a></li>
	<li><a href="#" >My Account<br />Settings</a>
		<ul>
				<li><a href="#">Account Settings</a> </li>
				<li><a href="#">My Information</a></li>
				<li><a href="#">Others on My Account</a> </li>
				<li><a href="#">Management Team</a> </li>
				<li><a href="#">Billing</a> </li>
				
		</ul>       
	</li>
	<!-- ==================================== -->
	<li><a href="#" >Pay My<br/>Bill Online</a>
		<ul>
			<li><a href="#">View Invoice to Pay</a></li>                          
				<li><a href="#">Payment History</a></li>
		</ul>
	</li>
	<!-- ==================================== -->
	<li><a href="#">My<br/>Inbox</a> </li>
	<!-- ==================================== -->        
	<li><a href="#" >My<br/>Charge</a>
		<ul>
			<li><a href="#">Visit Last Visit Summary</a></li>
			<li><a href="#">My Recent Rx</a></li>
			<li><a href="#">Download</a></li>  
            <li><a href="#">Transmit</a></li>                          
		</ul>        
	</li>
	<!-- ==================================== -->       
	<li><a href="#">Patient<br/>Education</a></li>   
		
	<!-- ==================================== -->  
	<li><a href="#">Portal<br/>Home</a>	</li>
			       
	<!-- ==================================== -->          
	
	<!-- ==================================== -->  
	
	<!-- ==================================== -->    
	
	<!-- ==================================== --> 
	</ul>

	<!-- #EndLibraryItem --></div>
	<!-- Closing Div: navbar -->

	<div id="bluerule"></div>
	<div class="spacer"><!-- spacer --></div>
	<div id="bottomwrapper-int">
		<div class="ew_leftcolumn">
			<!-- css3 accordion -->
			<div class="qlabs_accordion">
				<!--accordion-->
				<ul>
					
					<!-- Portal Menu -->
					
					<?
					//Add the portal menu list items here.
					addPortalMenu($subMenuName, $isLoggedIn, $whichPageNum, $allowToChoose, $includeLogin);
					?>
				</ul>
			</div>
		</div>
		<div style="left: -2000px;">
			<a id="mainContent" name="mainContent" tabindex="0"></a>
		</div>
		<script type="text/javascript">
			var isWebkit = navigator.userAgent.toLowerCase().indexOf('webkit') > -1;
			var isOpera = navigator.userAgent.toLowerCase().indexOf('opera') > -1;
			if(isWebkit || isOpera) { 
				var target = document.getElementById('mainContent');
				target.href="#mainContent";
				//target.innerText="Start of main content";
				target.setAttribute("tabindex" , "0"); 
				document.getElementById('skipToContentLink').setAttribute("onclick" , "document.getElementById('mainContent').focus();");
			}
		</script>
		<div class="ew_container">
			<div id="welcomeContainer">
				<?
					//Show different images based on top menu - this converts from old flash choices to new image-based choices
					if ($topMenu == 'insurancetop.swf') {
						echo "<img src=\"/Images/portal-payment-top.png\" alt=\"Welcome to the EyeCare Associates Patient Portal\" style=\"border-style:none; width: 852px; height: 202px;\" />";
					} else {
						echo "<img src=\"/Images/patient-portal.png\" alt=\"Welcome to the EyeCare Associates Patient Portal\" style=\"border-style:none; width: 852px; height: 202px;\" />";
					}
				?>
			</div>
<?
} //End if not on a mobile device
?>
