<?

require_once(GLOBAL_INCLUDES_DIR . '/springfield/formatters/dateformatter.php');
require_once(GLOBAL_INCLUDES_DIR . '/springfield/formatters/phonenumberformatter.php');

function formatPatientField($pat, $fieldName) {
	$fieldValue = $pat->getFieldValue($fieldName);
	if ($fieldName == 'birthday') {
		$dateFormatter = new DateFormatter('m/d/Y');
		return $dateFormatter->format(strtotime($fieldValue));
	} else if ($fieldName == 'homephone' || $fieldName == 'cell' || $fieldName == 'workphone') {
		$phoneFormatter = new PhoneNumberFormatter();
		return $phoneFormatter->format($fieldValue);
	} else {
		//No formatter necessary - just get the field value
		return $fieldValue;
	}
}

/**
 * Returns whether or not any fields in the map starting with $prefix have "X" as their value.
 * Useful for figuring out if the user actually chose any values for check box fields.
 */
function hasAnyXs($map, $prefix) {
	foreach ($map as $field => $value) {
		if ($value == 'X' && strpos($field, $prefix) === 0) {
			return true;
		}
	}
	return false;
}

function setWelcomeSheetRace($map, $raceStr) {
	$races = ($raceStr == null ? null : explode(',', $raceStr));
	if ($races != null) {
		foreach ($races as $race) {
			$race = str_replace(' ', '_', $race);
			$map["patient__race_$race"] = "X";
		}
	}
	return $map;
}

function setWelcomeSheetEthnicity($map, $ethnicityStr) {
	$ethnicities = ($ethnicityStr == null ? null : explode(',', $ethnicityStr));
	if ($ethnicities != null) {
		foreach ($ethnicities as $ethnicity) {
			$ethnicity = str_replace(' ', '_', $ethnicity);
			$map["patient__ethnicity_$ethnicity"] = "X";
		}
	}
	return $map;
}

function setWelcomeSheetSmokingStatus($map, $smokingStatus) {
	if ($smokingStatus != null) {
		$map["patient__SmokingStatus$smokingStatus"] = "X";
	}
	return $map;
}

function setWelcomeSheetMarried($map, $married) {
	if ($married != null) {
		$map["patient__married_$married"] = "X";
	}
	return $map;
}

function addHistory($map, $propertyPrefix, $conditionsStr) {
	if ($conditionsStr == null || $conditionsStr == '') {
		//If no conditions, we can't add anything
		return $map;
	}
	$conditions = explode(',', $conditionsStr);
	foreach ($conditions as $conditionUID) {
		$map[$propertyPrefix . $conditionUID] = 'X';
	}
	return $map;
}

?>