<?
require_once('includes/conf.php');
enforcedSessionStart();

require_once('includes/includes.php');
require_once('includes/portalutils.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/fullnameformatter.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/dateformatter.php');
require_once(GLOBAL_INCLUDES_DIR . 'crystalLake/uitools.php');

$mainPatient = getPatient();

if ($mainPatient != null) {
	$logged_in = isLoggedIn($mainPatient);

	//The user must be logged in to access this page
	if (!$logged_in) {
		$_SESSION['referral_page'] = $_SERVER['PHP_SELF'];
		header("location:login.php");
	} else {
		$fnf = new FullNameFormatter(null, false);
		$df = new DateFormatter('m/d/Y');
		
		$drawArrow = false;
		//Include the header info
		$title='EyeCare Associates - View Invoice History';
		include("template.php");
		
		$subMenu = "portal_menu.jpg";
		include("head.php");
		$curDate = date('m/d/Y');
		
		$patients = getAllUnderAccount($mainPatient);
		$patientMap = array();
		$num = 0;
		$invoices = array();
		echo "<script type=\"text/javascript\">\n";
		echo "	var dates = new Array();\n";
		echo "	var invoice_patient = new Array();\n";
		echo "	var patients = new Array();\n";
		echo "	var user = '" . $mainPatient->getFieldValue('uid') . "';\n";
		foreach ($patients as $patient) {
			$uid = $patient->getFieldValue('uid');
			$patientMap[$uid] = $patient;
			$dpls = getSuperbillsForPatient($patient);
			echo "	patients.push('$uid');";
			//Loop through each superbill and show relevant ones
			foreach ($dpls as $dpl) {
				$superbill = new Superbill($dpl->getDatabaseName());
				$superbill->load($dpl->getFieldValue('superbill'));
				
				$invoices[$uid][] = "<div id=\"box_$num\" class=\"invoice\">" . UITools::getExpandableBox($superbill->getSalesLogTable(),
							"oldInvoiceTable_$num", "Invoice #" . $superbill->getSuperbillNumber() . ":", 'orange') .
							$superbill->getDateAndBalanceHTML() . "</div>";
				echo "	dates[$num] = '" . $df->format($superbill->getDPL()->getFieldValue('date')) . "';\n";
				echo "	invoice_patient[$num] = '" . $patient->getFieldValue('uid') . "';\n";
				$num++;
			} //end foreach dpl
		} //end foreach patient
		echo "</script>\n";
		?>
		<script type="text/javascript" src="/Scripts/filterInvoices.js"></script>
		<script type="text/javascript">
			function showInvoiceDialog() {
				showInvoices(getStartDate(), getEndDate(), showKids());
			}
		</script>
		<h1>Invoice History</h1>
		<h3 class="orange">Filter Invoices</h3>
		<p>To view or print a single invoice or a series of invoices over the course of a particular time frame, simply type in a Start Date and End Date and hit Enter.</p>
		<form id="filterForm">
		  <p>
				Start Date: <input id="start_date" type="text" onkeyup="filterInvoices()" size="12" maxlength="10" /> &nbsp;
				End Date: <input id="end_date" type="text" onkeyup="filterInvoices()" value="<? echo $curDate; ?>" size="12" maxlength="10" />
			</p>
			<?
			if (count($patients) > 1) {
				echo "<p><input id='show_kids' type='checkbox' checked='checked' onchange='filterInvoices()' /> Show all invoices associated with this account</p>";
			}
			?>
		</form>
		<h3><a class="basicLink" href="javascript:showInvoiceDialog();">Print This History</a></h3>
		
		<?
		//Now show the invoices (stored as HTML)
		foreach ($invoices as $patUID=>$patInvoices) {
			echo "<div id=\"invoices_for_$patUID\">";
			echo "<h2>For patient: " . $fnf->format($patientMap[$patUID]) . "</h2>";
			foreach ($patInvoices as $invoiceHTML) {
				echo $invoiceHTML . "\n";
			}
			echo "</div>";
		}
		
		echo "<br>\n";
		include "foot.php";
	} //end if is logged in
} //end if patient != null
?>