<?
require_once('includes/conf.php');
enforcedSessionStart();

require_once('includes/includes.php');
require_once('includes/portalutils.php');

$success = (isset($_SESSION['invoice_success']) && $_SESSION['invoice_success']);
unset($_SESSION['invoice_success']);

//Check that a patient has logged in (or at least chosen a superbill)
$patient = getPatient();

//Check that a superbill has been selected
$superbill = getSuperbill();

$logged_in = isset($patient) && isset($superbill) && isset($_SESSION['secure_cc_display']);

if (!$logged_in) {
	header('location:billing_info.php');
} else if ((!$success) || (!userCanSeeSuperbill($patient, $superbill))) {
	//Latter part of this if statement (verification that patient has this superbill's permissions)
	//shouldn't be possible if success is set, but have it just in case
	header('location:choose_invoice.php');
} else {
	//User is logged in, and they just had a successful invoice attempt
	$drawArrow = false;

	//Include the header info
	$title='EyeCare Associates - Receipt for Invoice #' . $superbill->getSuperbillNumber() . ')';
	include("template.php");
	
	$topMenu = "insurancetop.swf";
	$topMenuName = "insurancetop";
	$subMenu = "billpay_menu.jpg";
	$subMenuName = "billpay_menu";
	$allowToChoose = isLoggedIn($patient);
	$whichPageNum = 2; //same as billing_info - can't go back to billing_info or review, only to choose_invoice.
	include("head.php");

	//Set the billing info defaults array based on either previously set billing info or the patient's array
	if (isset($_SESSION['billto'])) {
		$billingArray = $_SESSION['billto'];
	} else {
		$billingArray = $patient->getFields(array('firstname', 'lastname', 'address', 'city', 'state', 'zip', 'homephone'));
	}
?>
	<h1>Payment Successful</h1>
	<div class="success">Your payment was received by EyeCare Associates, and is being processed. A copy of this receipt was
		sent to the email address specified. You may also print a copy of this receipt for your records
		<a class="basicLink" href="javascript:printreceipt();">(Printer Friendly Page)</a>.</div>
<?
	$allowToChange = false;
	$completed = true;
	$amount = $_SESSION['amount_paid'];
	include('invoice_summary.php');
?>
	<br>
<?
	include("foot.php");
} //end if logged in and successful
?>