<?
//******************** This file requires the following variables to be set: ********************
// * $superbill - the superbill to display
// * $creditcard - A CreditCard object representing the currently chosen card (optional)
// * $billingArray - the array of billing info (must include firstname, lastname, address,
//                   city, state, zip, and homephone
// * $completed - Whether or not the billing has been completed at this point
// * $allowToChange - (optional, default !$completed); Whether or not to allow the user to go
//                    back to billing_info.php to set their billing info
// * $amount - (optional, default superbill balance); The amount paid just now on the superbill
//***********************************************************************************************
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/currencyformatter.php');

if (!isset($allowToChange)) {
	$allowToChange = !$completed;
}

$totals = $superbill->total();
$patBalance = $totals['PAT_BALANCE'];
$currencyFormatter = new CurrencyFormatter();
if (!isset($amount)) {
	$amount = $patBalance;
}

?>

<h1>Invoice #<? echo $superbill->getSuperbillNumber(); ?>:</h1>
<?
echo "\n" . $superbill->getSalesLogTable() . "\n";
echo $superbill->getDateAndBalanceHTML();
?>
<!-- <div class="billBalance">Patient Balance: <? echo $currencyFormatter->format($patBalance); ?></div> -->

<?
if ((!$completed) && ($patBalance < 0.01 || $superbill->codeExists(SalesLog::$COLLECTIONS_CODE))) {
	if ($superbill->codeExists(SalesLog::$COLLECTIONS_CODE)) {
		$note = Superbill::$COLLECTIONS_STRING;
	} else {
		$note = "This invoice has no balance due";
	}
	echo "<div class=\"returnInfo\"><h2 class=\"orange\">" . $note . "</h2>\n";
	echo "<a href=\"choose_invoice.php\">Click Here</a> to return to the invoice select screen</div>\n";
} else if ($completed && ($patBalance >= 0.01 || $superbill->codeExists(SalesLog::$COLLECTIONS_CODE))) {
	echo "<div class=\"returnInfo\"><h2 class=\"orange\">";
	if ($superbill->codeExists(SalesLog::$COLLECTIONS_CODE)) {
		echo Superbill::$COLLECTIONS_STRING . "</h2>\n";
		echo "<a href=\"choose_invoice.php\">Click Here</a> to return to the invoice select screen</div>\n";
	} else {
		echo "This invoice still has balance due.</h2>\n";
		echo "<a href=\"billing_info.php\">Click Here</a> to pay this bill</div>\n";
	}
} else {
	//Only show the rest of the page if there is balance and should be, or isn't balance and shouldn't be
?>
	<div class="returnInfo" style="text-align: left;">
		<h3 class="orange">Bill to Information <? if ($allowToChange) echo "| <a href=\"billing_info.php\">change</a>" ; ?></h3>
		<?
		echo strtoupper($billingArray['firstname']).' '.strtoupper($billingArray['lastname']).'<br />';
		echo strtoupper($billingArray['address']).'<br />';
		echo strtoupper($billingArray['city']).', '.strtoupper($billingArray['state']).' '.strtoupper($billingArray['zip']).'<br />';
		echo strtoupper($billingArray['homephone']).'<br />';
		?>
	</div>
	
	<!-- *********************************************** Credit Card Info *********************************************** -->
	<?
	if ($allowToChange) {
		//If allowing the user to change credit card info, display a form with that info
	?>
		<div class="returnInfo" style="text-align: left;">
			<h3 class="orange">Credit Card Information</h3>
			<table width="520" border="0">
				<tr>
					<td width="80" height="29"><div align="right">Card Type </div></td>
					<td width="150"><label>
						<?
							//Find card type - default to visa
							$type = 'visa';
							if (isset($creditcard) && $creditcard->hasValue()) {
								//if a credit card was set before, get the old values back.
								$type = strtolower($creditcard->getType());
							}
							echo UITools::getArrayComboBox(array('visa'=>'Visa', 'mastercard'=>'MasterCard', 'discover'=>'Discover'/*,
									'amex'=>'American Express'*/), $type, array('name'=>'cardtype', 'id'=>'cardtype'));
						?>
					</label></td>
					<td width="110"><div align="right">Card Number </div></td>
					<td width="180"><label>
						<input name="ccnumber" id="ccnumber" type="text" size="22" maxlength="16" />
					</label></td>
				</tr>
				<tr>
					<td><div align="right">Exp. Date </div></td>
					<td>
						<label>
						<?
							//Get an array of months
							$months = array();
							$months[""] = "Month";
							for ($i=1; $i<=12; $i++) {
								$monthStr = str_pad(strval($i), 2, '0', STR_PAD_LEFT);
								$fullMonthStr = date('m - M', mktime(0, 0, 0, $monthStr, 1, date('Y')));
								$months[$monthStr] = $fullMonthStr;
							}
							//Figure out which month to select
							$selected = ((isset($creditcard) && $creditcard->hasValue()) ? $creditcard->getMonth() : "");
							
							//Create and display the expiration month box
							echo UITools::getArrayComboBox($months, $selected, array('name'=>'expmonth', 'id'=>'expmonth'));
						?>
						</label>
						<label>
							<!-- <option selected="selected" value="">Year</option> -->
							<?
								$years = array();
								$years[""] = "Year";
								for ($i = date('Y'); $i <= date('Y')+10; $i++) {
									$years[$i] = $i;
								}
								$selected = ((isset($creditcard) && $creditcard->hasValue()) ? $creditcard->getYear() : "");
								echo UITools::getArrayComboBox($years, $selected, array('name'=>'expyear', 'id'=>'expyear'));
							?>
						<!-- </select> --></label>
					</td>
					<td><div align="right">Name on Card </div></td>
					<td>
					<?php
						//if a credit card was set before, get the old values back.
						if (isset($creditcard)) {
							echo '<input name="cardname" id="cardname" type="text" size="22" value="'.$creditcard->getName().'" / >';
						} else {
							echo '<input name="cardname" id="cardname" type="text" size="22" />';
						}
					?>
					</td>
				</tr>
			<?
			if ($errorFlag) {
				echo '<tr><td>&nbsp;</td><td width="400px" colspan="3" class="error">Please enter valid credit card information</td></tr>';
			}
			?>
			</table>
		</div>
	<?
	} //End if allow to change
	?>
	<div class="returnInfo" style="text-align: left;">
		<h3 class="orange">Payment Information</h3>
		<? echo ($allowToChange ? "" : "Card Number: " . $_SESSION['secure_cc_display'].'<br />');
		   echo ($completed ? "Total charged to card: " : "Total to be charged to card: ");
		   echo $currencyFormatter->format($amount); ?> <br />
	</div>
<?	
} //end if balance != 0
?>