<?
session_start();

require_once('includes/portalutils.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/invalidelement.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/backend/emrdatacenter/healthquery.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/backend/emrdatacenter/emrdatacenterresult.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/backend/emrdatacenter/emrresultfactory.php');

//Make sure patient is logged in first
$patient = getPatient();
$logged_in = isLoggedIn($patient);

if (!$logged_in) {
	$_SESSION['referral_page'] = $_SERVER['PHP_SELF'];
	header('location:login.php');
} else {
	//Include the header info
	$title='EyeCare Associates - Link Account with Google Health';
	include("template.php");
	
	$drawArrow = false;
	$subMenu = "portal_menu.jpg";
	include("head.php");
	
	$msg = null;
	if (isset($_SESSION['google_action'])) {
		switch ($_SESSION['google_action']) {
			case 'link':
				$msg = 'Your EyeCare Associates account has been successfully linked with your Google Health account!
				       You may now use the tools below to send/receive data between these accounts. Alternately, you
					   can <a class="basicLink boldLink" href="https://health.google.com/health/directory?cat=importrecords">
					   Go back to Google Health</a>';
				break;
			case 'unlink':
				$msg = 'Your EyeCare Associates account has been successfully unlinked with your Google Health ' .
				       'account. You can no longer use these tools until you link the accounts again.';
				break;
			case 'upload':
				$msg = 'EyeCare Associates records have been successfully uploaded to Google Health!';
				break;
			case 'download':
				$msg = 'Records have been successfully downloaded from Google Health into your EyeCare Associates account!';
				break;
		}
		unset($_SESSION['google_action']);
	}
	
	$patientLink = getPatientLink($patient);
	$linked = isset($patientLink) && (!($patientLink instanceof InvalidElement));
	
	if (isset($msg)) {
		echo "<script type=\"text/javascript\">
				function hideMessage() {
					$('#googleMessage').slideUp('fast');
				}
		      </script>
		      <div id=\"googleMessage\">
                <div id=\"googleInfo\"><h3 class=\"googleSuccess\">$msg</h3></div>
                <a class=\"basicLink\" href=\"javascript:hideMessage()\">^ Hide Message ^</a>
              </div>";
	}
?>
	<div style="text-align: right;"><a href="https://health.google.com/health/p/">
		<img src="/Images/google_health_in_box.gif" alt="Google Health" style="border-style: none;" />
	</a></div>
	
<?	if (!$linked) {
		$googleURL = "https://www.google.com/h9/authsub?scope=" . urlencode("https://www.google.com/h9/feeds/") .
		             "&secure=1&session=1&permission=1&next=" . urlencode("https://www.webeca.com/portal/google_target.php");
?>
		<!-- Show info that is displayed when account IS NOT already linked -->
		<h1>Link Account With Google Health</h1>
		<h2 class="orange">Link Accounts</h2>
		<h3>What does this service do for me?</h3>
		<p>
			If you link your EyeCare Associates patient account with a Google Health account, you can share your health information
			with other participating health providers and pharmacies, as well as keep track of your prescription history and other
			medical records that you have on file. You have complete control over when records are sent between EyeCare Associates
			and Google Health, and we won't send/receive any information without your permission. Please view our
			<a class="basicLink" href="javascript:openPrivacy();">privacy policy</a> for more information about how we use your
			medical records.
		</p>
		<p class="basicMedium">
			<a class="basicLink boldLink" href="<? echo $googleURL; ?>">Click Here</a> to link this account with your Google Health account
			(this allows you to send and receive data between your EyeCare Associates account and your Google Health account)
		</p>
<?	} else { ?>
		<!-- Show info that is displayed when account IS already linked -->
		<h1>Exchange Records With Google Health</h1>
		<h2 class="orange">Download Data</h2>
		<p class="basicMedium">
			<a class="basicLink boldLink" href="google_download.php">Click Here</a> to download patient records from your
			Google Health account to your EyeCare Associates account.
		</p>
		<h2 class="orange">Upload Data</h2>
		<p class="basicMedium">
			<a class="basicLink boldLink" href="google_upload.php">Click Here</a> to upload patient records from EyeCare Associates to your Google Health account.
		</p>
		<h2 class="orange">Unlink from Google Health</h2>
		<p class="basicMedium">
			<a class="basicLink boldLink" href="google_unlink.php">Click Here</a> to unlink your EyeCare Associates and
		    Google Health accounts, so that data can no longer be shared between them.
			
			<div class="smallItem">Note: If you unlink your accounts, they can be linked again simply by returning to this
			page and clicking on "Link Accounts" again. Also, unlinking your accounts will not remove any information that
			has already been transferred between EyeCare Associates and Google Health.</div>
		</p>
<?	} //End if account is linked ?>
	<h2 class="orange">Return to Google Health</h2>
	<p class="basicMedium">
		<a class="basicLink boldLink" href="https://h9.google.com/h9/p/">Click Here</a> to return to your Google Health account.
		<!-- <a class="basicLink boldLink" href="https://health.google.com/health/directory?cat=importrecords">Click Here</a>
		to go to your Google Health account. -->
	</p>
	<br><br>
	<h2 class="orange">Other Useful Links</h2>
	<p class="basicMedium">
		Our <a class="basicLink boldLink" href="javascript:openPrivacy();">Privacy Policy</a> provides information about how
		your medical records will be used and communicated with entities such as Google Health.
	</p>
	<p class="basicMedium">
		Our <a class="basicLink boldLink" href="javascript:openTerms();">Terms of Service</a> provide information about your
		account access, and further information about your medical records.
	</p>
	<br>
<?
	include "foot.php";
} //end if logged in
?>