<?
require_once('includes/conf.php');
enforcedSessionStart();

require_once('includes/portalutils.php');

$error = null;
$whichBox = null;
if (isset($_POST['accesstype'])) {
	//whichBox tracks which login type was attempted (for error messages)
	$whichBox = $_POST['accesstype'];
	if ($_POST['accesstype'] == 'login') {
		if (!isset($_POST['user']) || !isset($_POST['password']) || $_POST['user'] == "" || $_POST['password'] == "") {
			$error = "Username and password are both required. Please fill these in and try again.";
		} else {
			//$patient = getPatientByEmail($_POST['email']);
			try {
				$patient = getPatientByUsername($_POST['user']);
				if ($patient == null) {
					$error = "Patient with the given username not found. Please
					          <a class=\"basicLink\" href=\"register.php\">register</a> to access your account";
				} else if (!logIn($_POST['user'], $_POST['password'])) {
					$error = "Invalid password. Please try again.";
				} else {
					$redirect = $_SESSION['referral_page'];
					if (isset($redirect)) {
						unset($_SESSION['referral_page']);
						header("location:$redirect");
					} else {
						header('location:portal_main.php');
					}
				}
			} catch (Exception $e) {
				$error = "An error occurred while trying to log you in.  We apologize for the inconvenience, and we are currently working on fixing the problem.  Please try again later.";
			}
		}
	} else if ($_POST['accesstype'] == 'invoice') {
		if (!isset($_POST['superbill']) || !isset($_POST['firstname']) || !isset($_POST['lastname']) ||
		           $_POST['superbill'] == "" || $_POST['firstname'] == "" || $_POST['lastname'] == "") {
			$error = "Invoice number, first name, and last name are all required. Please fill these in and try again.";
		} else {
			try {
				$patient = getPatientBySuperbill($_POST['superbill']);
				if ($patient == null) {
					$error = "Invoice not found.  Make sure you entered it correctly and try again.";
				} else if (!nameMatches($patient, $_POST['firstname'], $_POST['lastname'])) {
					$error = "Name provided does not match the name on file for the provided invoice.";
				} else {
					//Set patient and superbill and go straight to billing info
					unset($_SESSION['creditcard']);
					unset($_SESSION['superbill']);
					setPatient($patient);
					setSuperbill($_POST['superbill'], $patient->getDatabaseName());
					header('location:billing_info.php');
				}
			} catch (Exception $e) {
				$error = "An error occurred while attempting to look up your invoice.  We apologize for the inconvenience, and we are currently working on fixing the problem.  Please try again later.";
			}
		}
	} else {
		//something strange happened (incorrect access type)
		$error = "Invalid login attempt. Please try again.";
		$whichBox = "login";
	}
}

$logged_in = isset($_SESSION['patient']) && isset($_SESSION['password']);

//Only draw an arrow over the "Log In" box if we're not logged in already (otherwise it's a "Log Out" box)
$drawArrow = !$logged_in;
$arrowPos = 511;

//Include the header info
$title='EyeCare Associates - Log In or Choose an Invoice';
include("template.php");

//Don't show timeout warnings on the login page.
$initializeTimeout = false;
$subMenu = "portal_menu.jpg";
include("head.php");

?>
<div id="portal-box-login">

 <h1>Login</h1>
<div class="smallItem">Login to access your exam records, account information, prescriptions and pay your bills online. <br />
  User account required.</div>
<div class="error"><? echo (isset($error) && $whichBox == "login") ? $error : ""; ?></div>
<form action="<?php echo $_SERVER['PHP_SELF'];?>" method="post" id="loginform" name="loginform">
	<input type="hidden" name="accesstype" value="login" />
	<div>
		<div class="smallItem"><table class="formLines1">
			<tr><td><label for="user">Username/E-mail: </label></td><td><input type="text" id="user" name="user" size="30" maxlength="255" /></td></tr>
			
			<tr><td><label for="password">Password: </label></td><td><input type="password" id="password" name="password" size="30" maxlength="50" /></td></tr>
			<tr><td colspan="2"><div class="smallInfo">
				<a class="basicLink" href="forgot_username.php">Forgot your username?</a>
			</div></td></tr><tr><td colspan="2"><div class="smallInfo">
				<a class="basicLink" href="reset_password.php">Forgot your password?</a>
			</div></td></tr>
			<tr><td colspan="2" style="padding-top: 10px;"><input type="submit" value="Login" /></td></tr>
		</table>
	</div></div>
</form><h1>Register</h1>
<div class="smallItem">Don't yet have an account? <a class="basicLink" href="register.php">Registration</a> is easy.</div>
</div>
<div id="portal-box">

<h1>Easy Pay</h1>
<div class="smallInfo">Pay your invoice in 3 easy steps.  Login not required.</div>
<div class="error"><? echo (isset($error) && $whichBox == "invoice") ? $error : ""; ?></div><div class="smallItem">
<form action="<?php echo $_SERVER['PHP_SELF'];?>" method="post" id="invoiceform" name="invoiceform">
	<input type="hidden" name="accesstype" value="invoice" />
	<div>
		<table class="formLines1">
			<tr><td><label for="firstname">First Name: </label></td><td><input type="text" id="firstname" name="firstname" size="30" maxlength="50" /></td></tr>
			<tr><td><label for="lastname">Last Name: </label></td><td><input type="text" id="lastname" name="lastname" size="30" maxlength="50" /></td></tr>
			<tr><td><label for="superbill">Invoice #: </label></td><td><input type="text" id="superbill" name="superbill" size="30" maxlength="20" /></td></tr>
			<tr><td colspan="2" style="padding-top: 10px;"><input type="submit" value="Pay This Bill" /></td></tr>
		</table>
	</div>
</form></div>
</div>
<br />

<? include "foot.php"; ?>
