<?
require_once('includes/conf.php');
enforcedSessionStart();

require_once('includes/portalutils.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/fullnameformatter.php');
require_once('password_strength.php');

//Make sure patient is logged in first
$patient = getPatient();
$children = getListedChildren($patient);
$logged_in = isLoggedIn($patient);
$username = getPatUsername($patient);

if (!$logged_in) {
	$_SESSION['referral_page'] = $_SERVER['PHP_SELF'];
	header('location:login.php');
} else {
	//Include the header info
	$title='EyeCare Associates - Manage Account';
	include("template.php");

	$subMenu = "portal_menu.jpg";
	$drawArrow = true;
	$arrowPos = 318;
	include("head.php");
	
	$fnf = new FullNameFormatter(null, false);
	
	$message=null;
	$messagePos=null;
	$messageClass='error';
	if (isset($_POST['changeValue'])) {
		//Something is changing - check which form it is
		if (!isset($_POST['password']) || $_POST['password'] == "") {
			$message = "You must enter your current password in order to change this field.";
		} else if (!verifyCredentials($username, $_POST['password'])) {
			$message = "Incorrect password.  Please try again.";
		} else {
			$messagePos = $_POST['changeValue'];
			if ($_POST['changeValue'] == 'username') {
				$newUsername = $_POST['username'];
				if (preg_match("/^[\\w\\-\\.@_]+$/", $newUsername) == 1) {
					include('change_username.php');
					$username = $newUsername;
				} else {
					$message = "Invalid username.  Invalid characters used.";
				}
			} else if ($_POST['changeValue'] == 'password') {
				$oldPassword = $_POST['password'];
				$newPassword = $_POST['new_password'];
				$confirmPassword = $_POST['new_password2'];
				include('change_password.php');
			} else {
				$message = "Unsupported operation.";
			}
		}
	}
?>

	<h1>My Account Settings</h1>
<h2 id="patient-name">For Patient <? echo $fnf->format($patient); ?></h2>
	<? 
	if (isset($message)) {
		if (strpos($message, "\n") !== false) {
			//Right now, the only message with multiple lines is the password strength issue.
			echo "<h3 class=\"$messageClass\">The password does not meet strength requirements (see below)</h3>\n";
		} else {
			echo "<h3 class=\"$messageClass\">$message</h3>\n";
		}
	}
	?>
	<?
		if (isset($children) && sizeof($children) > 0) {
			echo "\n\t<h2 class=\"orange\">Other Patients Associated with this Account:</h2>\n";
			echo "<div class=\"smallItem\">The following patient records and bills can currently be viewed on this account. <a href=\"manage_account_add_individual.php\">Click here</a> to add an additional individual to this account.</div>";
			foreach ($children as $child) {
				echo "\t<h4>" . $fnf->format($child) . "</h4>";
			}
		}
	?>
<div id="spacer"></div>
	<div id="portal-box1">
	<h2 class="orange">Change Username</h2>
	<p>	Usernames can only contain alphanumeric characters (A-Z, a-z, and 0-9),
		as well as the following four special characters: @ . - _
</p><br/>
	<? if ($messagePos == "username") echo "<div class=\"$messageClass\">$message</div>\n"; ?>
	<p>Current username: <? echo $username; ?></p>
	<form action="<?php echo $_SERVER['PHP_SELF'];?>" method="post" id="userForm" name="userForm">
		<input type="hidden" name="changeValue" value="username" />
		<table class="formLines">
			<tr><td>New Username: </td><td><input type="text" name="username" /></td></tr>
			<tr><td>Current Password: </td><td><input type="password" name="password" /></td></tr>
			<tr><td colspan="2"><input type="submit" value="Change Username" /></td></tr>
		</table>
	</form></div>
	
	<div id="portal-box2">
	<h2 class="orange">Change Password</h2>
	<? if ($messagePos == "password") echo "<div class=\"$messageClass\">$message</div>\n"; ?>
	<form action="<?php echo $_SERVER['PHP_SELF'];?>" method="post" id="userForm" name="userForm">
		<input type="hidden" name="changeValue" value="password" />
		<table class="formLines">
			<tr><td>Current Password: </td><td><input type="password" name="password" /></td><td rowspan="4" style="padding-left: 10px;">
				<? echo showPasswordRequirements('new_password'); ?>
			</td></tr>
			<tr><td>New Password: </td><td><input id="new_password" type="password" name="new_password" /></td></tr>
			<tr><td>Confirm Password: </td><td><input type="password" name="new_password2" /></td></tr>
			<tr><td colspan="2"><input type="submit" value="Change Password" /></td></tr>
		</table>
	</form>
	
	</div>

<?
	echo "<br />\n";
	include "foot.php";
} //end if logged in
?>