<?
require_once('includes/conf.php');
enforcedSessionStart();

require_once('includes/portalutils.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/fullnameformatter.php');
require_once('password_strength.php');

//Make sure patient is logged in first
$patient = getPatient();
$children = getListedChildren($patient);
$logged_in = isLoggedIn($patient);
$username = getPatUsername($patient);

if (!$logged_in) {
	$_SESSION['referral_page'] = $_SERVER['PHP_SELF'];
	header('location:login.php');
} else {
	//Include the header info
	$title='EyeCare Associates - Manage Account';
	include("template.php");

	$subMenu = "portal_menu.jpg";
	$drawArrow = true;
	$arrowPos = 318;
	include("head.php");
	
	$fnf = new FullNameFormatter(null, false);
	
	$message=null;
	$messagePos=null;
	$messageClass='error';
	if (isset($_POST['changeValue'])) {
		//Something is changing - check which form it is
		if (!isset($_POST['password']) || $_POST['password'] == "") {
			$message = "You must enter your current password in order to change this field.";
		} else if (!verifyCredentials($username, $_POST['password'])) {
			$message = "Incorrect password.  Please try again.";
		} else {
			$messagePos = $_POST['changeValue'];
			if ($_POST['changeValue'] == 'username') {
				$newUsername = $_POST['username'];
				if (preg_match("/^[\\w\\-\\.@_]+$/", $newUsername) == 1) {
					include('change_username.php');
					$username = $newUsername;
				} else {
					$message = "Invalid username.  Invalid characters used.";
				}
			} else if ($_POST['changeValue'] == 'password') {
				$oldPassword = $_POST['password'];
				$newPassword = $_POST['new_password'];
				$confirmPassword = $_POST['new_password2'];
				include('change_password.php');
			} else {
				$message = "Unsupported operation.";
			}
		}
	}
?>

	<h1>My Account Settings</h1>

    <h2 id="patient-name">For Patient <? echo $fnf->format($patient); ?></h2>
	 
   	<div id="portal-box2">
	<h2 class="orange">Add an Individual to My Account</h2>
	
	<form action="<?php echo $_SERVER['PHP_SELF'];?>" method="post" id="userForm" name="userForm">
		<input type="hidden" name="changeValue" value="username" />
		<table width="390" class="formLines">
			<tr><td>First Name:</td><td><input type="text" name="fname" /></td></tr>
			<tr><td>Last Name:</td><td><input type="text" name="lname" /></td></tr>
            <tr><td>Date of Birth:</td><td><input type="text" name="lname" /> (MM/DD/YYYY)</td></tr>
			<tr><td colspan="2"><input type="submit" value="Submit" /></td></tr>
		</table>
	</form></div>
<div id="spacer"></div>
<?
	echo "<br />\n";
	include "foot.php";
} //end if logged in
?>
