<?
require_once('includes/conf.php');
enforcedSessionStart();

require_once('includes/portalutils.php');
require_once('secure_message.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/fullnameformatter.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/backend/axis/GetEmployeeMailboxesMessage.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/backend/axis/GetProvidersSeenMessage.php');

//Include the header info
$title='EyeCare Associates - New Secure Messages';
include("template.php");
$availableProviders = array();
$providers = array();
$anyProviders = false;
$multipleUsers = false;

if ($_SESSION['userMode'] == PATIENT_MODE) {
	$patient = getPatient(true);
	if (!isLoggedIn($patient)) {
		$patient = null;
	} else {
		//$msg = new GetEmployeeMailboxesMessage('cec_messaging');
		try {
			//$availableProviders = $msg->getEmployeeMailboxes();
			$availableProviders = array();
			$msg = new GetProvidersSeenMessage('cec_portal');
			$providers = $msg->getProvidersSeen($patient->getFieldValue('uid'));
			if ($providers != null && is_array($providers)) {
				foreach ($providers as $provider) {
					$proUID = $provider->getFieldValue('uid');
					$anyProviders = true;
					$availableProviders[] = $proUID;
					/* if (in_array($proUID, $availableProviders)) {
						$anyProviders = true;
					} */
				}
			}
		} catch (Exception $e) {
			$error = "There was an error loading the available doctors.  Please try again later.";
		}
	}
	$allUsers = getAllUnderAccount($patient);
	if ($allUsers != null && is_array($allUsers) && count($allUsers) > 1) {
		$multipleUsers = true;
	}
} else if ($_SESSION['userMode'] == EMPLOYEE_MODE) {
	$employee = getEmployee(true);
	if (!isEmployeeLoggedIn($employee)) {
		$employee = null;
	}
}
if ($patient != null || $employee != null) {
	$uid = $_POST['replyToUID'];
	$replyTo = urldecode($_POST['replyTo']);
	if ($uid == null && $_POST['replyTo'] == null) {
		//Try to get it from a GET variable as well.
		$uid = $_GET['replyToUID'];
		$replyTo = urldecode($_GET['replyTo']);
	}
	//TODO - get a real GET param name for this variable
	$toPatientUID = $_GET['toPatient'];
	$subMenuName = ($_SESSION['userMode'] == PATIENT_MODE ? "portal_menu" : "employee_menu");
	include("head.php");
	if (!isset($error)) {
		try {
			if ($replyTo != null && trim($replyTo) != "" && $uid != null && trim($uid) != "") {
				$message = getSecureMessage($uid, $replyTo, false);
			}
			if ($_SESSION['userMode'] == PATIENT_MODE && !$anyProviders && !$multipleUsers) {
				if ($providers != null && is_array($providers) && count($providers) > 0) {
					echo "<h2 class=\"orange\">Your Doctor(s)' Accounts are not Ready</h2>
					<div>We are working now to finalize your doctors patient portal account.</div>
					<div>In the meantime you may send any questions or comments to <a class=\"basicLink\" href=\"mailto:info@webeca.com\">info@webeca.com</a>.</div>
					<div>Your message will be passed along to your doctor.</div>
					<div>Thank you for your patience. Check back soon to begin communicating directly with your EyeCare Associates doctor.</div>";
				} else {
					echo "<h2 class=\"orange\">Your Doctors could not be Found</h2>
					<div>You do not appear to have been seen recently by any of our doctors.  You can only send secure messages to doctors with whom you have had an eye exam.  Please feel free to <a class=\"basicLink\" href=\"schedule_choose.php\">schedule an appointment</a> now!  If you have any questions, please send them to <a class=\"basicLink\" href=\"mailto:info@webeca.com\">info@webeca.com</a>.</div>";
				}
			} else {
				echo getNewMessageHTML($message, $uid, $toPatientUID, $providers, $availableProviders);
			}
		} catch (Exception $e) {
			$error = "An error occurred while initializing the message.  Please try again later.";
		}
	}
	if (isset($error)) {
		echo "<div class=\"error\">$error</div>";
	}
	include("foot.php");
} else {
	$replyTo = $_POST['replyTo'];
	$replyToUID = $_POST['replyToUID'];
	$userMode = $_GET['userMode'];
	$toPatientUID = $_GET['toPatient'];
	$suffix = ($userMode == null ? '' : "?userMode=$userMode");
	$suffix .= (isset($replyTo) ? (strlen($suffix) > 0 ? '&' : '?') . "replyTo=" . urlencode($replyTo) : "");
	$suffix .= (isset($replyToUID) ? (strlen($suffix) > 0 ? '&' : '?') . "replyToUID=$replyToUID" : "");
	//If the employee mode param is provided, assume it's a provider.  Else assume it's a patient.
	if ((isset($userMode) && $userMode == EMPLOYEE_MODE) || $toPatientUID != null) {
		if ($toPatientUID != null) {
			$suffix .= (strlen($suffix) > 0 ? '&' : '?') . "toPatient=$toPatientUID";
		}
		$_SESSION['referral_page'] = $_SERVER['PHP_SELF'] . $suffix;
		header("location:employee_login.php");
	} else {
		$_SESSION['referral_page'] = $_SERVER['PHP_SELF'] . $suffix;
		header("location:login.php");
	}
}
?>