<?
session_start();
require_once('includes/portalutils.php');
require_once('includes/welcome_sheet_utils.php');
require_once(GLOBAL_INCLUDES_DIR . 'xml_to_html.php');
require_once(GLOBAL_INCLUDES_DIR . '/springfield/formatters/dateformatter.php');
require_once(GLOBAL_INCLUDES_DIR . '/springfield/backend/axis/getwelcomesheetmessage.php');
require_once(GLOBAL_INCLUDES_DIR . '/springfield/backend/axis/needswelcomesheetmessage.php');

$patUID = $_GET['patient'];
if ($patUID == null || $patUID == '') {
	//Get from the session var if no patient is set
	$patUID = $_SESSION['WelcomeSheetPatient'];
}
$needsWelcomeSheet = true;
$error = null;
$serviceNotAvailable = null;
if (isset($patUID) && $patUID != '') {
	/* $patient = getPatientFromDB(DEFAULT_SERVER, $patUID, false, null);
	if ($patient->getFieldValue("firstname") == null) {
		//No patient was actually loaded - set the patient to null
		$patient = null;
	} */
	$msg = new GetWelcomeSheetMessage('cec_welcomesheet');
	try {
		$welcomeSheet = $msg->getWelcomeSheet($patUID);
	} catch (Exception $e) {
		$error = "<div class=\"basicMedium\">An unknown error occurred while loading your welcome sheet.  Please try again.  " .
				"If the problem persists, please print out your welcome sheet <a class=\"basicLink\" href=\"" .
				"http://www.webeca.com/Welcome_Sheet_Interactive.pdf\">here</a> and complete it by hand.</div>";
	}
	//Use this when the axis service is down:
	//$welcomeSheet = new WelcomeSheet();
	//$msg = new GetLastWelcomeSheetDateMessage('cec_welcomesheet');
	//$lastWelcomeSheetDate = $msg->getLastWelcomeSheetDate($patUID);
	$msg = new NeedsWelcomeSheetMessage('cec_welcomesheet');
	try {
		$needsWelcomeSheet = $msg->needsWelcomeSheet($patUID);
	} catch (Exception $e) {
		$error = "<div class=\"basicMedium\">An unknown error occurred while loading your welcome sheet.  Please try again.  " .
				"If the problem persists, please print out your welcome sheet <a class=\"underLink\" href=\"" .
				"http://www.webeca.com/Welcome_Sheet_Interactive.pdf\">here</a> and complete it by hand.</div>";
	}
} else {
	//No patient was specified - can't do a welcome sheet for no patient.
	$error = "<h4 class=\"orange\">No Patient Specified</h4><div class=\"basicMedium\">You must come to this page from the link on " .
			"the reminder e-mail, which will correctly associate this welcome sheet with your record.  If you did this and you still " .
			"get this message, please <a class=\"basicLink\" href=\"http://www.webeca.com/Welcome_Sheet_Interactive.pdf\">" .
			"click here</a> to access a printable version of the welcome sheet that you can fill out, print, and bring to your visit.</div>";
}

$dateFormatter = new DateFormatter('m/d/Y');

//Assume new patient by default - use the new patient welcome sheet
$xmlFile = dirname(__FILE__) . "/Welcome_Sheet.xml";
$map = array();
$starStr = '*****';
if ($error == null) {
	//No errors so far
	if ($welcomeSheet == null) {
		//The patient was specified but their welcome sheet was not found.
		$error = "<h4 class=\"orange\">Patient Not Found</h4><div class=\"basicMedium\">You must come to this page from the link on " .
				"the reminder e-mail, which will correctly associate this welcome sheet with your record.  If you did this, but you " .
				"still get this message, please try to refresh the page to see if your record can be found.  If the error continues, " .
				"please <a class=\"basicLink\" href=\"http://www.webeca.com/Welcome_Sheet_Interactive.pdf\">click here</a> " .
				"to access a printable version of the welcome sheet that you can fill out, print, and bring to your visit.</div>";
	} else if ($needsWelcomeSheet) {
		//TODO - REMOVE THIS ECHO STATEMENT!  (Actually, ideally just comment it for future use if necessary).
		$serviceNotAvailable = "<div class=\"orange\">We apologize for the inconvenience, but this service is temporarily unavailable.  Please print out your welcome sheet <a class=\"underLink\" href=\"http://www.webeca.com/Welcome_Sheet_Interactive.pdf\">here</a> and complete it by hand.  We will restore the online welcome sheet service as soon as possible.</div>";
		//TODO - UNCOMMENT THIS!  IT'S HERE TO TEMPORARILY STOP USERS FROM DOING THEIR WELCOME SHEETS ONLINE UNTIL THE AXIS SERVICE IS FIXED
		/*
		//The welcome sheet was found and the patient needs to fill one out.
		$_SESSION['WelcomeSheetPatient'] = $patUID;
		$newPat = ($welcomeSheet->getFieldValue('new_pat') == 'TRUE');
		$showLoginInfo = false;
		$doDefaults = true;
		if (!$newPat) {
			//The patient isn't new - use the established patient welcome sheet.
			$xmlFile = dirname(__FILE__) . "/est_welcome_sheet.xml";
			//See if the patient is logged in.  If not, force them to do so.
			$loggedInPatient = getPatient(false);
			
			if ($loggedInPatient != null && $loggedInPatient->getFieldValue('firstname') != null && $loggedInPatient->getFieldValue('uid') == $welcomeSheet->getFieldValue('uid')) {
				//Don't show the disclaimer describing the blank fields and "*****" fields; there are none
				$doDefaults = false;
				//Put all patient fields in the map
				foreach ($welcomeSheet->getFieldNames() as $fieldName) {
					$map["patient__$fieldName"] = formatPatientField($welcomeSheet, $fieldName);
				}
				
				//Address is in the data as "street"
				$map["patient__address"] = formatPatientField($welcomeSheet, 'street');
				
				//Smoking status is chosen from several boxes
				$smokingStatus = $welcomeSheet->getFieldValue('smoking_status');
				$map = setWelcomeSheetSmokingStatus($map, $smokingStatus);
				
				//Marriage status is also chosen from several boxes
				$married = $welcomeSheet->getFieldValue('married');
				$map = setWelcomeSheetMarried($map, $married);
				
				//Race and ethnicity are chosen from several boxes
				$raceStr = $welcomeSheet->getFieldValue('race');
				$map = setWelcomeSheetRace($map, $raceStr);
				
				$ethnicityStr = $welcomeSheet->getFieldValue('ethnicity');
				$map = setWelcomeSheetEthnicity($map, $ethnicity);
				
				//Pat history fields
				$map = addHistory($map, "patient__eye_", $welcomeSheet->getFieldValue('patEye'));
				$map = addHistory($map, "patient__medical_", $welcomeSheet->getFieldValue('patMed'));
				$map = addHistory($map, "family__eye_", $welcomeSheet->getFieldValue('famEye'));
				$map = addHistory($map, "family__medical_", $welcomeSheet->getFieldValue('famMed'));
				
				//Insurance fields don't map directly to their name:
				$map["patient__primary_insurance"] = $welcomeSheet->getFieldValue('primaryIns');
				$map["patient__primary_id"] = $welcomeSheet->getFieldValue('primaryInsID');
				$map["patient__subscriber"] = $welcomeSheet->getFieldValue('subscriber');
				$map["patient__relationship"] = $welcomeSheet->getFieldValue('subscriberRelationship');
				
				//Add spaces after commas in meds/allergies.  For now, we're just showing these to the patient
				//and if a change is needed, they must do so at the office.
				$allergies = $welcomeSheet->getFieldValue('allergies');
				$map["patient__allergies"] = str_replace(',', ', ', str_replace(', ', ',', $allergies));
				$meds = $welcomeSheet->getFieldValue('medications');
				$map["patient__medications"] = str_replace(',', ', ', str_replace(', ', ',', $meds));
			} else {
				//If the patient has an e-mail address, let them know they can log in to fill out data faster.
				$showLoginInfo = ($welcomeSheet->getFieldValue('email') != null && $welcomeSheet->getFieldValue('email') != '');
			}
		}
		//For all patients, by default, just show the basic info (if they didn't log in, this isn't secure enough for sensitive data)
		//Designation is in the data as "title"
		$map['patient__designation'] = formatPatientField($welcomeSheet, 'title');
		$map['patient__lastname'] = formatPatientField($welcomeSheet, 'lastname');
		$map['patient__firstname'] = formatPatientField($welcomeSheet, 'firstname');
		$map['patient__mi'] = formatPatientField($welcomeSheet, 'mi');
		$map['patient__address'] = formatPatientField($welcomeSheet, 'street');
		$map['patient__city'] = formatPatientField($welcomeSheet, 'city');
		$map['patient__state'] = formatPatientField($welcomeSheet, 'state');
		$map['patient__zip'] = formatPatientField($welcomeSheet, 'zip');
		$map['patient__homephone'] = formatPatientField($welcomeSheet, 'homephone');
		$map['patient__email'] = formatPatientField($welcomeSheet, 'email');
		
		$defaultsMap = array();
		if ($doDefaults) {
			$emptyFields = array('preferred_name', 'ssn', 'occupation', 'ethnicity', 'race', 'preferred_language', 'married', 'smoking_status');
			$starFields = array('employer', 'cell', 'workphone');
			foreach ($emptyFields as $field) {
				$fieldVal = $welcomeSheet->getFieldValue($field);
				if ($fieldVal != null && $fieldVal != '') {
					//We don't need to store defaults if the field is empty anyway.
					$defaultsMap['patient__' . $field] = '';
				}
			}
			foreach ($starFields as $field) {
				$fieldVal = $welcomeSheet->getFieldValue($field);
				if ($fieldVal != null && $fieldVal != '') {
					//We don't need to store defaults if the field is empty anyway.
					$map['patient__' . $field] = $starStr;
					$defaultsMap['patient__' . $field] = $starStr;
				}
			}
		}
		
		//Use today's date as the date
		$map['date'] = $dateFormatter->format(time());
		//Check the appropriate preferred phone type
		$prefPhone = $welcomeSheet->getFieldValue("preferred_phone");
		if ($prefPhone == 'workphone') {
			$map['patient__preferred_phone__workphone'] = 'X';
		} else if ($prefPhone == 'cell') {
			$map['patient__preferred_phone__cell'] = 'X';
		} else {
			//Default to homephone if nothing else is specified
			$map['patient__preferred_phone__homephone'] = 'X';
		}*/
	}
}

//Build the enumeration choices
$enumChoices = buildWelcomeSheetEnumerations();

//Include the header info
$title='EyeCare Associates - Fill out Welcome Sheet';
include("template.php");

$drawArrow = false;
$arrowPos = 0;
$subMenu = "portal_menu.jpg";
$rightPadding = (($needsWelcomeSheet && !isset($error)) ? 300 : 0);
include("head.php");
?>

<!-- Form validation script -->
<script type="text/javascript">
	<?
	echo "var patUID = \"$patUID\";";
	if ($newPat) {
	?>
		var newPat = true;
	<?
	} else {
	?>
		var newPat = false;
	<?
	}
	?>
	function validateWelcomeSheet() {
		var error = null;
		//All welcome sheets need the following:
		if (!$("#agree_to_terms").attr("checked")) {
			//Patient must agree to terms first
			error = "<h3 class=\"orange\">You must agree to the terms before submitting the form</h3>";
		}
		
		//Remove any existing invalid modifiers
		$("input").removeClass('invalid');
		
		//Validate some required fields:
		if (error == null) {
			var requiredFields = new Array("patient__firstname", "patient__lastname", "patient__address",
				"patient__city", "patient__state", "patient__zip", "patient__homephone", "patient__birthday");
			for (i = 0; i < requiredFields.length; i++) {
				var fieldSelector = '[name="' + requiredFields[i] + '"]';
				var val = $(fieldSelector).val();
				if (val == '' || val == null || ($(fieldSelector).hasClass('blur') && val == $(fieldSelector).attr('title'))) {
					//Required fields cannot be empty
					$(fieldSelector).addClass("invalid");
					error = "<div class=\"orange\">Some required fields are not entered.  They have been " +
							"highlighted in red.  Please fill in these fields before hitting \"Submit\".</div>";
				}
			}
		}
		
		//Validate date fields:
		if (error == null) {
			var fieldSelector = 'input[editstyle="date"]';
			$(fieldSelector).each(function() {
				var val = $(this).val();
				if (val == null || val == '' || ($(fieldSelector).hasClass('blur') && val == $(fieldSelector).attr('title'))) {
					return;
				}
				var pattern = new RegExp("\\d{1,2}\\/\\d{1,2}\\/\\d{4}");
				var matched = true;
				var d = $(this).val();
				
				//Match the required date pattern
				if (!pattern.test(d)) {
					matched = false;
				}
				
				//If the pattern matches, make sure it's a real date
				if (matched) {
					//Javascript just rolls over when out of range, so check that all date parts match in a resulting date object to validate.
					var dateParts = d.split("/");
					var dateObj = new Date(d);
					matched = (dateObj.getMonth() == dateParts[0] - 1 && dateObj.getDate() == dateParts[1] && dateObj.getFullYear() == dateParts[2]);
				}
				if (!matched) {
					$(this).addClass("invalid");
					error = "<div class=\"orange\">All dates must be in MM/DD/YYYY format.  Please " +
							"check all date fields, highlighted in red, and resubmit.</div>";
				}
			});
		}
		
		//Validate phone fields:
		if (error == null) {
			var fieldSelector = 'input[editstyle="phone"]';
			$(fieldSelector).each(function() {
				var val = $(this).val();
				var name = $(this).attr('name');
				if (val == null || val == '' || ($(fieldSelector).hasClass('blur') && val == $(fieldSelector).attr('title'))) {
					return;
				}
				var pattern = new RegExp("\\D*\\d\\D*\\d\\D*\\d\\D*\\d\\D*\\d\\D*\\d\\D*\\d\\D*\\d\\D*\\d\\D*\\d");
				<?
				//Phone numbers with defaults are special - the star str is allowed
				if ($doDefaults) {
					if (array_key_exists('patient__workphone', $defaultsMap)) {
						echo "if (name == 'patient__workphone' && val =='$starStr') {\n\t//Defaults are fine\n\treturn; \n} else ";
					}
					if (array_key_exists('patient__cell', $defaultsMap)) {
						echo "if (name == 'patient__cell' && val =='$starStr') {\n\t//Defaults are fine\n\treturn; \n} else ";
					}
				}
				?>if (!pattern.test(val)) {
					$(this).addClass("invalid");
					error = "<div class=\"orange\">Phone numbers must be 10 digits, including an area code (format does not matter).  " +
							"Please check all phone number fields, highlighted in red, and resubmit.</div>";
				}
			});
		}
		if (error == null) {
			//The last possible validation error comes from the backend - query it to find out.
			var data = $("#mainForm").serializeArray();
			data.push({name: "newPat", value: newPat});
			data.push({name: "patUID", value: patUID});
			//Make the actual AJAX call to the validator
			$.post("validate_welcome_sheet.php", data, function(result) {
				if (result.hadException) {
					error = "<div class=\"orange\">An unknown error occurred, likely due to the system being down at this time.  " +
							"Please try again.  If the problem persists, print out your welcome sheet <a class=\"underLink\" href=\"" +
							"http://www.webeca.com/Welcome_Sheet_Interactive.pdf\">here</a> and complete it by hand.</div>";
				} else if (result.hadError) {
					//Validation errors occurred - show the errors.
					$.each(result.results, function(index, value) {
						//The value is a JSON object containing a name and value
						var fieldSelector = '[name="' + value.name + '"]';
						$(fieldSelector).removeClass('invalid').addClass('invalid');
						var editStyle = $(fieldSelector).attr('editStyle');
						if (editStyle != 'phone' && editStyle != 'date') {
							//If not phone or date, set the title to the hint, so the user sees the tool tip
							$(fieldSelector).attr('title', value.value);
						}
					});
					error = "<div class=\"orange\">Some fields contained invalid values.  They have been highlighted in red.  " +
							"Please correct these values and resubmit.</div>";
				} else {
					//No validation errors - submit the form
					$("#mainForm").submit();
				}
				if (error != null) {
					$("#error_top").slideUp('slow').html(error).slideDown('slow');
					$("#error_bottom").slideUp('slow').html(error).slideDown('slow');
				}
			}, 'json').error(function() {
				//An AJAX error occurred - the call can't be completed properly.  Inform the user.
				error = "<div class=\"orange\">An unknown error occurred, likely due to the system being down at this time.  " +
						"Please try again.  If the problem persists, print out your welcome sheet <a class=\"underLink\" href=\"" +
						"http://www.webeca.com/Welcome_Sheet_Interactive.pdf\">here</a> and complete it by hand.</div>";
					$("#error_top").slideUp('slow').html(error).slideDown('slow');
					$("#error_bottom").slideUp('slow').html(error).slideDown('slow');
			});
		}
		if (error != null) {
			$("#error_top").slideUp('slow').html(error).slideDown('slow');
			$("#error_bottom").slideUp('slow').html(error).slideDown('slow');
		}
		//Never return true; after validation via the AJAX call, the form will be submitted if necessary.
		return false;
	}
</script>
<?
if ($needsWelcomeSheet) {
	if (isset($error)) {
		echo '<div id="error_top"><h3 class="orange">Error Loading Welcome Sheet</h3>' . $error . '</div>';
	} else if (isset($serviceNotAvailable)) {
		//The welcome sheet service is temporarily unavailable; show that message.
		echo $serviceNotAvailable;
	} else {
		if ($showLoginInfo) {
			echo '<h3 class="orange">Log in first to save some time!</h3><div class="basicMedium">In order to fill out your welcome sheet more ' .
				'quickly, you can <a class="basicLink" href="to_login.php?from=online_welcome_sheet.php">log in</a> to our patient ' .
				'portal if you have an account.  If not, you can <a class="basicLink" href="register.php">click here</a> to register ' .
				'for a new account.  If you are logged in, any of your data that we have on file for you will be entered automatically.  ' .
				'Note that some data must be entered again at each visit, and this data will not be auto-loaded.</div>';
		}
		if ($doDefaults) {
			echo '<h3 class="orange">Note About Your Information</h3><div class="basicMedium">For security reasons, sensitive information ' .
				'that we have on file for you may not be displayed here.  Fields that are filled in with "*****" indicate a value in your ' .
				'record that is not being displayed, but may be cleared from our records by simply clearing them here.</div>';
		}
		//No errors - show the welcome sheet form
?>
		<form id="mainForm" action="welcome_sheet_landing.php" method="POST">
			<div style="width: 800px; text-align: center; padding-bottom: 10px; padding-top: 20px;">
				<input type="button" value="Submit" onclick="validateWelcomeSheet();" />
				<div id="error_top" style="display: none;"></div>
			</div>
			<input type="hidden" name="xml_file" value="<? echo $xmlFile; ?>" />
			<input type="hidden" name="patient" value="<? echo $patUID;?>" />
			<?
			if ($doDefaults) {
				foreach ($defaultsMap as $key=>$value) {
					echo "<input type=\"hidden\" name=\"" . $key . "_defaultValue\" value=\"$value\" />\n";
				}
			}
			echo xmlFileToHTML($xmlFile, true, '../Images/', $map, $enumChoices);
			?>
			<script type="text/javascript">
				$('input[editstyle="date"]').attr('title', 'MM/DD/YYYY');
				$('input[editstyle="date"]').hint();
				$('input[editstyle="phone"]').attr('title', '(include area code)');
				$('input[editstyle="phone"]').hint();
			</script>
			<div style="width: 800px; text-align: center; padding-top: 15px; padding-bottom: 10px; font-size: 10pt;">
				<input id="agree_to_terms" type="checkbox" name="agree_to_terms">I agree to all of the terms shown on the form above (this will be treated as your signature for the welcome sheet).</input>
				<div id="error_bottom" style="display: none;"></div>
				<script type="text/javascript">
					$("#agree_to_terms").click(function() {
						var agree = $("#agree_to_terms").attr("checked");
						if (agree) {
							var firstName = $("input[name='patient__firstname']").val();
							var lastName = $("input[name='patient__lastname']").val();
							$("input[name='patient__signature']").val(firstName + " " + lastName);
							$("input[name='patient__signature_date']").val(new Date().format("m/d/yyyy"));
							$("div[name='patient__signature_text']").html(firstName + " " + lastName);
							$("div[name='patient__signature_date_text']").html(new Date().format("m/d/yyyy"));
						} else {
							$("div[name='patient__signature']").val("");
							$("div[name='patient__signature_date']").val("");
							$("div[name='patient__signature_text']").html("");
							$("div[name='patient__signature_date_text']").html("");
						}
					});
					$('[name="patient__primary_insurance_text"],[name="patient__primary_id_text"],[name="patient__subscriber_text"],[name="patient__relationship_text"],[name="patient__subscriber_birthday_text"]').mousedown(function() {
						alert("Unfortunately, you cannot update your insurance information online at this time.  If you need to make any changes to your insurance information, please call 888.EYECARE.");
					});
					$('[name="patient__medications_text"],[name="patient__allergies_text"]').mousedown(function() {
						alert("Unfortunately, you cannot update your allergy/medication information online at this time.  Any medications or allergies that are not shown here must be reported at the office at the time of your visit.");
					});
				</script>
			</div>
			<div style="width: 800px; text-align: center; padding-bottom: 10px;"><input type="button" value="Submit" onclick="validateWelcomeSheet();" /></div>
		</form>
<?
	}
} else {
?>
<h3 class="orange">Welcome Sheet Not Needed</h3>
<div class="basicMedium">Your most recent welcome sheet is sufficient, and you don't need to fill out a new one at this time.
Thank you for taking the time to prepare for your exam!</div>

<?
} //End if needs welcome sheet
include("foot.php");
?>