<?

//Generates an option button group based on the results of the patient query.
//$patientEmail and $patients must be set. $birthday can be set or not - if set, filters patients by bd
//$_GET['has_user'] determines whether to show only patients with a username or only those without (if unset, shows all)
//If $selectedPatient is set, causes any patient with that uid to be selected

require_once('includes/includes.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/patient.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/fullnameformatter.php');

//Collects data on all patients with the given parameters
if (isset($patientEmail) && $patientEmail != "" && isset($patients)) {
	$fnf = new FullNameFormatter();
	
	//That function no longer exists, nor is it needed.
	$filteredPatients = $patients;
	echo "<fieldset><legend>Patients with the specified email address and birthday:</legend>";
	//$filteredPatients = ((isset($_GET['has_user'])) ? filterByUserType($patients, $_GET['has_user']) : $patients);
	foreach ($filteredPatients as $patient) {
		$value = $patient->getFieldValue('uid');
		$database = $patient->getDatabaseName();
		$checked = "";
		if ((isset($selectedPatient) && $selectedPatient == $value) || (!isset($selectedPatient) && count($filteredPatients) <= 1)) {
			//If there's only one option, check that option
			$checked = " checked=\"checked\"";
		}
		$patName = $fnf->format($patient);
		echo "<div class=\"radio_container\"><input id=\"patient_$value\" type=\"radio\" name=\"patient\" value=\"$value\"$checked /> <label for=\"patient_$value\">" .
				$patName . "</label></div><div><input type=\"hidden\" name=\"patient_db_$value\" value=\"$database\" /></div>";
	}
	echo "</fieldset>";
	//If none were added, output an appropriate error message
	if (count($filteredPatients) == 0) {
		$bdText = (isset($birthday) ? " and birthday" : "");
		$loginText = "Please <a class=\"basicLink\" href=\"login.php\">Log In</a> to access your account.</p>";
		if (count($patients) == 0) {
			echo "<p>No patients with that email address" . $bdText . " found.</p>";
		} else {
			if (isset($birthday)) {
				if (!$_GET['has_user']) {
					echo "<p>Patient with that email address and birthday had an existing account. ";
					echo $loginText;
				} else {
					echo "<p>Patient with that email address and birthday does not have an existing account.</p>";
				}
			} else {
				if (!$_GET['has_user']) {
					echo "<p>All patients with that email address had an existing account. ";
					echo $loginText;
				} else {
					echo "<p>No patients with that email address have an existing account.</p>";
				}
			}
		}
	}
}


?>