<?

session_start();

require_once('includes/includes.php');
require_once('includes/portalutils.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/creditcard.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/currencyformatter.php');
require_once('submit_superbill_payment.php');

//Check that a patient has logged in (or at least chosen a superbill)
$patient = getPatient();

//Check that a superbill has been selected
$superbill = getSuperbill();
$email = $_POST['email'];

//Make sure all prerequisite steps are completed
$logged_in = (isset($patient) && isset($superbill) && isset($_POST['cardtype']) && isset($email));

if ($logged_in) {
	$cardType = $_POST['cardtype'];
	$ccNum = preg_replace('/\D/', '', $_POST['ccnumber']);
	$expMonth = $_POST['expmonth'];
	$expYear = preg_replace('/\D/', '', $_POST['expyear']);
	$cardName = $_POST['cardname'];
	$creditcard = new CreditCard($ccNum, $expMonth, $expYear, $cardName, $cardType);
	if (!$creditcard->validate()) {
		//Card is invalid
		header('location:review.php?error=1');
	} else {
	//Card is valid.
	$_SESSION['secure_cc_display'] = $creditcard->getSecureDisplay();
	$totals = $superbill->total();
	$patBalance = $totals['PAT_BALANCE'];
	if ($patBalance < 0.01 || $superbill->codeExists(SalesLog::$COLLECTIONS_CODE)) {
		//No balance or sent to collections - go back to review
		header('location:review.php');
	} else {
		//Superbill has a balance and was not sent to collections; billing info is set; we're good to go.
		$type = $creditcard->getCMSType();
		$superbill->addPayment($patBalance, $type, LOCATION_STAMP, 'Webeca.com Online Payment');
		if (!$superbill->validateSuperbill()) {
			//There was a validation error - go back to billing info
			$log = "Validation error for superbill " . $superbill->getSuperbillNumber() . "\n";
			$validationResults = $superbill->getValidationResults();
			$log .= dump($validationResults);
			klog($log, KLogger::ERROR);
			header('location:billing_info.php?error=1');
		} else {
			$cc_amount = $patBalance;
			$tax = $totals['PAT_TAX'];
			$shippingCost = 0;
			$testMode = !LIVE;
			$dontSubmit = false;
			
			$result = submitSuperbillPayment($patient, $superbill, $creditcard, $cc_amount, $tax, $shippingCost, $testMode, $dontSubmit, $email);
			if (!isset($result)) {
				//Success! Email safe patient info to the error receiver so nothing sensitive is transferred
				//$patientFieldArray = $patient->getFields(array('uid', 'firstname', 'lastname', 'address', 'city', 'state', 'zip'));
				$_SESSION['invoice_success'] = true;
				$_SESSION['amount_paid'] = $cc_amount;
				//$subject = "Webeca.com Billing Success";
				//$message = "Billing success\n\n";
				//$message .= "Invoice number " . $superbill->getSuperbillNumber() . "\n";
				//$message .= dump($patientFieldArray);
				//$message .= "\nEmail: $email";
				//mail(ERROR_MAIL_TO, $subject, $message, "From: Webeca.com <invoices@Webeca.com>\r\nReply-To: " . ERROR_MAIL_TO);
				
				$message = "Billing success for invoice number " . $superbill->getSuperbillNumber();
				klog($message, KLogger::INFO);
				
				$_SESSION['invoice_success'] = true;
				$_SESSION['amount_paid'] = $cc_amount;
				header('location:invoice_receipt.php');
			} else {
				header('location:billing_info.php?error=' . urlencode($result->getName()));
			}
		}
	}
	} //End if card is valid
} else if (isset($patient)) {
	if (isset($superbill)) {
		header('location:review.php');
	} else {
		//patient is set, but missing superbill
		header('location:choose_invoice.php');
	}
} else {
	//no patient
	$_SESSION['referral_page'] = $_SERVER['PHP_SELF'];
	header('location:login.php');
} //End if logged in
?>
