<?
require_once('includes/conf.php');
enforcedSessionStart();

require_once('includes/includes.php');
require_once('includes/portalutils.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/superbill.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/dateformatter.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/fullnameformatter.php');

$mainPatient = getPatient();

if ($mainPatient != null) {
	$logged_in = isLoggedIn($mainPatient);

	//The user must be logged in to access this page
	if (!$logged_in) {
		echo "<h1>Sorry, an error occurred, and you can't see your history at this time.</h1>";
	} else {
		$startDate = date('Y-m-d', strtotime($_GET['start']));
		$endDate = date('Y-m-d', strtotime($_GET['end']));
		$showKids = (boolean)$_GET['showKids'];
		$df = new DateFormatter('m/d/Y');
?>
		<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
		<html>
		<head>
			<title>EyeCare Associates - Account History</title>
		</head>
		<body onload="window.print()">
			<p><img src="/Imagess/eca-logo.png" alt="EyeCare Associates"></p>
			<h1>Account History</h1>
            <div id="block">
			<p>Showing invoices for dates <? echo $df->format($startDate); ?> through <? echo $df->format($endDate); ?></p>
<?
			$fnf = new FullNameFormatter(null, false);
			
			$patients = (($showKids) ? getAllUnderAccount($mainPatient) : array($mainPatient));
			$patientMap = array();
			$num = 0;
			foreach ($patients as $patient) {
				$uid = $patient->getFieldValue('uid');
				$patientMap[$uid] = $patient;
				$dpls = getSuperbillsForPatient($patient, $startDate, $endDate, 'asc');
				//Loop through each superbill and show relevant ones
				foreach ($dpls as $dpl) {
					$superbill = new Superbill($dpl->getDatabaseName());
					$superbill->load($dpl->getFieldValue('superbill'));
					
					$invoices[$uid][] = "<div id=\"box_$num\"><h3>Invoice #" . $superbill->getSuperbillNumber() . ":</h3>" .
					                    $superbill->getSalesLogTable() . $superbill->getDateAndBalanceHTML() . "</div>";
					$num++;
				} //end foreach dpl
			} //end foreach patient
			
			foreach ($invoices as $patUID=>$patInvoices) {
				echo "<h2>For patient: " . $fnf->format($patientMap[$patUID]) . "</h2>";
				foreach ($patInvoices as $invoiceHTML) {
					echo $invoiceHTML . "\n";
				}
				echo "<br><br>";
			}
?></div>
		</body>
		</html>
<?
	} //end if is logged in
} //end if patient != null
?>