<?
require_once('includes/conf.php');
enforcedSessionStart();

require_once('includes/portalutils.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/patient.php');

$error = null;

if (isset($_GET['error']) && $_GET['error'] == 1) {
	$error = "An unknown error occurred while registering your account. Please try again. If this error
	          occurs again, please send an email to info@webeca.com regarding the issue and
			  we'll help you to resolve the problem. We're sorry for any inconvenience.";
}

if (isset($_POST['stage']) && $_POST['stage'] == 'process') {
	if (!isset($_POST['termagree']) || $_POST['termagree'] != "agree") {
		$error = "You must indicate that you accept our terms of service by checking the box below.";
	} else if (!isset($_POST['email']) || !isset($_POST['birthday']) || $_POST['email'] == "" || $_POST['birthday'] == ""){
		$error = "All fields are required.  Please enter all information and retry.";
	} else {
		$patients = getPatientsByEmailInfo($_POST['email']);
		$specificPatients = filterByBirthday($patients, $_POST['birthday']);
		if ($patients == null || count($patients) == 0) {
			$error = "No patients found with the provided email address. Please make sure that you entered it correctly
			          and try again. For security reasons, your email address must be on file with us in order to register.
					  See the above information for more details.";
		} else if ($specificPatients == null || count($specificPatients) == 0) {
			$error = "No patients with the provided email address have that birthday. Please make sure all data is entered correctly
			          and try again. Also, for security reasons, your email address must be on file with us in order to register.";
		} else if (userExists($_POST['email']) || count($patients) > 1) {
			//Either more than one patient with that email, or username must be changed
			$_SESSION['temp_email'] = $_POST['email'];
			$_SESSION['temp_birthday'] = $_POST['birthday'];
			header('location:register_user.php');
		} else {
			//Exactly one patient with that email address & bd, and email is unique - make sure they don't already have an account
			$patient = $patients[0];
			if (patHasUsername($patient)) {
				$error = "<p class=\"error\">A username and password are already on file for the chosen patient. Please
						  <a class=\"basicLink\" href=\"login.php\">Log In</a> to access your account.</p><p class=\"error\">If you
						  remember your username but not your password, please click the following link to <a href=\"reset_password.php\">
						  Reset Your Password</a>.</p><p class=\"error\">If you do not remember your username, please click the following
						  link to <a href=\"forgot_username.php\">Send Your Username to Your Email Address</a>.</p>";
			} else {
				$_SESSION['temp_user'] = $_POST['email'];
				$_SESSION['temp_patient'] = $patient->getFieldValue('uid');
				$_SESSION['temp_db'] = $patient->getDatabaseName();
				header('location:create_temp_password.php');
			}
		}
	}
}

$drawArrow = false;

//Include the header info
$title='EyeCare Associates - Register for an Account';
include("template.php");

$subMenu = "portal_menu.jpg";
include("head.php");

?>

<h1>Register Your Account</h1>
<h2>Your health information privacy and security is important to us.</h2>  <div class="smallItem">In order to create an account online, your email address must already be on file with EyeCare Associates.&nbsp;&nbsp;If it is not currently on file, please
visit any EyeCare Associates location to register your email address with us.&nbsp;&nbsp;Proof of identity, such as a driver's license or valid photo ID, is required.<p>&nbsp;</p>
After registering your email address, we will send you an activation email.&nbsp;&nbsp;<i>Note:</i> You must click on the activation link in the email, and follow the instructions on screen, to fully activate your account.</div>

<div id="errorBox" class="error"><? echo (isset($error)) ? $error : ""; ?></div>
<form action="<?php echo $_SERVER['PHP_SELF'];?>" method="post" id="registerform" name="registerform">
	<input type="hidden" name="stage" value="process" />
	<div>
		<div class="smallItem">
			In order to register for an account, you must agree to our
			<a class="basicLink" href="terms_of_service.php" style="font-weight:bold;">Terms of Service</a>
		</div><p>&nbsp;</p>
		<div class="smallItem">
			<input type="checkbox" id="termagree" name="termagree" value="agree" /><label for="termagree">I ACCEPT the Terms of Service listed above*</label>
            <p>&nbsp;</p>
		</div>
		<table class="formLines1">
			<tr>
				<td><label for="emailBox">Email*: </label></td>
				<td><input id="emailBox" type="text" name="email" size="30" maxlength="50" /></td>
			</tr>
			<tr><td><label for="birthday">Birthdate*: </label></td><td><input type="text" id="birthday" name="birthday" size="30" maxlength="10" /></td><td colspan="2">(Please use MM/DD/YYYY format)</td></tr>
			<tr></tr>
			<tr><td colspan="2" style="padding-top: 10px;"><input type="submit" value="Register" /></td></tr>
		</table>
	</div>
</form>

<br />
<?  include "foot.php"; ?>
