<?
require_once('includes/conf.php');
enforcedSessionStart();

require_once('includes/portalutils.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/patient.php');

$loadData = true;
$error = null;
if (isset($_POST['stage']) && $_POST['stage'] == 'process') {
	if (!isset($_POST['patient']) || !isset($_POST['user']) || $_POST['patient'] == "" || $_POST['user'] == "") {
		$error = "All fields are required.  Please enter a username and select a patient, then try again.";
	} else if (preg_match("/^[\\w\\-\\.@_]+$/", $_POST['user']) !== 1) {
		$error = "Invalid username.  Invalid characters used.  Rules for usernames are described below.";
	} else if (userExists($_POST['user'])) {
		$error = "An account already exists with that username. Usernames must be unique. Please choose a new one.";
	} else {
		$uid = $_POST['patient'];
		$db = $_POST['patient_db_' . $uid];
		$patient = new Patient($db, $uid);

		if (patHasUsername($patient)) {
			$error = "<p class=\"error\">A username and password are already on file for the chosen patient. Please
					<a class=\"basicLink\" href=\"login.php\">Log In</a> to access your account.</p><p class=\"error\">If you
					remember your username but not your password, please click the following link to <a href=\"reset_password.php\">
					Reset Your Password</a>.</p><p class=\"error\">If you do not remember your username, please click the following
					link to <a href=\"forgot_username.php\">Send Your Username to Your Email Address</a>.</p>";
		} else {
			//Unset this page's temp vars
			unset($_SESSION['temp_email']);
			unset($_SESSION['temp_birthday']);
			//Set temp username and password 
			$_SESSION['temp_user'] = $_POST['user'];
			$_SESSION['temp_patient'] = $patient->getFieldValue('uid');
			$_SESSION['temp_db'] = $patient->getDatabaseName();
			//Don't load the rest of this page.  Instead, create the temp password
			$loadData = false;
			header('location:create_temp_password.php');
		}
	}
}

if ($loadData && !(isset($_SESSION['temp_email']) && isset($_SESSION['temp_birthday']))) {
	//Missing some data - don't load the rest of the page.  Instead go back to register.php
	$loadData = false;
	header('location:register.php');
}

if ($loadData) {
	$patientEmail = $_SESSION['temp_email'];
	$birthday = $_SESSION['temp_birthday'];
	$selectedPatient = $_POST['patient'];
	$patients = getPatientsByEmailInfo($patientEmail, $birthday);
	$canUseEmail = !userExists($patientEmail);
	$multiplePatients = count($patients) > 1;

	$drawArrow = false;

	//Include the header info
	$title='EyeCare Associates - Register for an Account';
	include("template.php");

	$subMenu = "portal_menu.jpg";
	include("head.php");
?>

	<h1>Specify Account Information</h1>
	<?
		if (!$canUseEmail) {
			echo "<div class=\"smallItem\">Your email address is already a registered username. 
				  Please choose a different username for your account.</div>";
		}
	?>
	<?
		if ($multiplePatients) {
			echo "<div class=\"smallItem\">Multiple patients share your email address and birthday.
				  Please choose the correct patient and enter a username, then click \"Register\".</div>";
		}
	?>

	<div class="smallItem">If your name does not appear here, your email address may not be on
	file with us. For security reasons, in order to register here, your email address must
	already be on file with us. If it is not currently on file, please visit any EyeCare Associates location. In order to register your email address with us, you will be asked to
	present proof of identity, such as a driver's license or valid photo ID.</div>


	<div class="smallItem">Upon successful registration, you will receive an activation email.  Your
	account will only be active upon following the activation link you receive in the email.</div>

	<div id="errorBox" class="error"><? echo (isset($error)) ? $error : ""; ?></div>
	<form action="<?php echo $_SERVER['PHP_SELF'];?>" method="post" id="registerform" name="registerform">
		<input type="hidden" name="stage" value="process" />
		<div>
			<table class="formLines">
				<tr><td>Patient: </td><td colspan="2"><div id="patientArea">
					<? include("patient_query.php"); ?>
				</div></td></tr>
				<tr>
					<td colspan="3"><div style="margin-top: 8px; margin-bottom: 8px;"><strong>
						Usernames can only contain alphanumeric characters (A-Z, a-z, and 0-9),<br />
						as well as the following four special characters: @ . - _
					</strong></div></td>
				</tr>
				<tr>
					<td><label for="user">Choose Username: </label></td>
					<td><input id="user" type="text" name="user"<? 
						if (isset($_POST['user'])) {
							echo " value=\"" . $_POST['user'] . "\"";
						} else {
							echo ($canUseEmail ? " value=\"$patientEmail\"" : "");
						}
					?> size="30" maxlength="255" /></td>
					<td></td>
				</tr>
				<?
					if ($canUseEmail) {
						echo "<tr><td colspan=\"3\">(Can be your email address)</td></tr>";
					}
				?>
				<tr><td colspan="3" style="padding-top: 10px;"><input type="submit" value="Register" /></td></tr>
			</table>
		</div>
	</form>

	<br />
<?
	include "foot.php";
} //end if loadData
?>
