<?
require_once('includes/conf.php');
enforcedSessionStart();

require_once('includes/portalutils.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/backend/axis/GetLastProviderSeenMessage.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/backend/axis/GetCurrentContactRxsMessage.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/backend/axis/GetCurrentExamRxsMessage.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/backend/axis/GetCurrentLensRxsMessage.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/backend/axis/SendRxRequestMessage.php');

$mainPatient = getPatient();
$patient = new Patient(null);
$patUID = $_POST['patient'];
if ($patUID == null && $_SESSION['rxRequestPatient'] != null) {
	//Patient was set with a session variable.  Get the UID from there.
	$patUID = $_SESSION['rxRequestPatient'];
	$_SESSION['rxRequestPatient'] = null;
}
if (!$patient->setFromFirstWhere('uid', $patUID, '=')) {
	$patient = null;
}
if ($patient == null) {
	$_SESSION['rx_request_error'] = "Could not request prescriptions: you can only request prescriptions for a patient under this account.";
	header("location:portal_main.php?error=rx_request_error");
} else if (($patient->getFieldValue('uid') != $mainPatient->getFieldValue('uid')) && !userHasChild($patient->getFieldValue('uid'))) {
	$_SESSION['rx_request_error'] = "Could not request prescriptions: you can only request prescriptions for a patient under this account (i.e., for yourself or one of your children).";
	header("location:portal_main.php?error=rx_request_error");
} else {
	$patUID = $patient->getFieldValue('uid');

	$getContacts = ($_POST['contacts'] == 1 || $_SESSION['rxRequestContacts'] == 1);
	$getExamLens = ($_POST['examLens'] == 1 || $_SESSION['rxRequestExamLens'] == 1);
	
	//Get contact prescriptions
	if ($getContacts) {
		try {
			$msg = new GetCurrentContactRxsMessage('cec_portal');
			$clRxs = $msg->getCurrentContactRxs($patUID);
		} catch (Exception $e) {
			klog("Error loading recent contact prescriptions:\n" . dump($e), KLogger::ERROR);
			$error = "Error loading recent contact prescriptions";
		}
	}
	if ($getExamLens) {
		//Get exam prescriptions
		try {
			$msg = new GetCurrentExamRxsMessage('cec_portal');
			$examRxs = $msg->getCurrentExamRxs($patUID);
		} catch (Exception $e) {
			klog("Error loading recent exam prescriptions:\n" . dump($e), KLogger::ERROR);
			$error = "Error loading recent prescriptions";
		}
		//Get lens prescriptions
		try {
			$msg = new GetCurrentLensRxsMessage('cec_portal');
			$lensRxs = $msg->getCurrentLensRxs($patUID);
		} catch (Exception $e) {
			klog("Error loading recent lens prescriptions:\n" . dump($e), KLogger::ERROR);
			$error = "Error loading recent eyeglass prescriptions";
		}
	}
	
	if (isset($error)) {
		$_SESSION['rx_request_error'] = $error;
		header("location:portal_main.php?error=rx_request_error");
	} else if ((!isset($clRxs) || count($clRxs) == 0) && (!isset($examRxs) || count($examRxs) == 0) && (!isset($lensRxs) || count($lensRxs) == 0)) {
		$typeStr = '';
		if ($getExamLens && !$getContacts) {
			$typeStr = ' glasses';
		} else if ($getContacts && !$getExamLens) {
			$typeStr = ' contact lens';
		}
		$_SESSION['rx_request_error'] = "Sorry, you do not have any recent$typeStr prescriptions with EyeCare Associates.";
		header("location:portal_main.php?error=rx_request_error");
	} else {
		//Send the message containing the rx's found.
		//$msg = new SendRxMessageMessage('cec_messaging');
		$msg = new GetLastProviderSeenMessage('cec_portal');
		try {
			//This message can't run without the currently non-existent email template.  For now, just do if (true).
			//if ($msg->sendRxMessage($patUID, $finalLensRxs, $finalContactRxs, $clrxToCome)) {
			$employee = $msg->getLastProviderSeen($patUID);
			if ($employee != null) {
				$empUID = $employee->getFieldValue('uid');
				$msg = new SendRxRequestMessage('cec_messaging');
				try {
					$msg->sendRxRequest($patUID, $empUID);
					header("location:rx_request_success.php");
				} catch (Exception $e) {
					klog("Call to sendFinalRxMessage($empUID, $patUID) failed.  See Washington log for details.", KLogger::ERROR);
					$_SESSION['rx_request_error'] = 'An unexpected error occurred while requesting recent prescriptions.  Please try again later.';
					header("location:portal_main.php?error=rx_request_error");
				}
			} else {
				$_SESSION['rx_request_error'] = 'All prescription requests must be finalized by a doctor, and you do not appear to have a recent exam with EyeCare Associates.  Please contact info@webeca.com and we will do our best to provide you with your most recent prescription(s).';
				header("location:portal_main.php?error=rx_request_error");
			}
		} catch (Exception $e) {
			klog("Error requesting final prescriptions\n" . dump($e), KLogger::ERROR);
			$_SESSION['rx_request_error'] = 'An unexpected error occurred while requesting recent prescriptions.  Please try again later.  We apologize for any inconvenience this may cause you.';
			header("location:portal_main.php?error=rx_request_error");
		}
	}
}

?>
