<?
require_once('includes/conf.php');
enforcedSessionStart();

require_once('includes/portalutils.php');

$error = null;
if (isset($_POST['stage']) && $_POST['stage'] == 'process') {
	if (!isset($_POST['user']) || $_POST['user'] == "") {
		$error = "Username is required. If you have an email address with us, but haven't chosen a username, please go
		         to our <a class=\"basicLink\" href=\"register.php\">Registration Page</a> to register your account. Questions? Email <a class=\"basicLink\" href=\"mailto:info@webeca.com\">info@webeca.com. </a> ";
	} else if (!isset($_POST['birthday']) || $_POST['birthday'] == "") {
		$error = "For verification of identity, you must enter your birthday.";
	} else {
		$patient = getPatientByUsername($_POST['user']);
		if ($patient == null) {
			$error = "Patient with the given username not found. Please make sure that you entered it correctly and try again.";
		} else if (!isNonFalseMatch(strtotime($_POST['birthday']), strtotime($patient->getFieldValue('birthday')))) {
			$error = "Birth date provided does not match the one on file for the provided user.";
			klog("Birthday didn't match for username " . $_POST['user'] . ":\nEntered: " . $_POST['birthday'] . " -> " . strtotime($_POST['birthday']) . " vs. Expected: " . $patient->getFieldValue('birthday') . " -> " . strtotime($patient->getFieldValue('birthday')), KLogger::INFO);
		} else {
			$_SESSION['temp_user'] = $_POST['user'];
			$_SESSION['temp_patient'] = $patient->getFieldValue('uid');
			$_SESSION['temp_db'] = $patient->getDatabaseName();
			header('location:create_temp_password.php?reset=1');
		}
	}
}

$drawArrow = false;

//Include the header info
$title='EyeCare Associates - Reset Account Password';
include("template.php");

$subMenu = "portal_menu.jpg";

//Don't show timeout warnings on the reset password page.
$initializeTimeout = false;
include("head.php");

?>

<h1>Reset Your Password</h1>
<div class="smallItem">
  <p>Upon clicking &quot;Reset Password&quot; your account  may only be activated through the link received in the reset email (your old password will no longer work and will require a reset).</p>
</div>

<div id="portal-box2">
<div id="errorBox" class="error"><? echo (isset($error)) ? $error : ""; ?></div>
<form action="<?php echo $_SERVER['PHP_SELF'];?>" method="post" id="registerform" name="registerform">
	<input type="hidden" name="stage" value="process" />
	<div>
		<table width="575" class="formLines">
			<tr><td width="9">&nbsp;</td><td width="151"><div class="smallItem">Username/Email: </div></td>
			  <td width="462"><input type="text" id="user" name="user" size="30" maxlength="255" /></td>
			</tr>
			<tr><td>&nbsp;</td><td><div class="smallItem">Birthdate: </div></td>
			  <td><input id="birthday" type="text" name="birthday" size="12" maxlength="10" />			    (Please use MM/DD/YYYY format)</td>
			</tr>
			<tr><td>&nbsp;</td>
			  <td>&nbsp;</td>
			  <td><span style="padding-top: 10px;">
			    <input type="submit" value="Reset Password" />
			  </span></td>
			</tr>
		</table>
	</div>
</form>
</div>
<br />
<?  include "foot.php"; ?>