<?

session_start();

require_once('includes/includes.php');
require_once('includes/portalutils.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/currencyformatter.php');

//First see if the form has already been submitted:
/*$error = null;
if (isset($_POST['stage']) && $_POST['stage'] == 'process') {
	if ((!isset($_POST['email'])) || (trim($_POST['email']) == '')) {
		$error = "Must specify an email address for the receipt";
	} else {
		$done = true;
		header('location:pay_invoice.php?email=' . urlencode($_POST['email']));
	}
}*/
$error = null;
if (isset($_GET['error']) && $_GET['error'] == 1) {
	$error = "The credit card information you entered was invalid.  Please make sure you entered " .
			"everything correctly, and that the card hasn't expired, and try again.";
}

//Don't do the rest if patient is already done with the form
if (!$done) {
	//Check that a patient has logged in (or at least chosen a superbill)
	$patient = getPatient();

	//Check that a superbill has been selected
	$superbill = getSuperbill();

	$logged_in = isset($patient) && isset($superbill);

	if (!$logged_in) {
		header('location:choose_invoice.php');
	} else {
		//GET RID OF THIS!!! - Randomly adds either collections or a purchase
		/*$r = rand(0, 2);
		if ($r == 0) {
			$superbill->addSalesLog(SalesLog::$COLLECTIONS_CODE);
		}*/
		$drawArrow = true;
		$arrowPos = 427;

		//Include the header info
		$title='EyeCare Associates - Pay Bill (invoice #' . $superbill->getSuperbillNumber() . ')';
		include("template.php");
		
		$topMenu = "insurancetop.swf";
		$topMenuName = "insurancetop";
		$subMenu = "billpay_menu.jpg";
		$subMenuName = "billpay_menu";
		$allowToChoose = isLoggedIn($patient);
		$whichPageNum = 3;
		include("head.php");
		
		if (!userCanSeeSuperbill($patient, $superbill)) {
			echo "<h2 class=\"error\">You are not authorized to view this invoice. Please go back and 
				  <a href=\"choose_invoice.php\" class=\"basicLink\">Select an Invoice</a></h2>";
		} else if ($error != null) {
			echo "<h2 class=\"orange\">Invalid Data</h2><p class=\"error\">$error</p>";
		} else {
			//Add the script that validates the form
?>
			<script type="text/javascript">
				function submitForm() {
					var isOkay = true;
					//Verify that all credit card fields are entered
					var ids = "#expmonth,#expyear,#ccnumber,#cardname";
					
					$(ids).each(function() {
						if ($(this).val() == "") {
							//Slide down info box moderately fast
							//alert('Please fill in all of the required Bill To fields.');
							$('#missingCC').hide();
							$('#missingCC').text("All credit card information fields are required.  Please fill in these fields.");
							$('#missingCC').slideDown(400);
							isOkay = false;
							return false;
						}
					});
					
					if (isOkay && document.getElementById('email').value != '') {
						//document.forms[0].submit();
						submitOnce(0);
					} else if (isOkay) {
						//alert('Please fill in all of the required fields.');
						$('#missingCC').hide();
						$('#missingCC').text("You must specify an email address for the receipt.");
						$('#missingCC').slideDown(400);
					}
				}
			</script>
<?
			//Set the billing info defaults array based on either previously set billing info or the patient's array
			if (isset($_SESSION['billto'])) {
				$billingArray = $_SESSION['billto'];
			} else {
				$billingArray = $patient->getFields(array('firstname', 'lastname', 'address', 'city', 'state', 'zip', 'homephone'));
			}
			
			$completed = false;
			echo "<form action=\"pay_invoice.php\" method=\"post\">\n";
			include('invoice_summary.php');
			
			if (!($patBalance < 0.01 || $superbill->codeExists(SalesLog::$COLLECTIONS_CODE))) {
?>
				<p>
					<input type="hidden" name="stage" value="process" />
					Email: <input type="text" name="email" id="email" value="<?
						$email = $patient->getFieldValue('email');
						if (isset($email)) {
							echo strtolower($email);
						}
					?>" size="40" maxlength="50" />
					<div class="smallItem">Email address is required for sending a billing receipt. Setting your email here
										   does not affect any email address you have on file with EyeCare Associates.</div>
					<div class="smallItem">Once you hit 'submit', your transaction will be processed. If approved, your
										   credit card will be billed, and you will be shown and emailed a receipt.</div>
					<div class="smallItem">After being billed, your payment cannot be refunded online. If you wish to receive
										   a refund, you must then call 636-200-4393, extension 3000.</div>
					<div id="missingCC" style="display: none;" class="error"></div>
					<p><input type="button" value="Pay Now" onclick="submitForm()" /></p>
				</p>
				</form>
				<br>
<?
			} //end if superbill has balance
			include "foot.php";
		} //end if correct patient
	} //end if logged in
} //end if already done
?>