<?
require_once('includes/conf.php');
enforcedSessionStart();

require_once('includes/portalutils.php');
require_once('schedule_details.php');
require_once('send_appointment_confirmation.php');
require_once(GLOBAL_INCLUDES_DIR . 'washington_utils.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/location.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/dateformatter.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/datafieldnameformatter.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/fullnameformatter.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/donothingformatter.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/phonenumberformatter.php');

//Include the header info
$title='EyeCare Associates - Schedule an Appointment';
include("template.php");

$subMenu = "schedule_menu.jpg";
$subMenuName = "schedule_menu";
$patient = getPatient(false);
$allowToChoose = isLoggedIn($patient);
$drawArrow = true;
$arrowPos = 434;
$whichPageNum = 3;
$rightPadding = 100;
$selectedProvider = $_SESSION['selected_provider'];

include("head.php");

$dateFormatter = new DateFormatter('m/d/Y');
$timeFormatter = new DateFormatter('h:i A');
$dbTimeFormatter = new DateFormatter('H:i:s');
$dbDateFormatter = new DateFormatter('Y-m-d');
$schedulePatient = getSchedulePatient(true);
$locationUID = $_SESSION['schedule_location'];
$locationDB = $_SESSION['schedule_location_db'];
$location = new Location($locationDB);
$noLoc = false;
$notesCols = ($isMobile ? 40 : 60);
if ($locationUID == null) {
	$noLoc = true;
} else {
	if (!$location->setFromFirstWhere('uid', $locationUID, '=', array($locationDB), true)) {
		$noLoc = true;
	} else if ($schedulePatient == null) {
		$error = "You cannot skip the previous pages.  Please go back to the <a class=\"basicLink\" href=\"schedule_start.php\">" .
				"details page</a> to enter your basic information, and then choose a time slot.";
	} else if ($_SESSION['schedule_time'] == null || $_SESSION['schedule_provider'] == null) {
		$error = "You cannot skip the previous pages.  Please go back to the <a class=\"basicLink\" href=\"schedule_appointment.php\">" .
				"schedule a time page</a> to choose a time slot and (optionally) a provider.";
	}
}
if ($noLoc) {
	if (sessionExpired()) {
		$error = "We're sorry, but your session has been idle too long and has expired.  You must come back here from the ".
				"patient portal's <a class=\"basicLink\" href=\"schedule_choose.php\">Schedule Appointment</a> page, or from " .
				"the <a class=\"basicLink\" href=\"https://www.webeca.com/locations/\">Find a Location</a> page.";
	} else {
		$error = "You must come to this page from the <a class=\"basicLink\" href=\"https://www.webeca.com/locations/\">" .
				"Find a Location</a> page, or from the patient portal's <a class=\"basicLink\" href=\"schedule_choose.php\">" .
				"Schedule Appointment</a> page in order to schedule appointments for the appropriate office.";
	}
}

//If there is a fatal error, just show the error and nothing else
if (isset($error)) {
	echo "<div class=\"error\">$error</div>";
} else {
	//Try to load the provider
	$provider = new Provider(null);
	if (!$provider->setFromFirstWhere('uid', $_SESSION['schedule_provider'], '=', array($locationDB), true)) {
		$provider = null;
	}
	if (!isset($_POST['submitted'])) {
		//Not yet submitted - clear any leftover success flag
		unset($_SESSION['schedule_success']);
		//Show the review form
?>
		<h1 class="hide-from-mobile">Review and Submit Appointment</h1>
		<h1 class="hide-from-desktop">Review and Submit</h1>
		<h3 class="orange hide-from-mobile">PLEASE NOTE:</h3>
        <span class="hide-from-mobile">
		<p class="orange boldText">Your appointment will not be finalized until you click the FINALIZE APPOINTMENT button at the bottom of this page.</p>
		<p class="menuItem">For some appointments, with some insurance plans, additional processing may be necessary.
		In a few cases this can cause a delay, requiring us to make changes to your appointment.  If we have any comments
		or concerns with your appointment, we will contact you in order to get them resolved as quickly as possible.</p>
		
		<h3 class="orange">Schedule Details</h3>
		<h4>Please review the details to make sure they are correct, then click the button below to finalize your appointment.</h4>
        </span>
        
        <span class="hide-from-desktop">
		<p class="menuItem"><strong>You are not done. Please review your request below and press submit if correct.</strong></p><br>

		<p class="menuItem"><strong>Please note:</strong> In certain cases we may contact you to suggest a different appointment time due to unforeseen scheduling issues, or insurance requirements.</p><br>

        </span>
		
		<? echo getScheduleDetails($location, $schedulePatient, $provider, !$isMobile); ?>
		<!-- Spacer -->
		<div>&nbsp;</div>
		<form action="schedule_confirmation.php" method="post">
			<input type="hidden" name="submitted" value="1" />
			<input type="hidden" name="selected_provider" value="<? echo $selectedProvider; ?>" />
			<div class="smallItem">If you would like to leave any notes for your exam, please enter them here</div>
			<div style="margin-top:4px;"><textarea id="notes" name="notes" rows="5" cols="<? echo $notesCols; ?>"></textarea></div>
			<div style="margin-top:4px;"> </div>
			<div class="smallItem">If you need any special accommodations, please select them here:</div>
			<div style="margin-top:4px;"><select name="accommodations" id="accommodations">
<option value="- Please Select -" selected>- Please Select -</option>
<option value="Hearing Impairment">Hearing Impairment</option>
<option value="Wheelchair accessibility">Wheelchair accessibility</option>
<option value="Language translator">Language translator</option>
</select></div>
			<div style="margin-top:8px; font-weight: bold;"><input style="font-weight: bold;" type="submit" value="FINALIZE APPOINTMENT" /></div>
		</form>
		<!-- Spacer -->
		<div>&nbsp;</div>
        
<? 
		
	} //End if form was submitted
} //End if no fatal errors
include("foot.php");
?>

<script
	src="https://code.jquery.com/jquery-3.3.1.js"
	integrity="sha256-2Kok7MbOyxpgUVvAk/HJ2jigOSYS2auK4Pfzbm7uH60="
	crossorigin="anonymous"></script>
  	<script type="text/javascript">
				$("#accommodations").on("change", function () {

				var notes = $('#notes'); 

					if ($('#accommodations').val() == 'Hearing Impairment') {
						notes.val(notes.val() + 'Accommodation: Hearing Impairment   ');           
					} else if  ($('#accommodations').val() == 'Wheelchair accessibility') {
						notes.val(notes.val() + 'Accommodation: Wheelchair accessibility   ');           
					} else if  ($('#accommodations').val() == 'Language translator') {
						notes.val(notes.val() + 'Accommodation: Language translator   ');           
					} else {
						$('#notes').val('');
					}
				});
	</script>
