<?
require_once('includes/conf.php');
enforcedSessionStart();

require_once('includes/includes.php');
require_once('includes/portalutils.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/fullnameformatter.php');

//Make sure patient is logged in first
$fnf = new FullNameFormatter(null, false);
$mainPatient = getPatient();
$logged_in = isLoggedIn($mainPatient);

if (!$logged_in) {
	$_SESSION['referral_page'] = $_SERVER['PHP_SELF'];
	header('location:login.php');
} else {
	$patients = getAllUnderAccount($mainPatient);
	
	//if (count($patients) == 1) {
		//$_SESSION['rxRequestPatient'] = $mainPatient->getFieldValue('uid');
		//$_SESSION['rxRequestContacts'] = 1;
		//$_SESSION['rxRequestExamLens'] = 1;
		//header('location:request_recent_rxs.php');
	//} else {
		//Include the header info
		include("template.php");
		
		$title='Request Recent Prescriptions';
		include("head.php");
		
		?>

		<h1>Request Recent Prescriptions</h1>
        <p>You may request most recent exam and contact lens prescriptions for anyone associated with this account by choosing the patient name below. Once we receive your request a patient care specialist will review the patient chart and respond within 48 hours to the email address on file.</p>
		<div id="errorDiv" class="error" style="display:none;"></div>
		<script type="text/javascript">
			function validateRequest() {
				if ($("input[@name='patient']:checked").length < 0) {
					$("#errorDiv").html("You must select a patient under your account for whom to request prescriptions.");
					$("#errorDiv").show();
				} else {
					$("#requestForm").submit();
				}
			}
		</script>
		<form id="requestForm" action="request_recent_rxs.php" method="POST">
			<? //TODO - Allow user to choose these? ?>
			<input type="hidden" name="contacts" value="1" />
			<input type="hidden" name="examLens" value="1" />
	<?
		if (isset($patients)) {
			if (count($patients) > 0) {
				echo "<h2 class=\"orange\">Choose Patient</h2>\n<div class=\"spaced\">";
				echo "<div class=\"basicmedium\">Request recent prescriptions for:</div>";
				foreach ($patients as $patient) {
					$patUID = $patient->getFieldValue('uid');
					echo "<div class=\"basicMedium boldText\"><label for=\"patient_$patUID\">";
					//This is another patient, allow user to choose them
					echo "<input type=\"radio\" id=\"patient_$patUID\" name=\"patient\" value=\"$patUID\" required=\"required\" />";
					echo $fnf->format($patient) . "</label></div>\n";
				}
				echo "</div>\n";
				echo "<input type=\"submit\" value=\"Request Prescriptions\" onclick=\"validateRequest();\" />";
			} else if (count($patients) == 0) {
				//This should never happen, but it never hurts to be sure.
				echo "<div class=\"error\">You must be logged into the patient portal in order to request recent prescriptions.  Please <a class=\"basicLink\" href=\"login.php\">log in</a> first.</div>";
			}
		}
		echo "</form>";
		include "foot.php";
	} //End if there's more than one patient from which to choose
//} //end if logged in
?>
