
<?
require_once('includes/conf.php');
enforcedSessionStart();

require_once('includes/portalutils.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/location.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/fullnameformatter.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/firstperwordcapsformatter.php');
require_once(GLOBAL_INCLUDES_DIR . 'crystalLake/uitools.php');

if (isset($_POST['schedule_time']) && isset($_POST['schedule_provider'])) {
	$_SESSION['schedule_time'] = $_POST['schedule_time'];
	$_SESSION['schedule_provider'] = $_POST['schedule_provider'];
	$_SESSION['schedule_app_type'] = $_POST['app_type'];
	$_SESSION['schedule_template_type'] = $_POST['template_type'];
	$_SESSION['schedule_app_uid'] = generateUID();
	$_SESSION['selected_provider'] = $_POST['selected_provider'];
	header('location:review_schedule.php');
} else {
	//Include the header info
	$title='EyeCare Associates - Schedule an Appointment';
	include("template.php");

	$subMenu = "schedule_menu.jpg";
	$subMenuName = "schedule_menu";
	$patient = getPatient(false);
	$allowToChoose = isLoggedIn($patient);
	$drawArrow = true;
	$arrowPos = 340;
	$whichPageNum = 2;
	$rightPadding = 130;
	$fixedSize=true;
	include("head.php");

	//Load the data from the previous page
	$schedulePatient = getSchedulePatient(true);
	$locationUID = $_SESSION['schedule_location'];
	$locationDB = $_SESSION['schedule_location_db'];
	$location = new Location($locationDB);
	$noLoc = false;
	if ($locationUID == null || $locationDB == null) {
		$noLoc = true;
	} else {
		if (!$location->setFromFirstWhere('uid', $locationUID, '=', array($locationDB), true)) {
			$noLoc = true;
		} else if ($schedulePatient == null) {
			$error = "You cannot skip the previous page.  Please go back to the <a class=\"basicLink\" href=\"schedule_start.php\">" .
					"details page</a> to enter your basic information before choosing a time slot.";
		}
	}
	if (isset($_SESSION['schedule_success']) && $_SESSION['schedule_success'] != null) {
		//The patient has already scheduled an appointment.
		$error = "You have already scheduled this appointment.  If you would like to schedule for another family member, " .
				"please <a href=\"clear_redirect.php?family=1&target=" . urlencode('/portal/schedule_step3.php?alt=1') . "\" " .
				"class=\"basicLink\">click here</a>.";
	}
	if ($noLoc) {
		if (sessionExpired()) {
			$error = "We're sorry, but your session has been idle too long and has expired.  You must come back here from the ".
					"patient portal's <a class=\"basicLink\" href=\"schedule_choose.php\">Schedule Appointment</a> page, or from " .
					"the <a class=\"basicLink\" href=\"https://www.webeca.com/locations/\">Find a Location</a> page.";
		} else {
			$error = "You must come to this page from the <a class=\"basicLink\" href=\"https://www.webeca.com/locations/\">" .
					"Find a Location</a> page, or from the patient portal's <a class=\"basicLink\" href=\"schedule_choose.php\">" .
					"Schedule Appointment</a> page in order to schedule appointments for the appropriate office.";
		}
	}

	/* $axisServer = findAxisServerFor($location->getDatabaseName());
	if ($axisServer == null) {
		$error = "Cannot find doctors - could not find the server.  Please go back to the <a class=\"basicLink\"
				href=\"https://www.webeca.com/locations/\">Find a Location</a> page, or the patient
				portal's <a class=\"basicLink\" href=\"schedule_choose.php\">Schedule Appointment</a> page and try again.";
	} */
	$axisServer = 'cec_axis';
	//If there is a fatal error, just show the error and nothing else
	if (isset($error)) {
		echo "<div class=\"error\">$error</div>";
	} else {
		$lastProvider = null;
		if ($schedulePatient->getFieldValue('uid') != RESERVED_PATIENT) {
			//It's not the reserved patient - choose the patient's last appointment's provider.
			$lastVisit = getLastVisitFor($schedulePatient);
			if ($lastVisit != null) {
				$lastProvider = $lastVisit->getFieldValue('provider');
			}
		}
		//Load the schedule options given the specific location
	?>
		<h1>Schedule Your Appointment</h1>
		<h3 class="orange">Choose a Doctor</h3>
		<?
		$allProviders = getAllProvidersFor($location->getFieldValue('uid'), array($location->getDatabaseName()));
		try {
			$scheduledProviderUIDs = getScheduledProvidersFor($location->getFieldValue('uid'), $axisServer);
		} catch (Exception $e) {
			$scheduledProviderUIDs = null;
		}
		$scheduledProviders = array();
		$unscheduledProviders = array();
		if ((!isset($scheduledProviderUIDs)) || (!is_array($scheduledProviderUIDs))) {
			echo "<div class=\"error\">The website failed to find the requested doctors.  " .
					"Please refresh the page and try again.</div>";
		} else {
			foreach ($allProviders as $provider) {
				if (in_array($provider->getFieldValue('uid'), $scheduledProviderUIDs)) {
					$scheduledProviders[] = $provider;
				} else {
					$unscheduledProviders[] = $provider;
				}
			}
			//The second array is in case we want to show all providers, but to just show the first ones first.
			$format = new FullNameFormatter();
			$providerBox = UITools::getDataHolderComboBox($scheduledProviders, 'uid', $format, '', array("id"=>"providerBox", "name"=>"providerBox"));
			//Create a provider named "ALL PROVIDERS" with uid=0
			$providerBox->addRow(new MapOption('0', 'Any Doctor', null), true);
			$providerBox->addRow(new MapOption('', 'Please Choose', null), true);
			$providerNotChosenHTML = "<p class=\"menuItem\">After you choose your doctor, appointment times will appear here.</p>";
			if ($lastProvider != null) {
				$format2 = new FullNameFormatter(null, false);
				$provider = null;
				foreach ($allProviders as $scheduledProvider) {
					if ($scheduledProvider->getFieldValue('uid') == $lastProvider) {
						$provider = $scheduledProvider;
					}
				}
				if ($provider != null) {
					if (in_array($lastProvider, $scheduledProviderUIDs)) {
						echo "<p id=\"lastProvider\" class=\"menuItem\">Your last appointment was with Dr. " . $format2->format($provider) .
								".  This doctor will be chosen automatically when the page loads, but you may choose another doctor " .
								"(or \"Any Doctor\") if you wish.</p>";
					} else {
						$locFormat = new FirstPerWordCapsFormatter();
						$providerName = $format2->format($provider);
						$locName = $locFormat->format($location->getFieldValue('name'));
						echo "<p id=\"lastProvider\" class=\"menuItem\">Your last appointment was with Dr. " . $providerName . ".  This " .
								"doctor is not currently seeing patients at $locName, and thus does not appear in the options below.  Please " .
								"choose another doctor, or choose \"Any Doctor\" if you do not require a specific doctor in the list.</p>";
					}
				}
			}
			echo $providerBox . "\n";
		}
		?>
		<script type="text/javascript">
			var currentWeek = 0;
			var direction = 1;
			var maxWeeks = 9;
			var autoLoad = true;

			//Update the schedule whenever a provider is chosen
			$("#providerBox").change(function() {
				currentWeek = 0;
				direction = 1;
				autoLoad = false;
				updateSchedule();
			});

			<? if ($lastProvider != null && in_array($lastProvider, $scheduledProviderUIDs)) { ?>
				$(document).ready(function() {
					if (autoLoad) {
						$("#providerBox").val('<? echo $lastProvider; ?>');
						$("#providerBox").change();
					}
				});
			<? } ?>

			//Update the schedule to reflect any changes
			function updateSchedule() {
				var providerUID=$("#providerBox").val();

				if (providerUID == null || providerUID == '') {
					$("#scheduler").html('<? echo str_replace("'", "\'", $providerNotChosenHTML); ?>');
				} else {
					var errorP = document.getElementById('emptyScheduleInfo');
					if (errorP != null) {
						var innerHTML = errorP.innerHTML;
						$("#scheduler").html('<p class="menuItem">' + innerHTML + '</p><p class="menuItem">' +
								'Loading the ' + (direction > 0 ? 'next' : 'previous') + ' week...</p>');
					} else {
						$("#scheduler").html('<h4>Loading schedule.  Please wait...</h4>');
					}
					//Use the chosen provider (stored in providerUID) to calculate schedule entries
					var args = { week: currentWeek, provider: providerUID, maxWeeks: maxWeeks };
					//Post to get_schedule.php, and fill the scheduler element with the response
					$.post("get_schedule.php", args, function(data) {
						$("#scheduler").html(data);
						var errorP = document.getElementById('emptyScheduleInfo');
						if (errorP != null && currentWeek + direction <= maxWeeks && currentWeek + direction >= 0) {
							currentWeek += direction;
							updateSchedule();
						}
					});
				}
			}
		</script>
		<!-- <p style="font-size: 12px;"><em>(Please note our <a href="http://webeca.com/PDFs/CEC-Late-Arrival-Policy.pdf" target="_blank">Late Arrival Policy</a></em>)</p><br /> -->
		<h3 class="orange">Choose Your Time</h3>
		<div id="scheduler">
			<? echo $providerNotChosenHTML; ?>
		</div>
<?
	} //End if no fatal errors
	include("foot.php");
} //End if we should load the page at all
?>
