<?
require_once('includes/conf.php');
enforcedSessionStart();

require_once('includes/portalutils.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/holderfieldformatter.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/firstperwordcapsformatter.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/zipcodeformatter.php');

if ((!isset($_GET['loc'])) && (!isset($_SESSION['loc']))) {
	$error = "You must come to this page from the main site's <a class=\"basicLink\" href=\"https://www.webeca.com/locations/\">" .
			"Schedule an Appointment</a> page, or from the patient portal's <a class=\"basicLink\" href=\"schedule_choose.php\">" .
			"Schedule Appointment</a> page in order to schedule appointments for the appropriate office.";
}

$useAlternate = (isset($_GET['alt']) && $_GET['alt'] == 1);
$patient = getPatient(true);
$logged_in = isset($patient);
//$usingLoggedInUser = false;

if ($logged_in) {
	//Include the header info
	$title='EyeCare Associates - Schedule an Appointment';
	include("template.php");

	$subMenu = "portal_menu.jpg";
	$subMenuName = "schedule_menu";
	$allowToChoose = true;
	$drawArrow = false;
	$whichPageNum = 0;
	include("head.php");
	
	echo "<h1>Schedule Appointments</h1>\n";
	$lastDPL = getLastFullExamDPLForPatient($patient);
		if ($lastDPL != null) {
			$dateFormatter = new DateFormatter();
			$lastDate = $lastDPL->getFieldValue('date');
			$overOneYear = false;
			if ($lastDate != null) {
				$lastDateLong = add_date(strtotime($lastDate), 1);
				$overOneYear = ($lastDateLong < strtotime("today"));
				$lastApp = getLastAppointmentForPatient($patient);
				//Don't give the over one year prompt if the patient is already scheduled for an exam for a future date.
				$overOneYear = $overOneYear && ($lastApp == null || strtotime($lastApp->getFieldValue('date')) < strtotime("today"));
			}
			if ($overOneYear) {
				echo "<p class=\"menuItem\">Your last Well Eye Exam was over a year ago.  We recommend getting your eyes checked every 12 months.</p>";
			}
			
			echo "<p class=\"menuItem\">Most insurance plans require 12 months between Well Eye Exam visits";
			echo ".  Your last exam was on " . $dateFormatter->format($lastDate);
			echo ".  Please call us if you have questions about your eligibility for benefits.</p><br>";
		}
	$lastApp = getLastAppointmentForPatient($patient);
	if ($lastApp != null) {
		//Format the location by getting its name
		$lastLocationUID = $lastApp->getFieldValue('location');
		$lastLocation = new Location($lastApp->getDatabaseName(), $lastLocationUID);
		$formatter = new HolderFieldFormatter('name', new FirstPerWordCapsFormatter());
		$lastLocationName = $formatter->format($lastLocation);
		//Now we use the UID, not the location number
		//$lastLocationNum = $lastLocation->getFieldValue('location_number');
		$lastLocationNum = $lastLocationUID;
		$hasMoved = false;
		
		//If the location has moved, show a special message
		if (hasNewLocation($lastLocationUID)) {
			$hasMoved = true;
			$zipFormat = new ZipCodeFormatter();
			$movedLocation = getNewLocation($lastLocationUID);
			$movedLocationName = $formatter->format($movedLocation);
			//Now we use the UID, not the location number
			//$lastLocationNum = $movedLocation->getFieldValue('location_number');
			$lastLocationNum = $movedLocation->getFieldValue('uid');
			$movedLocationAddress = $movedLocation->getFieldValue('address') . "<br />\n";
			$movedLocationAddress .= $movedLocation->getFieldValue('city') . ', ' . $movedLocation->getFieldValue('state') .
					" " . $zipFormat->format($movedLocation->getFieldValue('zip')) . "<br />\n";
		}
		
		$unavailableLocs = unserialize(UNAVAILABLE_LOCATIONS);
		$available = (($lastLocation->getFieldValue('available') == 'TRUE') && !in_array($lastLocationUID, $unavailableLocs));
		
		if ($hasMoved) {
			echo "<p class=\"menuItem\">Your last appointment was at our $lastLocationName office.  This office has 
					moved to a new location.  You have 2 options for scheduling appointments:</h4>
				<h2 class=\"orange\">Schedule an appointment at $movedLocationName</h2>
				<p class=\"menuItem\">The $lastLocationName office has moved to our $movedLocationName location:<br />$movedLocationAddress</p>
				<p class=\"menuItem\">
					<a class=\"basicLink\" href=\"schedule_start.php?loc=$lastLocationNum\">Click here</a>
					to schedule an appointment at $movedLocationName</p>
				<h2 class=\"orange\">Schedule for another EyeCare Associates office</h2>
				<p class=\"menuItem\"><a class=\"basicLink\" href=\"https://www.webeca.com/locations/\">Click here</a>
					to choose another location for which to schedule your appointment</p>";
		} else if (!$available) {
			//Patient's last location is unavailable
			echo "<p class=\"menuItem\">Your last appointment was at our $lastLocationName office.  This office is not available for online
				scheduling.  Please <a class=\"basicLink\" href=\"https://www.webeca.com/locations/\">click
				here</a> to choose a location near you in order to schedule an appointment</p>";
		} else {
			echo "<p class=\"menuItem\">Your last appointment was at our $lastLocationName office.  You have 2 options for scheduling appointments:</h4>
				<h2 class=\"orange\">Schedule an appointment at $lastLocationName</h2>
				<p class=\"menuItem\"><a class=\"basicLink\" href=\"schedule_start.php?loc=$lastLocationNum\">Click here</a>
					to schedule an appointment at $lastLocationName</p>
				<h2 class=\"orange\">Schedule for another EyeCare Associates office</h2>
				<p class=\"menuItem\"><a class=\"basicLink\" href=\"https://www.webeca.com/locations/\">Click here</a>
					to choose another location for which to schedule your appointment</p>";
		}
	} else {
		//This should really never happen if they have an account, unless there's an error in the backend
		echo "<p class=\"menuItem\">There are no previous appointments on file.  
			Please <a class=\"basicLink\" href=\"https://www.webeca.com/locations/\">
				click here</a> to choose a EyeCare Associates location near you to schedule an appointment</p>";
	}
}
include("foot.php");
?>
