<?
require_once('includes/conf.php');
enforcedSessionStart();

require_once('includes/portalutils.php');
require_once('schedule_details.php');
require_once('send_appointment_confirmation.php');
require_once(GLOBAL_INCLUDES_DIR . 'washington_utils.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/location.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/dateformatter.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/datafieldnameformatter.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/fullnameformatter.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/donothingformatter.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/phonenumberformatter.php');

//Include the header info
$title='EyeCare Associates - Schedule Appointment Confirmation';
include("template.php");

$subMenu = "schedule_menu.jpg";
$subMenuName = "schedule_menu";
$patient = getPatient(false);
$allowToChoose = isLoggedIn($patient);
$drawArrow = true;
$arrowPos = 434;
$whichPageNum = 3;
$rightPadding = 100;
$selectedProvider = $_SESSION['selected_provider'];

include("head.php");

$dateFormatter = new DateFormatter('m/d/Y');
$timeFormatter = new DateFormatter('h:i A');
$dbTimeFormatter = new DateFormatter('H:i:s');
$dbDateFormatter = new DateFormatter('Y-m-d');
$schedulePatient = getSchedulePatient(true);
$locationUID = $_SESSION['schedule_location'];
$locationDB = $_SESSION['schedule_location_db'];
$location = new Location($locationDB);
$noLoc = false;
$notesCols = ($isMobile ? 40 : 60);

if ($locationUID == null) {
	$noLoc = true;
} else {
	if (!$location->setFromFirstWhere('uid', $locationUID, '=', array($locationDB), true)) {
		$noLoc = true;
	} else if ($schedulePatient == null) {
		$error = "You cannot skip the previous pages.  Please go back to the <a class=\"basicLink\" href=\"schedule_start.php\">" .
				"details page</a> to enter your basic information, and then choose a time slot.";
	} else if ($_SESSION['schedule_time'] == null || $_SESSION['schedule_provider'] == null) {
		$error = "You cannot skip the previous pages.  Please go back to the <a class=\"basicLink\" href=\"schedule_appointment.php\">" .
				"schedule a time page</a> to choose a time slot and (optionally) a provider.";
	}
}
if ($noLoc) {
	if (sessionExpired()) {
		$error = "We're sorry, but your session has been idle too long and has expired.  You must come back here from the ".
				"patient portal's <a class=\"basicLink\" href=\"schedule_choose.php\">Schedule Appointment</a> page, or from " .
				"the <a class=\"basicLink\" href=\"https://www.webeca.com/locations/\">Find a Location</a> page.";
	} else {
		$error = "You must come to this page from the <a class=\"basicLink\" href=\"https://www.webeca.com/locations/\">" .
				"Find a Location</a> page, or from the patient portal's <a class=\"basicLink\" href=\"schedule_choose.php\">" .
				"Schedule Appointment</a> page in order to schedule appointments for the appropriate office.";
	}
}

if (isset($error)) {
	echo "<div class=\"error\">$error</div>";
} else {
	//Try to load the provider
$provider = new Provider(null);
	if (!$provider->setFromFirstWhere('uid', $_SESSION['schedule_provider'], '=', array($locationDB), true)) {
		$provider = null;
	}


$alreadyCreated = (isset($_SESSION['schedule_success']) && $_SESSION['schedule_success'] == $_SESSION['schedule_app_uid']);
		//Don't resubmit the appointment or email if they have already been created
		if (!$alreadyCreated) {
			//If the patient needs the appointment added to their location list, do so here.
			$hasLocation = $schedulePatient->containsLocation($locationUID);
			if ((!$hasLocation) && (RESERVED_PATIENT != $schedulePatient->getFieldValue('uid'))) {
				$locationListStr = $schedulePatient->getFieldValue('location');
				$locationListStr = ($locationListStr == null ? "" : $locationListStr);
				$schedulePatient->setFieldValue('location', $locationListStr . ' ' . $locationUID);
				$schedulePatient->saveData();
				if (isset($updateResult) && count($updateResult) > 0) {
					//Couldn't add the location to the patient - log the error
					$error = "Error adding location $locationUID to patient " . $_SESSION['schedule_patient'] . ":\n" . dump($updateResult);
				} else {
					//Added the location to the patient - log the success
					$logMsg = "Added location $locationUID to " . $_SESSION['schedule_patient'] . "\n";
					klog($logMsg, KLogger::INFO);
				}
			}

			//Don't save the appointment if the patient's location list didn't update.
			if (!isset($error)) {
				//Save the new appointment to the database
				$currentTimestamp = date('Y-m-d H:i:s');
				$appt = new Appointment($locationDB);
				$appt->setFieldValue('uid', $_SESSION['schedule_app_uid']);
				$appt->setFieldValue('time', $dbTimeFormatter->format($_SESSION['schedule_time']));
				$appt->setFieldValue('date', $dbDateFormatter->format($_SESSION['schedule_time']));
				$appt->setFieldValue('patient', $schedulePatient->getFieldValue('uid'));
				//Default to comprehensive exams, if type not set
				if ($_SESSION['schedule_app_type'] == null) {
					$_SESSION['schedule_app_type'] = COMPREHENSIVE_APP_TYPE;
				}
				$appt->setFieldValue('type', $_SESSION['schedule_app_type']);
				$appt->setFieldValue('color', 'FFFFFF');
				$appt->setFieldValue('location', $locationUID);
				$appt->setFieldValue('provider', $_SESSION['schedule_provider']);
				$appt->setFieldValue('confirmed', 'FALSE');
				$appt->setFieldValue('complete', 'FALSE');
				$appt->setFieldValue('notes', "Scheduled online.  Patient notes: " . $_POST['notes']);
				$appt->setFieldValue('provider_template', $_SESSION['schedule_template_type']);
				$appt->setFieldValue('location_stamp', LOCATION_STAMP);
				$appt->setFieldValue('updated_stamp', $currentTimestamp);
				$appt->setFieldValue('created_stamp', $currentTimestamp);
				$updateResult = $appt->saveData();
				if (isset($updateResult) && count($updateResult) > 0) {
					$error = "Error creating appointment for " . $_SESSION['schedule_lastname'] . ", " . $_SESSION['schedule_firstname'] . "(" . $_SESSION['schedule_patient'] . ")\n:" . dump($updateResult);
					$error .= "Should have been for:\n  Email: " . $_SESSION['schedule_email'] . "\n  Appointment: " . $_SESSION['schedule_app_uid'] . "\n";
				} else {
					$logMsg = "Appointment created for " . $_SESSION['schedule_lastname'] . ", " . $_SESSION['schedule_firstname'] . "(" . $_SESSION['schedule_patient'] . ")\n";
					$logMsg .= "Email: " . $_SESSION['schedule_email'] . "\n" . "Appointment: " . $_SESSION['schedule_app_uid'] . "\n";
					klog($logMsg, KLogger::INFO);
				}
			}
			if (!isset($error)) {
				//The appointment has been saved.  Set the last success UID to that of the appointment.
				$_SESSION['schedule_success'] = $_SESSION['schedule_app_uid'];
				//At this point, the appointment has successfully saved - send an email to appointment@webeca.com
				$to = SCHEDULE_MAIL_TO;
				$subject = $location->getFieldValue('name') . " on " . $dateFormatter->format($_SESSION['schedule_time']) .
						" at " . $timeFormatter->format($_SESSION['schedule_time']) . " - Online Scheduler Appointment";
				//$headers = "From:" . SCHEDULE_MAIL_FROM . "\r\nX-Mailer: PHP/" . phpversion();
				$headers = array("From"=>SCHEDULE_MAIL_FROM, "Subject"=>$subject, "X-Mailer"=>"PHP/" . phpversion(), "To"=>SCHEDULE_MAIL_TO);
				$message = "";
				$dfFormatter = new DataFieldNameFormatter('AppType');
				$phoneFormatter = new PhoneNumberFormatter();
				$fullNameFormatter = new FullNameFormatter(new DoNothingFormatter(), true);
				$fields = array('patient', 'designation', 'firstname', 'lastname', 'sex', 'address', 'address2', 'city', 'state',
						'zip', 'phone', 'phone_type', 'email', 'birthday', 'ssn', 'preferred_language', 'has_insurance',
						'insurance', 'insurance_other', 'subscriber_name', 'subscriber_birthday', 'subscriber_sex', 'subscriber_ssn',
						'subscriber_employer', 'subscriber_relationship', 'subscriber_id', 'group_num', 'insurance_phone',
						'location', 'time', 'provider', 'app_type', 'template_type');
				//$boldOpen = "<span style='font-weight: bold;'>";
				//$boldClose = "</span>";
				foreach ($fields as $fieldName) {
					$value = $_SESSION['schedule_' . $fieldName];
					if (isset($value)) {
						if ($fieldName == 'patient') {
							$message .= str_pad("scheduled patient: ", 26, ' ', STR_PAD_LEFT) . $fullNameFormatter->format($schedulePatient) . "\n";
						} else if ($fieldName == 'location') {
							$message .= "\n" . str_pad("office: ", 26, ' ', STR_PAD_LEFT) . $location->getFieldValue('name') . "\n";
						} else if ($fieldName == 'provider') {
							$message .= str_pad("provider: ", 26, ' ', STR_PAD_LEFT) . $fullNameFormatter->format($provider) . "\n";
						} else if ($fieldName == 'insurance') {
							$insurance = new Insurance($locationDB, $value);
							$message .= str_pad("insurance: ", 26, ' ', STR_PAD_LEFT) . $insurance->getFieldValue('name') . "\n";
						} else if ($fieldName == 'birthday' || $fieldName == 'subscriber_birthday') {
							if (strtotime($value) === false) {
								//If it can't convert the string to a date, just return the string itself
								$dateStr = $value;
							} else {
								//If the conversion is possible, use the date formatter
								$dateStr = $dateFormatter->format($value);
							}
							$message .= str_pad(str_replace('_', ' ', $fieldName) . ": ", 26, ' ', STR_PAD_LEFT) . $dateStr . "\n";
						} else if ($fieldName == 'time') {
							$message .= str_pad("date: ", 26, ' ', STR_PAD_LEFT) . $dateFormatter->format($value) . "\n";
							$message .= str_pad("time: ", 26, ' ', STR_PAD_LEFT) . $timeFormatter->format($value) . "\n";
						} else if ($fieldName == 'app_type') {
							$message .= str_pad("appointment type: ", 26, ' ', STR_PAD_LEFT) . $dfFormatter->format($value) . "\n";
						} else if ($fieldName == 'homephone' || $fieldName == 'workphone' || $fieldName == 'cell' || $fieldName == 'phone') {
							$message .= str_pad(str_replace('_', ' ', $fieldName) . ": ", 26, ' ', STR_PAD_LEFT) . $phoneFormatter->format($value) . "\n";
						} else if ($fieldName == 'email') {
							//Email addresses should be in upper case so lower case "L"'s aren't confused with the number "1".
							$message .= str_pad("email: ", 26, ' ', STR_PAD_LEFT) . strtoupper($value) . "\n";
						} else if ($fieldName != 'patient_db' && $fieldName != 'location_db') {
							$message .= str_pad(str_replace('_', ' ', $fieldName) . ": ", 26, ' ', STR_PAD_LEFT) . "$value\n";
						}
					}
				}
				$anyPro = (($selectedProvider == null || $selectedProvider === '0' || $selectedProvider === 0) ? "TRUE" : "FALSE");
				$message .= str_pad("Chose \\\"Any Provider\\\"?" . ": ", 28, ' ', STR_PAD_LEFT) . "$anyPro\n";
				//if (!sendEncryptedEmail(SCHEDULE_MAIL_FROM, $to, $message, $subject, $headers)) {
				$logMsg .= "Email: " . $_SESSION['schedule_email'] . "\n" . "Appointment: " . $_SESSION['schedule_app_uid'] . "\n";
				klog("Sending encrypted e-mail for appointment " . $_SESSION['schedule_app_uid'], KLogger::INFO);
				if (!sendEncryptedPearEmail(SMTP_HOST, SMTP_PORT, APPOINTMENT_SMTP_USERNAME, APPOINTMENT_SMTP_PASSWORD, SCHEDULE_MAIL_FROM, $to, $message, $headers)) {
					$to = ERROR_MAIL_TO;
					$subject = "ERROR - $subject";
					$message = $_SESSION['schedule_lastname'] . ", " . $_SESSION['schedule_firstname'] . "(" . $_SESSION['schedule_patient'] . ")<br>\n";
					$message .= "Patient email address: " . $_SESSION['schedule_email'] . "<br>\n";
					$message .= "Trying to schedule for " . $location->getFieldValue('name') . " on " .
						$dateFormatter->format($_SESSION['schedule_time']) . " at " .
						$timeFormatter->format($_SESSION['schedule_time']) . "<br>\n";
					$message .= "Sending encrypted email to " . SCHEDULE_MAIL_TO . " failed";
					$headers = unserialize(ERROR_MAIL_HEADER_ARRAY);
					$headers['Subject'] = $subject;

					//Log the error, whether or not the error email sends
					klog("Failure to send appointment email for this online appointment:\n$message", KLogger::ERROR);
					if (!pearMail(SMTP_HOST, SMTP_PORT, SMTP_USERNAME, SMTP_PASSWORD, $to, $message, $headers)) {
						$error = "Failure to report error via email.";
					}
				} else {
					klog("Sent encrypted e-mail for appointment " . $_SESSION['schedule_app_uid'], KLogger::INFO);
				}
			} //End if no error so far
		} //End if not already created
		if (isset($error)) {
			echo "
				<h1>An error has occurred!</h1>
				<div class=\"error\">An error occurred while processing the appointment, and the appointment
				was not scheduled.  Please try again.</div>
				<div class=\"smallItem\">If you continue to receive this error, please call your local office to schedule
				your appointment.  We're sorry for any inconvenience.</div>";
			//Log the error, and send an error email
			klog($error, KLogger::ERROR);
			$to = ERROR_MAIL_TO;
			$subject = "Online Scheduler Error";
			$message = "An error occurred on the online scheduler:\n$error";
			$headers = unserialize(ERROR_MAIL_HEADER_ARRAY);
			$headers['Subject'] = $subject;
			pearMail(SMTP_HOST, SMTP_PORT, SMTP_USERNAME, SMTP_PASSWORD, $to, $message, $headers);
		} else {
			$email = $_SESSION['schedule_email'];
			//If appointment was already created, that means the email was also already sent
			$patientEmailSent = $alreadyCreated;
			if (isset($email) && $email != '' && !$patientEmailSent) {
				$patientEmailSent = sendAppointmentConfirmation($location, $_SESSION['schedule_patient'], $_SESSION['schedule_firstname'], $provider, $email);
			}
?>

			<h1>Appointment Scheduled</h1>
			<h4>
				Your appointment has been scheduled.  Here are the details for your appointment
				<?
					if ($patientEmailSent) {
						echo " (a copy of these details has been sent to $email)";
					}
					echo ":";
				?>
			</h4>
			<!-- <div><a href="printable_schedule_details.php" class="basicLink">TODO Printable Version DO THIS!!!!!!!!!!!!!!!!!!!!!!!</a></div> -->
<?
			echo getScheduleDetails($location, $schedulePatient, $provider, true);
			//Spacer
			echo "<div>&nbsp;</div>\n";
?>
			<form action="clear_redirect.php?family=1&target=<? echo urlencode('/portal/schedule_step3.php?alt=1'); ?>" method="post"><input type="submit" name="restart" value="Schedule for Another Family Member" /></form>

<div class="promoarea" style="width: 100%;">
  <h3 class="orange">Current Promotion - expires February 16, 2019.</h3>
  <a href="https://appt.webeca.com/promo/" target="_blank"><img style="width: 70%;" src="promoimage.jpg" width="1110" height="310" alt="Save Big in 2019! $95 Eyeglasses with Single Vision Lenses, $125 Eyeglasses with Progressive Lenses." title="Save Big in 2019! $95 Eyeglasses with Single Vision Lenses, $125 Eyeglasses with Progressive Lenses."/></a> </div>
<?
		} //End if no errors during appointment submit
} //End if no fatal errors
include("foot.php");
?>
