<?

require_once('includes/portalutils.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/location.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/insurance.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/insurancechoiceformatter.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/donothingformatter.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/fullnameformatter.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/dateformatter.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/phonenumberformatter.php');

function getScheduleDetails($location, $schedulePatient, $provider, $dynamicDetails=false) {
	$dateFormatter = new DateFormatter('m/d/Y');
	$timeFormatter = new DateFormatter('h:i A');
	$phoneFormatter = new PhoneNumberFormatter();
	$fullNameFormatter = new FullNameFormatter(null, false);
	$str = "
	<table>
		<tr><td class=\"boldText\">Patient</td><td class=\"patientDetailName\">";
			$str .= $_SESSION['schedule_firstname'] . " " . $_SESSION['schedule_lastname'];

			//Create a details view that shows additional patient details for verification
			if ($dynamicDetails) {
				//Get the basic fields
				if (strtotime($_SESSION['schedule_birthday']) === false) {
					$birthday = $_SESSION['schedule_birthday'];
				} else {
					$birthday = $dateFormatter->format($_SESSION['schedule_birthday']);
				}
				//$homephone = $phoneFormatter->format($_SESSION['schedule_phone']);
				$phone = $phoneFormatter->format($_SESSION['schedule_phone']);
				//$phonetype = $_SESSION['schedule_phone_type'];
				$email = $_SESSION['schedule_email'];

				//Combine address into one field
				$address = $_SESSION['schedule_address'];
				if (isset($_SESSION['schedule_address2']) && $_SESSION['schedule_address2'] != '') {
					$address .= "<br>" . $_SESSION['schedule_address2'] . "<br>";
				}
				$address .= "<br>" . $_SESSION['schedule_city'] . (isset($_SESSION['schedule_city']) ? ", " : "") . $_SESSION['schedule_state'] . " " . $_SESSION['schedule_zip'];

				//Get the insurance name
				$insuranceName = "";
				if ($_SESSION['schedule_insurance'] == OTHER_INSURANCE) {
					$insuranceName = $_SESSION['schedule_insurance_other'];
				} else {
					$insurance = new Insurance(null);
					if ($insurance->setFromFirstWhere('uid', $_SESSION['schedule_insurance'])) {
						$formatter = new InsuranceChoiceFormatter(new DoNothingFormatter());
						$insuranceName = $formatter->format($insurance);
					}
				}

				$detailsTable = "
				<div id=\"patient_details\" style=\"display:none;\"><table>
					<tr><td class=\"boldText\" style=\"padding-right:8px;\">Date of Birth</td><td>$birthday</td></tr>
					<tr><td class=\"boldText\" style=\"padding-right:8px;\">Phone</td><td>$phone</td></tr>
					<tr><td class=\"boldText\" style=\"padding-right:8px;\">Email Address</td><td>$email</td></tr>
					<tr><td class=\"boldText\" style=\"padding-right:8px;\">Address</td><td>$address</td></tr>
					<tr><td class=\"boldText\" style=\"padding-right:8px;\">Insurance</td><td>$insuranceName</td></tr>
				</table></div>";
				//$str .= UITools::getExpandableBox($detailsTable, "patient_details", "Details", );
				$str .= $detailsTable;
				$str .= "
				<div id=\"show_details\" class=\"smallItem clickable orange\">v Show Details v</div>
				<script type=\"text/javascript\">
					var showingDetails = false;
					$(\"#show_details\").click(function() {
						if (showingDetails) {
							$(\"#patient_details\").slideUp(\"slow\");
							$(\"#show_details\").html(\"v Show Details v\");
						} else {
							$(\"#patient_details\").slideDown(\"slow\");
							$(\"#show_details\").html(\"^ Hide Details ^\");
						}
						showingDetails = !showingDetails;
					});
				</script>";
			} //End if showing the dynamic details
		$str .= "
		</td></tr>
		<tr><td class=\"boldText\">Location</td><td>" . $location->getFieldValue('name') . "</td></tr>
		<tr><td class=\"boldText\">Doctor</td><td>Dr. " . $fullNameFormatter->format($provider) . "</td></tr>
		<tr><td class=\"boldText\">Date</td><td>" . $dateFormatter->format($_SESSION['schedule_time']). "</td></tr>
		<tr><td class=\"boldText\">Time</td><td>" . $timeFormatter->format($_SESSION['schedule_time']). "</td></tr>
	</table>
	<!-- Spacer -->
	<div>&nbsp;</div>
	";
	return $str;
} //End of getScheduleDetails()
?>
