<?
require_once('includes/conf.php');
enforcedSessionStart();

require_once('includes/portalutils.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/fullnameformatter.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/insurancechoiceformatter.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/donothingformatter.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/dateformatter.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/holderfieldformatter.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/dflist.php');
require_once(GLOBAL_INCLUDES_DIR . 'crystalLake/uitools.php');


//include("schedule_step_location_error.php");
//Include the header info
$title='EyeCare Associates - Schedule an Appointment';
include("template.php");
$subMenu = "schedule_menu.jpg";
$subMenuName = "schedule_menu";
  include("head.php");
if (isset($error)) {
?>
	<h1 class="orange">Unexpected Error</h1>
	<div class="error"><? echo $error; ?></div>
<?
}
else{
  //These are the various parameters that are used to fill out the form:
  //Removed 'designation'=>'Title'
  $formFields = array('firstname'=>'First Name', 'lastname'=>'Last Name', 'sex'=>'Gender', 'birthday'=>'Date of Birth <span class="smallInfo"> &nbsp;Please use MM/DD/YYYY format, eg. 12/30/1965</span><br>', 'email'=>'Email Address', 'phone'=>'Phone','address'=>'Address', 'city'=>'City', 'state'=>'State', 'phone_type'=>'Phone Type', 'zip'=>'Zip', 'has_insurance'=>'Insurance', 'insurance'=>'Insurance Company<br>', /* 'insurance_other'=>'If Other, Enter<br>Company Here', */
  		'subscriber_relationship'=>'Subscriber Relationship to Patient', 'subscriber_first_name'=>'Subscriber First Name (as seen on card)',  'subscriber_last_name'=>'Subscriber Last Name (as seen on card)', 'subscriber_name'=>'Subscriber Name', 'subscriber_birthday'=>'Subscriber Date of Birth', 'subscriber_sex'=>'Subscriber Sex',
  		'subscriber_ssn'=>'Subscriber Social Security Number (valid number required)', 'subscriber_employer'=>'Subscriber Employer',
  		'subscriber_id'=>'Subscriber Insurance ID', 'group_num'=>'Group Number', 'insurance_phone'=>'Carrier Service Phone Number',
  		'ssn'=>'Social Security #', 'preferred_language'=>'Preferred Language', 'subscriber_address'=>'Subscriber Address &nbsp;&nbsp; <small><input type="checkbox" id="same-as-patient"> Same Address as Patient</small>', 'subscriber_city'=>'Subscriber City', 'subscriber_state'=>'Subscriber State', 'subscriber_zip'=>'Subscriber Zip');
  $requiredFields = array('firstname', 'lastname', 'sex', 'zip', 'phone', 'address', 'city', 'state', 'email', 'birthday', 'has_insurance');
  $insuranceRequiredFields = array('subscriber_relationship', 'subscriber_id', 'insurance');
  $subscriberRequiredFields = array('subscriber_name', 'subscriber_birthday', 'subscriber_sex');
  $alreadyShown = false;
  $relationshipFormatter = new HolderFieldFormatter('name', new DoNothingFormatter());
  $error = null;
  try {
  	$relationships = DFList::getDFList('Relationships')->getDataFields();
  } catch (Exception $e) {
  	//An exception here means Victor is down.
  	$error = "An error occurred while loading the online schedule.  We apologize for the inconvenience, and we are currently working on fixing the problem.  Please try again later.";
  }

  //Read the form if it has been posted
  $missingRequired = array();
  $otherInvalid = array();
  $loadPage = true;
  if ($error == null && isset($_POST['post'])) {
  	$alreadyShown = true;
  	$required = $requiredFields;

  	$insRequired = false;
  	if (isset($_POST['schedule_has_insurance']) && $_POST['schedule_has_insurance'] != '' && $_POST['schedule_has_insurance'] == 'Yes') {
  		$insRequired = true;
  		array_splice($required, count($required), 0, $insuranceRequiredFields);
  		if ($_POST['schedule_subscriber_relationship'] != 'SELF') {
  			//Subscriber is not "SELF" - some subscriber fields are also required
  			array_splice($required, count($required), 0, $subscriberRequiredFields);
  		}
  	}

  	foreach ($required as $requiredField) {
  		$requiredPost = 'schedule_' . $requiredField;
  		if ((!isset($_POST[$requiredPost])) || trim($_POST[$requiredPost]) == '') {
  			$missingRequired[] = $requiredPost;
  		}
  	}

  	//if (count($missingRequired) > 0) {
  	if (count($missingRequired) > 0) {
  		$nonFatalError = "Some required fields are missing.  They are indicated in red.  Please fill out these fields, and submit the form again.";
  	}
    else {
  		$phoneFields = array('phone');
  		$phoneRegEx = "/^(\\D*\\d){10,}/";

  		foreach ($phoneFields as $phoneField) {
  			$phonePost = 'schedule_' . $phoneField;
  			//We don't need to check regex matching if the field isn't even entered.  That's checked elsewhere.  --DL 2012-09-18
  			if (isset($_POST[$phonePost]) && $_POST[$phonePost] != null && $_POST[$phonePost] != '') {
  				$match = preg_match($phoneRegEx, $_POST[$phonePost]);
  				if ($match === false || $match === 0) {
  					$otherInvalid[$phonePost] = "Must be at least 10 digits (including area code)";
  				}
  			}
  		}
  		$dateFields = array('birthday', 'subscriber_birthday');
  		$dateRegEx = "/^\\d\\d\\/\\d\\d\\/\\d{4}$/";
  		foreach ($dateFields as $dateField) {
  			$datePost = 'schedule_' . $dateField;
  			//We don't need to check regex matching if the field isn't even entered.  That's checked elsewhere.  --DL 2012-09-18
  			if (isset($_POST[$datePost]) && $_POST[$datePost] != null && $_POST[$datePost] != '') {
  				$match = preg_match($dateRegEx, $_POST[$datePost]);
  				if ($match === false || $match === 0 || !strtotime($_POST[$datePost])) {
  					$otherInvalid[$datePost] = "Dates must be in MM/DD/YYYY format";
  				}
  			}
  		} 

  		if (count($otherInvalid) > 0) {
  			$nonFatalError = "Some fields contain invalid data.  They are indicated in red, along with a description of the problem.";
			/* echo "<style>
			.stepone.right {margin-top: -975px !important; float:right !important;}
			#step2 {display:block !important;}
			.insurance_section.left, .insurance_section.right {display:block !important;}
			</style>";*/
  		} else {
  			//All required fields are present.  Put all fields into a set of session variables
  			foreach ($formFields as $formField=>$desc) {
  				$postField = "schedule_" . $formField;
  				if (isset($_POST[$postField])) {
  					$_SESSION[$postField] = $_POST[$postField];
  				}
  			}

  			//Create SSN from composite fields
  			if (isset($_POST['schedule_ssn1']) && isset($_POST['schedule_ssn2'])) {
  				//Use full social
  				$_SESSION['schedule_ssn'] = $_POST['schedule_ssn1'] . "-" . $_POST['schedule_ssn2'] . "-" . $_POST['schedule_ssn3'];
  			} else {
  				//Just use last 4 digits
  				$_SESSION['schedule_ssn'] = $_POST['schedule_ssn3'];
  			}

  			//Create subscriber's SSN from composite fields
  			if (isset($_POST['schedule_subscriber_ssn1']) && isset($_POST['schedule_subscriber_ssn2'])) {
  				//Use full social
  				$_SESSION['schedule_subscriber_ssn'] = $_POST['schedule_subscriber_ssn1'] . "-" . $_POST['schedule_subscriber_ssn2'] . "-" . $_POST['schedule_subscriber_ssn3'];
  			} else {
  				//Just use last 4 digits
  				$_SESSION['schedule_subscriber_ssn'] = $_POST['schedule_subscriber_ssn3'];
  			}

  			if (isset($_POST['expected_firstname']) && ($_POST['expected_firstname'] != $_SESSION['schedule_firstname'] || $_POST['expected_lastname'] != $_SESSION['schedule_lastname'])) {
  				//Patient "changed their name"... use the reserved patient, since the patient record can no longer be trusted to be accurate.
  				$_SESSION['schedule_patient'] = RESERVED_PATIENT;
  			}
  			$_SESSION['schedule_location'] = $_POST['schedule_location'];
  			$_SESSION['schedule_location_db'] = $_POST['schedule_location_db'];
  			header("location:schedule_appointment.php");
  			$loadPage = false;
  		}
  	}
  }

  if (isset($_SESSION['schedule_success']) && $_SESSION['schedule_success'] != null) {
  	//The patient has already scheduled an appointment.  Clear non-family fields and the scheduled appt. before showing this page.
  	header("location:clear_redirect.php?family=1&target=" . urlencode('/portal/schedule_step3.php?alt=1'));
  	$loadPage = false;
  }

  if ($loadPage) {
  	if (!isset($error)) {
  		$dateFormatter = new DateFormatter();
  		$useAlternate = (isset($_GET['alt']) && $_GET['alt'] == 1);
  		$patient = getPatient(false);
  		$logged_in = isset($patient);
  		//$usingLoggedInUser = false;

  		//Include the header info
  		$allowToChoose = isLoggedIn($patient);
  		$drawArrow = true;
  		$arrowPos = 287;
  		$whichPageNum = 1;
  		$rightPadding = 40;

  		$spacerWidth = ($isMobile ? 100 : 170);
  		$defaultInputSize = ($isMobile ? 22 : 35);

  		//Initialize the various parameters to ''
  		foreach ($formFields as $formField=>$text) {
  			$$formField = '';
  		}

  		//Get the location for the number passed in, or the session's location if already set
  		$location = null;
  		$locationNumber = $_GET['loc'];
  		if ($locationNumber != null) {
  			if (strlen($locationNumber) == 32) {
  				//Assume it's a UID
                          	$location = getLocationByUID($locationNumber);
  			} else {
  				//Priority goes to $_GET['loc'], so location can be overridden even if already set
  				$location = getLocationByNumber($locationNumber);
  			}
  		} else if (isset($_SESSION['schedule_location']) && isset($_SESSION['schedule_location_db'])) {
  			//If $_GET['loc'] isn't set, it may be that they clicked a back link - see if loc is already set
  			$locationUID = $_SESSION['schedule_location'];
  			$locationDB = $_SESSION['schedule_location_db'];

  			$location = new Location($locationDB);
  			if (!$location->setFromFirstWhere('uid', $locationUID, '=', array($locationDB), true)) {
  				$location = null;
  			}
  		}

  		//After those options, if location is still null, it's a fatal error
  		if ($location == null) {
  			if (sessionExpired()) {
  				$error = "We're sorry, but your session has been idle too long and has expired.  You must come back here from the ".
  						"patient portal's <a class=\"basicLink\" href=\"schedule_choose.php\">Schedule Appointment</a> page, or from " .
  						"the <a class=\"basicLink\" href=\"https://www.webeca.com/locations/\">Find a Location</a> page.";
				
  			} else {
  				$error = "You must come to this page from the <a class=\"basicLink\" href=\"https://www.webeca.com/locations/\">" .
  						"Find a Location</a> page, or from the patient portal's <a class=\"basicLink\" href=\"schedule_choose.php\">" .
  						"Schedule Appointment</a> page in order to schedule appointments for the appropriate office.";
  			}
  		}

  		//Get the information from the patient to fill in the fields; this info is overridden by $_POST data and $_SESSION vars
  		$schedulePatient = getSchedulePatient(false);
        //Use the logged in patient if applicable
  		$resetToReserved = false;
  		if (isset($patient) && !$useAlternate && (!isset($schedulePatient) || $schedulePatient->getFieldValue('uid') == RESERVED_PATIENT)) {
  			$schedulePatient = $patient;
  			if ($location != null && $patient->getDatabaseName() != $location->getDatabaseName()) {
  				//Once we're done copying fields, we want to reset to reserved - the patient isn't in the correct DB
  				$resetToReserved = true;
  			}
  		}

  		//Use the reserved patient if no other patient is set
  		if (!isset($schedulePatient)) {
  			if ($location != null) {
  				//Not logged in, or scheduling an alternate patient - use the dummy "reserved appointment" patient
  				$schedulePatient = getReservedPatient($location->getDatabaseName());
  			}
  		}

  		if (isset($schedulePatient) && isset($patient) && ($schedulePatient->getFieldValue('uid') == $patient->getFieldValue('uid')) && $useAlternate) {
  			//If the schedule patient is currently the one logged in, but we want to use alternate, use reserved patient instead.
  			$schedulePatient = getReservedPatient($location->getDatabaseName());

  		}

  		//If a schedule patient is chosen, store its database and uid
  		if (isset($schedulePatient)) {
  			$_SESSION['schedule_patient'] = $schedulePatient->getFieldValue('uid');
  			$_SESSION['schedule_patient_db'] = $schedulePatient->getDatabaseName();
  		}

  		//This is no longer appropriate.  See the similar block above.
  		/* if (isset($schedulePatient) && isset($patient) && ($schedulePatient->getFieldValue('uid') == $patient->getFieldValue('uid')) && $useAlternate) {
  			//Clear the schedule patient if it's currently the patient and we want to schedule for an alternate patient
  			unset($_SESSION['schedule_patient']);
  			unset($_SESSION['schedule_patient_db']);
  			$schedulePatient = null;
  		}*/

  		//If the logged in user is the schedule patient, some special text is necessary
  		//$usingLoggedInUser = ($schedulePatient == $patient || ($schedulePatient != null && $patient != null && $schedulePatient->getFieldValue('uid') == $patient->getFieldValue('uid')));

  		//Now, no matter how schedule patient was set, use their fields to determine the various form fields
  		$reservedPatient = (isset($schedulePatient) && $schedulePatient->getFieldValue('uid') == RESERVED_PATIENT);
  		if (isset($schedulePatient) && !$reservedPatient) {
  			//Don't set fields here if it's the "RESERVED APPOINTMENT" patient
  			foreach ($formFields as $formField=>$text) {
  				if ($schedulePatient->hasField($formField)) {
  					$$formField = $schedulePatient->getFieldValue($formField);
  				}
  			}

  			$primaryIns = $schedulePatient->getPrimaryInsurance();
  			if ($primaryIns != null) {
  				$insurance = $primaryIns->getFieldValue('insurance');
  				$subscriber_relationship = $primaryIns->getFieldValue('subscriber_relationship');
  				$subscriber = ($subscriber_relationship == 'SELF' ? $schedulePatient : $primaryIns->getSubscriber());
  				if ($subscriber != null) {
  					$fnf = new FullNameFormatter(null, false);
  					$subscriber_name = $fnf->format($subscriber);
  					$subscriber_birthday = $dateFormatter->format($subscriber->getFieldValue('birthday'));
  				}
  				//Don't load the ID - not only is it encrypted, but we also don't want to save/display this
  				//$subscriber_id = $primaryIns->getFieldValue('insurance_id');
  				$group_num = $primaryIns->getFieldValue('group_number');
  				$insurance_phone = $primaryIns->getFieldValue('card_phone');
  			}
  		}
      else if (isset($patient)) {
  			//Patient is set, but using alternate patient - still copy some fields.
  			$copyAnyway = array('lastname', 'homephone', 'address', 'city', 'state', 'zip', 'email');
  			foreach ($copyAnyway as $field) {
  				if ($patient->hasField($field)) {
  					$$field = $patient->getFieldValue($field);
  				}
  			}
  			$primaryIns = $patient->getPrimaryInsurance();
  			if ($primaryIns != null) {
  				$insurance = $primaryIns->getFieldValue('insurance');
  				$subscriber_relationship = $primaryIns->getFieldValue('subscriber_relationship');
  				$subscriber = ($subscriber_relationship == 'SELF' ? $patient : $primaryIns->getSubscriber());
  				//We don't want the relationship to be the same
  				unset($subscriber_relationship);
  				if ($subscriber != null) {
  					$fnf = new FullNameFormatter(null, false);
  					$subscriber_name = $fnf->format($subscriber);
  					$subscriber_birthday = $dateFormatter->format($subscriber->getFieldValue('birthday'));
  				}
  				//Don't load the ID - not only is it encrypted, but we also don't want to save/display this
  				//$subscriber_id = $primaryIns->getFieldValue('insurance_id');
  				$group_num = $primaryIns->getFieldValue('group_number');
  				$insurance_phone = $primaryIns->getFieldValue('card_phone');
  			}
  		}

  		if ($resetToReserved && $location != null) {
  			$_SESSION['schedule_patient'] = RESERVED_PATIENT;
  			$_SESSION['schedule_patient_db'] = $location->getDatabaseName();
  		}

  		//Override with $_POST['schedule_<formField>'] if set, or else with $_SESSION['schedule_<formField>'] if that is set
  		$allFields = array();
  		array_splice($allFields, 0, 0, array_keys($formFields));
  		array_push($allFields, 'ssn1', 'ssn2', 'ssn3', 'subscriber_ssn1', 'subscriber_ssn2', 'subscriber_ssn3');
  		foreach ($allFields as $formField) {
  			if (isset($_POST["schedule_$formField"])) {
  				$$formField = $_POST["schedule_$formField"];
  			} else if (isset($_SESSION["schedule_$formField"])) {
  				$$formField = $_SESSION["schedule_$formField"];
  			}
  		}

  		//Default to Alabama if no state is set
  		if (!isset($state) || $state=='') {
  			$state = 'AL';
  		}

  		if (isset($birthday) && $birthday != '') {
  			$birthday = $dateFormatter->format(trim($birthday));
  		}
  	}
  	if (isset($error)) {
  		echo "<h1 class=\"orange\">Unexpected Error</h1>\r\n";
  		echo "<div class=\"error\">$error</div>";
  	}
    else {
  		$insurances = getInsuranceChoices(array($location->getDatabaseName()));
  		//Filter out the insurances that are not available for online scheduling
  		$insurances = filterSchedulerInsurances($insurances);
  		if (isset($nonFatalError)) {
  			echo "<div class=\"error\">$nonFatalError</div>";
  		}
  		if ($logged_in) {
  			echo "<p class=\"menuItem currently hide-from-mobile\">";
  			//Logged in - allow user to switch between filling out form for themselves, or for other patients
  			if (!$useAlternate) {
  				echo "<h3 class=\"orange\">You are currently scheduling an appointment for yourself.</h3>
  						<a class=\"basicLink\" href=\"" . $_SERVER['PHP_SELF'] . "?loc=$locationNumber&alt=1\">Click here</a> to schedule
  						an appointment for a family member instead.  You still have the option of using your same insurance,
  						address, and other data when scheduling for your family.";
  			} else {
  				echo "<h3 class=\"orange\">You are currently scheduling an appointment for a patient other than the one for this user account.</h3>
  						<a class=\"basicLink\" href=\"schedule_start.php?loc=$locationNumber\">Click Here</a> to schedule
  						an appointment for yourself instead, which will automatically prepopulate this form with your information.";
  			}
  			echo "</p>\n";

  			echo "<p class=\"menuItem currently hide-from-desktop\">";
  			//Logged in - allow user to switch between filling out form for themselves, or for other patients
  			if (!$useAlternate) {
  				echo "<a class=\"basicLink\" href=\"" . $_SERVER['PHP_SELF'] . "?loc=$locationNumber&alt=1\">Schedule
  						an appointment for a family member instead.</a><br><br>";
  			}
        else
        {
  				echo "You are currently scheduling an appointment for a patient other than the one for this user account.
  						<a class=\"basicLink\" href=\"schedule_start.php?loc=$locationNumber\">Schedule
  						an appointment for yourself instead.</a><br><br>";
  			}
  			echo "</p>\n";
  		}
  	?>
  	<script type="text/javascript">
		
  		$("#schedule_insurance").live('change', function() {
  			checkInsuranceRequiredFields();

  			checkSubscriberRequiredFields();
  		});

  		$("#schedule_subscriber_relationship").live('change', function() {
  			checkSubscriberRequiredFields();
  		});

      function checkInsuranceRequiredFields(){
        //Conditionally require the insurance fields
        var val = $("input[name='schedule_has_insurance']:checked").val();
  			if (!(val === "Yes")) {
  				$(".insuranceRequired").removeClass("boldText");
  				$(".insuranceRequiredField").removeAttr("required").removeAttr("invalid");
  				$(".insuranceRequired.requiredStar").html("");
  			} else {
  				$(".insuranceRequired").addClass("boldText");
  				$(".insuranceRequiredField").attr("required", "required");
  				$(".insuranceRequired.requiredStar").html("*");
  			}

  			//Conditionally require the "other insurance" field
  			if (val == '<? echo OTHER_INSURANCE; ?>') {
  				$(".otherInsurance").addClass("boldText");
  				$(".otherInsurance.requiredStar").html("*");
  			} else {
  				$(".otherInsurance").removeClass("boldText");
  				$(".otherInsurance.requiredStar").html("");
  			}
      }

  		function checkSubscriberRequiredFields() {
  			var insRequired = ($("input[name='schedule_has_insurance']:checked").val() === "Yes");
  			var subscriberRelationship = $("#schedule_subscriber_relationship").val();
  			if (insRequired && subscriberRelationship != "SELF") {
  				$(".subscriberRequired").addClass("boldText");
  				$(".subscriberRequiredField").attr("required", "required");
  				$(".subscriberRequired.requiredStar").html("*");
  			} else {
  				$(".subscriberRequired").removeClass("boldText");
  				$(".subscriberRequiredField").removeAttr("required").removeAttr("invalid");
  				$(".subscriberRequired.requiredStar").html("");
  			}
  		}

  		function clearForm() {
  			$('input[type="text"]').val("");
  			$('input[type="password"]').val("");
  			$('#schedule_designation').val("");
  			$('#schedule_sex').val("");
  			$('#schedule_insurance').val("");
  			$('#schedule_subscriber_relationship').val("");
  			$('#schedule_subscriber_sex').val("");
  			$('#schedule_subscriber_address').val("");
  			$('#schedule_subscriber_state').val("");
  			$('#schedule_subscriber_zip').val("");
  		}
		 

  		$("#showForm").live('click', function() {
  			$("#showFormP").hide();
  			$("#formDiv").slideDown();
  		});
  	</script>
  	<div id="formDiv" style="display: block; font-size: 1em;">
      <h3 class="orange">Complete the Form below to Schedule Your Annual Comprehensive Exam</h3>
  		<p class="menuItem">To schedule any other type of appointment, such as a contact lens follow-up or medical visit, please call <span class="phonenum"><? echo $location->getFieldValue('phone1'); ?></span>.</p>
      <br  />
  		<h2 class="hide-from-mobile">Schedule Appointment for <? echo $location->getFieldValue('name'); ?> </h2>
  		<p class="hide-from-desktop">Office Location:</p><h3 class="hide-from-desktop" style="margin-top: 0px;"><? echo $location->getFieldValue('name'); ?></h3>
          <p class="hide-from-desktop" style="margin-bottom: -15px;"><a href="https://www.clarksoneyecare.com/locations/">Choose a Different Office</a></p>
  		<form action="<? echo $_SERVER['PHP_SELF'] . "?loc=" . $locationNumber . ($_GET['alt'] == null ? "" : "&alt=1");?>" method="post" class="form-inline">
  			<div id='step1' class="stepone left">

  			<?
        $formIndex = 0;
  			foreach ($formFields as $formField=>$text) {
          $formIndex++;
  				$elementName = 'schedule_' . $formField;
  				//Basic layout dependent on if field is required
  				$starClass = "";
  				$labelClass = "";
  				$requiredStar = "";
  				//$fieldAttrStr is used to add pseudo-classes (or CSS classes) to input elements
  				$fieldAttrStr = "";
  				$fieldAttrs = array('id'=>$elementName, 'name'=>$elementName);
  				if (in_array($formField, $requiredFields)) {
  					$starClass = "class='boldText requiredStar'";
  					$labelClass = "class='boldText control-label' style='cursor:initial;'";
  					$fieldAttrStr = " required class='requiredField'";
  					$fieldAttrs['required'] = null;
  					$fieldAttrs['class'] = 'requiredField';
  					$requiredStar = "*";
  				} else if (in_array($formField, $insuranceRequiredFields)) {
  					$starClass = "class='insuranceRequired requiredStar'";
  					$labelClass = "class='insuranceRequired control-label'";
  					$fieldAttrs['class'] = 'insuranceRequiredField';
  					if (isset($insurance) && $insurance != '' && $insurance != '0') {
  						$starClass = "class='insuranceRequired boldText requiredStar'";
  						$labelClass = "class='insuranceRequired boldText control-label'";
  						$fieldAttrStr = " required class='insuranceRequiredField'";
  						$fieldAttrs['required'] = null;
  						$requiredStar = "*";
  					} else {
  						$fieldAttrStr = " class='insuranceRequiredField'";
  					}
  				//} else if (in_array($formField, $subscriberRequiredFields) || $formField == 'subscriber_ssn') {
  				} else if (in_array($formField, $subscriberRequiredFields)) {
  					$starClass = "class='subscriberRequired requiredStar'";
  					$labelClass = "class='subscriberRequired control-label'";
  					$fieldAttrs['class'] = 'subscriberRequiredField';
  					if (isset($insurance) && $insurance != '' && $insurance != '0' && $subscriber_relationship != 'SELF') {
  						$starClass = "class='subscriberRequired boldText requiredStar'";
  						$labelClass = "class='subscriberRequired boldText control-label'";
  						$fieldAttrStr = " required class='subscriberRequiredField'";
  						$fieldAttrs['required'] = null;
  						$requiredStar = "*";
  					} else {
  						$fieldAttrStr = " class='subscriberRequiredField'";
  					}
  				}
          else {
            $labelClass = "class='control-label'";
          }

  				if ($formField == 'insurance_other') {
  					$starClass = "class='otherInsurance requiredStar'";
  					$labelClass = "class='otherInsurance control-label'";
  				}

  				//Add error text if a required field is missing
  				$errorText = "";
  				if (in_array($elementName, $missingRequired) || (in_array($elementName . '3', $missingRequired) && ($formField == 'ssn' || $formField == 'subscriber_ssn'))) {
  					$fieldAttrs['invalid'] = null;
  					$fieldAttrStr .= " invalid";
  					$prefixText = "";
  					if ($formField == 'ssn' || $formField == 'subscriber_ssn') {
  						$prefixText = "entire SSN ";
  					}
  					$suffixText = "";
  					if (in_array($formField, $insuranceRequiredFields)) {
  						$suffixText = " with insurance";
  					} else if (in_array($formField, $subscriberRequiredFields)) {
  						$suffixText = " with subscriber";
  					} else if ('subscriber_ssn' == $formField) {
  						$suffixText = "<br>with subscriber";
  					}
  					$errorText = "<br><div class=\"error\">$prefixText" . "required$suffixText</div>";
  				} else if (array_key_exists($elementName, $otherInvalid)) {
  					$fieldAttrs['invalid'] = null;
  					$fieldAttrStr .= " invalid";
  					$errorText = "<br><div class=\"error\">" . $otherInvalid[$elementName] . "</div>";
  				}

  				//Some special cases, then a basic case for other fields
  				if ($formField == 'designation') {
  					$inputText = UITools::getArrayComboBox(array(''=>'', 'Dr.'=>'Dr.', 'Miss'=>'Miss', 'Mr.'=>'Mr.',
  							'Mrs.'=>'Mrs.', 'Ms.'=>'Ms.'), $designation, $fieldAttrs);
  				} else if ($formField == 'sex' || $formField == 'subscriber_sex') {
  					$inputText = UITools::getArrayComboBox(array(''=>'', 'M'=>'Male', 'F'=>'Female'), $$formField, $fieldAttrs);
  				} else if ($formField == 'state') {
  					//Options of US states
  					$inputText = "<select id='$elementName' name='$elementName'$fieldAttrStr>";
  					foreach ($_SESSION['stateArray'] as $abbr => $name) {
  						if ($state == $abbr) {
  							$inputText .= "\t\t\t\t<option value='" . $abbr . "' selected='selected'>".ucwords(strtolower($name))."</option>";
  						} else {
  							$inputText .= "\t\t\t\t<option value='" . $abbr . "'>".ucwords(strtolower($name))."</option>";
  						}
  					}
  					$inputText .= "\t\t\t</select>";
  				}
          else if ($formField == 'preferred_language') {
  					//Options of US states
  					$inputText = "<select id='$elementName' name='$elementName'$fieldAttrStr>";
            $inputText .= "\t\t\t\t<option value=''" . (!isset($$formField) ? " selected='selected'" : "") . "></option>";
  					$inputText .= "\t\t\t\t<option value='English'" . ($$formField == "English" ? " selected='selected'" : "") . ">English</option>";
            $inputText .= "\t\t\t\t<option value='Spanish'" . ($$formField == "Spanish" ? " selected='selected'" : "") . ">Spanish</option>";
            $inputText .= "\t\t\t\t<option value='Other' " . ($$formField == "Other" ? " selected='selected'" : "") . ">Other</option>";
  					$inputText .= "\t\t\t</select>";
  				}
          else if ($formField == 'birthday' || $formField == 'subscriber_birthday') {
  					//Birthday fields - give an indication of preferred format
  					$inputText = "<input type='text' id='$elementName' name='$elementName' value='" . $$formField . "' size='10' maxlength='10'$fieldAttrStr />";
  					$inputText .= "<br>\n\t\t\t\t";
  				}
          else if($formField == 'phone_type'){
            $inputText = "<select id='$elementName' name='$elementName'$fieldAttrStr>";
            $inputText .= "\t\t\t\t<option value=''" . (!isset($$formField) ? " selected='selected'" : "") . "></option>";
  					$inputText .= "\t\t\t\t<option value='Home'" . ($$formField == "Home" ? " selected='selected'" : "") . ">Home</option>";
            $inputText .= "\t\t\t\t<option value='Work'" . ($$formField == "Work" ? " selected='selected'" : "") . ">Work</option>";
            $inputText .= "\t\t\t\t<option value='Cell' " . ($$formField == "Cell" ? " selected='selected'" : "") . ">Cell</option>";
            $inputText .= "\t\t\t\t<option value='Other' " . ($$formField == "Other" ? " selected='selected'" : "") . ">Other</option>";
  					$inputText .= "\t\t\t</select>";
          }
          else if($formField == 'has_insurance'){
            echo "<button id='nextBtn'>Next</button>
			</div>
			
			<div id='step2' style='display:none'>";
            $inputText = "<label class='radio'><input type='radio' id='" . $elementName . "1' name='schedule_" . $formField . "'" . ($$formField == "No" ? " checked='checked'" : "") . " value='No' $fieldAttrStr />No insurance</label><br/>";
            $inputText .= "<label class='radio'><input type='radio' id='" . $elementName . "2' name='schedule_" . $formField . "'" . ($$formField == "Yes" ? " checked='checked'" : "") . " value='Yes' $fieldAttrStr />I have insurance</label><br/>";
            $inputText .= "<label class='radio'><input type='radio' id='" . $elementName . "3' name='schedule_" . $formField . "'" . ($$formField == "Yes, fill in later" ? " checked='checked'" : "") . " value='Yes, fill in later' $fieldAttrStr />I have insurance (but will fill out before appointment)</label><br>";
          }
          else if ($formField == 'ssn' || $formField == 'subscriber_ssn') {
  					$var = $formField . "1";
  					$inputText = "<input type='password' id='$elementName" . "1' name='$elementName" . "1' size='3' maxlength='3' value='" . $$var . "'$fieldAttrStr /> - ";
  					$var = $formField . "2";
  					$inputText .= "<input type='password' id='$elementName" . "2' name='$elementName" . "2' size='2' maxlength='2' value='" . $$var . "'$fieldAttrStr /> - ";
  					$var = $formField . "3";
  					$inputText .= "<input type='password' id='$elementName" . "3' name='$elementName" . "3' size='4' maxlength='4' value='" . $$var . "'$fieldAttrStr />";
  				} else if ($formField == 'insurance') {
  				/*echo "\t\t<tr>
  					<td colspan='3'><br><strong>If you do not provide insurance information here,<br>please come to your appointment at least 30 minutes early.</strong><br>  </td>
  				</tr>\n";*/
  					$formatter = new InsuranceChoiceFormatter(new DoNothingFormatter());
  				/*echo "\t\t<tr>
  					<td colspan='3'><br><strong>VISION INSURANCE INFORMATION:</strong><br> </td>
  				</tr>\n";*/
  					$insuranceBox = UITools::getDataHolderComboBox($insurances, 'uid', $formatter, $insurance, $fieldAttrs);
  					$inputText = $insuranceBox;
  					$inputText .= "<span class='smallInfo smallmoveme1'>If your insurance company does not appear here, please</span>";
  					$inputText .= "<span class='smallInfo smallmoveme2' style='clear:left; display:block;'>call <span class='phonenum'>". $location->getFieldValue('phone1') . "</span> to schedule your appointment.</span>";
  				} else if ($formField == 'subscriber_relationship') {
  					//Static array replaced with data fields, per issue #3819
  					/* $inputText = UITools::getArrayComboBox(array(''=>'', 'SELF'=>'Self', 'SPOUSE'=>'Spouse',
  							'CHILD'=>'Child', 'OTHER'=>'Other'), $$formField, $fieldAttrs); */
  					$inputText = UITools::getDataHolderComboBox($relationships, '_key', $relationshipFormatter, $$formField, $fieldAttrs);
  				} else {
  					//Basic case - just a text field.  Escape quotes and special chars in value and add directly.
  					$val = str_replace("'", "&apos;", htmlspecialchars($$formField));
  					$inputText = "<input type='text' id='$elementName' name='$elementName' value='$val' size='$defaultInputSize'$fieldAttrStr />";
  				}
  				$finalInput = "<span $starClass>$requiredStar</span><label $labelClass>$text$errorText</label><div class='controls'>$inputText</div>";
          if($formField == 'insurance'){ 
            echo "
			<div class='insurance_section right' style='display:none;'></div>
			<div id='insurance_section' class='insurance_section left' style='display:none;'>
			";
          }
          echo "<div class='control-group'>". $finalInput . "</div>";
          if($formField == 'insurance_phone'){
            echo "</div>";
          }
				
  			}
  				/*echo "\t\t<tr>
  					<td colspan='3'><br><strong>MEDICAL INSURANCE INFORMATION:</strong><br></td>
  				</tr>\n";*/
  			?>

  			<script type="text/javascript">
  				$("#schedule_ssn1").keyup(function(event) {
  					switchToField(event.which, 'schedule_ssn1', 3, 'schedule_ssn2');
  				});
  				$("#schedule_ssn2").keyup(function(event) {
  					switchToField(event.which, 'schedule_ssn2', 2, 'schedule_ssn3');
  				});
  				$("#schedule_subscriber_ssn1").keyup(function(event) {
  					switchToField(event.which, 'schedule_subscriber_ssn1', 3, 'schedule_subscriber_ssn2');
  				});
  				$("#schedule_subscriber_ssn2").keyup(function(event) {
  					switchToField(event.which, 'schedule_subscriber_ssn2', 2, 'schedule_subscriber_ssn3');
  				});

  				function switchToField(keyCode, oldField, numChars, newField) {
  					var val = $("#" + oldField).val();
  					if (((keyCode >= 96 && keyCode <= 105) || (keyCode >= 48 && keyCode <= 57)) && val.length >= numChars) {
  						$("#" + newField).focus();
  						$("#" + newField).select();
  					}
  				}
  			</script>
  			<!-- Spacer -->
  			<div>&nbsp;</div>
        <input type="text" id="secretStepInput" required="required" style="display:none" />
  			<input type="hidden" name="post" value="1" />
  			<input type="hidden" name="schedule_location" value="<? echo $location->getFieldValue('uid'); ?>" />
  			<input type="hidden" name="schedule_location_db" value="<? echo $location->getDatabaseName(); ?>" />
  			<?
  				if (isset($schedulePatient) && isset($patient) && ($schedulePatient->getFieldValue('uid') == $patient->getFieldValue('uid'))) {
  					$expectedFirstname = $patient->getFieldValue('firstname');
  					$expectedLastname = $patient->getFieldValue('lastname');
  					echo "<input type=\"hidden\" value=\"$expectedFirstname\" name=\"expected_firstname\" />
  							<input type=\"hidden\" value=\"$expectedLastname\" name=\"expected_lastname\" />";
  				}
  			?>
        <input id="backBtn" type="button" value="Back" />
  			<!--<input type="button" value="Clear" onclick="clearForm();" />-->
  			<input id="submitBtn" type="submit" value="Continue" />
      </div>
      
      <div class='stepone right'>
      </div>

  			<!-- Spacer -->
  			<div>&nbsp;</div>
            <script
			  src="https://code.jquery.com/jquery-3.3.1.js"
			  integrity="sha256-2Kok7MbOyxpgUVvAk/HJ2jigOSYS2auK4Pfzbm7uH60="
			  crossorigin="anonymous"></script>
  			<script type="text/javascript">
				
				$(".stepone.right" ).next("div").addClass("lastdiv")
				$(".stepone.right").detach().insertAfter( ".stepone.left" );
				
				$("#nextBtn").hide();
				$("#backBtn").hide();
				
			$('input[name="schedule_has_insurance"]').change(function(){
				if($('#schedule_has_insurance2').prop('checked')){
				  var stepInputSelector = "#step1 [required]";
				  var inputCount = $(stepInputSelector).length;
					$(stepInputSelector).each(function(index){
                  if(!this.checkValidity()){
                    return false;
                  }
                  else if((index + 1) == inputCount)
                  {

                    //$("#step1").hide();
                    //$(".stepone.right").hide();
                    $("#step2").show(); 
                    return false;
                  }
              });
					
				} else if($('#schedule_has_insurance1').prop('checked')){
					$("#submitBtn").show();
					$("#schedule_subscriber_birthday").val("");
					$("#submitBtn").detach().insertAfter( ".lastdiv" );
				}
			});
			
          //$("#nextBtn").click(function(){
         /* $("#nextBtn").click(function(){
              var stepInputSelector = "#step1 [required]";
              var inputCount = $(stepInputSelector).length;
              $(stepInputSelector).each(function(index){
                  if(!this.checkValidity()){
                    return false;
                  }
                  else if((index + 1) == inputCount)
                  {

                    //$("#step1").hide();
                    //$(".stepone.right").hide();
                    $("#step2").show(); 
                    return false;
                  }
              });
          });
		  */

          /* $("#backBtn").click(function(){
              $("#step2").hide(function(){
                $("#secretStepInput").attr("required", "required");
              });
              $("#step1").show();
			  $(".stepone.right").show(); 
			   
          });*/

          $("#submitBtn").click(function(){
              $("#secretStepInput").removeAttr("required");
          });

  				$("#schedule_insurance").change();

  				$('#schedule_ssn1').keyup(function(){
  					$('#schedule_subscriber_ssn1').val($('#schedule_ssn1').val());
  				});

  				$('#schedule_ssn2').keyup(function(){
  					$('#schedule_subscriber_ssn2').val($('#schedule_ssn2').val());
  				});

  				$('#schedule_ssn3').keyup(function(){
  					$('#schedule_subscriber_ssn3').val($('#schedule_ssn3').val());
  				});

  				$(document).ready(function(){
					
					$("#schedule_sex").change(function(){
							$('#schedule_subscriber_sex').val($('#schedule_sex').val());
						});
					
					$('input[type="text"]').keydown(function(e){
					   var ingnore_key_codes = [192];
					   if ($.inArray(e.keyCode, ingnore_key_codes) >= 0){
						  e.preventDefault();
					   }
					});
					
					$('input:radio[name="schedule_has_insurance"]').change(function(){
							if($(this).val() == 'Yes, fill in later'){
							   alert("If you would like our office to file your insurance claim for you please call the office within 48 hours of your scheduled appointment time.");
							}
						});
					
					 
					var width = $(window).width();
					
    				$("#schedule_subscriber_sex option:contains("+ $("#schedule_sex").val() +")").attr('selected', true);
					
					$(".smallInfo.smallmoveme1").parent().addClass("inscompy");
					$(".smallInfo.smallmoveme1").next("br").addClass("movebr");
					
					$("#schedule_subscriber_address").parent().parent().addClass("subscriberaddress subscriberinfo");
					$("#schedule_subscriber_city").parent().parent().addClass("subscribercity subscriberinfo");
					$("#schedule_subscriber_state").parent().parent().addClass("subscriberstate subscriberinfo");
					$("#schedule_subscriber_zip").parent().parent().addClass("subscriberzip subscriberinfo");
					
					$("#schedule_firstname").addClass("requiredField2");
					$("#schedule_lastname").addClass("requiredField2");
					$("#schedule_birthday").addClass("requiredField2");
					$("#schedule_email").addClass("requiredField2");
					$("#schedule_phone").addClass("requiredField2");
					$("#schedule_address").addClass("requiredField2");
					$("#schedule_city").addClass("requiredField2");
					$("#schedule_state").addClass("requiredField2");
					$("#schedule_zip").addClass("requiredField2");
					$("#schedule_sex").addClass("requiredField2");
					
					if (width >= 769) {
					$(".subscriberaddress").detach().appendTo(".insurance_section.left");
					$(".subscriberstate").detach().appendTo(".insurance_section.left");
					}
					
					$( "#step1" ).find( ".control-group" ).eq( 0 ).addClass( "firstname" );
					$( "#step1" ).find( ".control-group" ).eq( 1 ).addClass( "lastname" );
					$( "#step1" ).find( ".control-group" ).eq( 2 ).addClass( "gender" );
					$( "#step1" ).find( ".control-group" ).eq( 3 ).addClass( "dob" );
					$( "#step1" ).find( ".control-group" ).eq( 4 ).addClass( "email" );
					$( "#step1" ).find( ".control-group" ).eq( 5 ).addClass( "phone" );
					$( "#step1" ).find( ".control-group" ).eq( 6 ).addClass( "address" );
					$( "#step1" ).find( ".control-group" ).eq( 7 ).addClass( "city" );
					$( "#step1" ).find( ".control-group" ).eq( 8 ).addClass( "state" );
					$( "#step1" ).find( ".control-group" ).eq( 9 ).addClass( "phonetype" );
					$( "#step1" ).find( ".control-group" ).eq( 10 ).addClass( "zip" );
					
					$( "#step2" ).find( ".control-group" ).eq( 0 ).addClass( "yes-no-insurance" ); 
					
					
					if (width >= 769) {
					$(".control-group.lastname").detach().appendTo(".stepone.right");
					$(".control-group.dob").detach().appendTo(".stepone.right");
					$(".control-group.phone").detach().appendTo(".stepone.right");
					$(".control-group.city").detach().appendTo(".stepone.right");
					$(".control-group.zip").detach().appendTo(".stepone.right");
					}
					//$(".control-group.phonetype").detach().appendTo(".stepone.right");
					$(".control-group.phonetype").detach();
					//$("button#nextBtn").detach();
					
					$("#insurance_section").find(".control-group").eq(0).addClass("ins-company");
					$("#insurance_section").find(".control-group").eq(1).addClass("ins-relationship");
					$("#insurance_section").find(".control-group").eq(2).addClass("ins-subscriber");
					$("#insurance_section").find(".control-group").eq(3).addClass("ins-subscriber2");
					$("#insurance_section").find(".control-group").eq(4).addClass("ins-subscribername");
					$("#insurance_section").find(".control-group").eq(5).addClass("ins-dob");
					$("#insurance_section").find(".control-group").eq(6).addClass("ins-gender");
					$("#insurance_section").find(".control-group").eq(7).addClass("ins-ssn");
					$("#insurance_section").find(".control-group").eq(8).addClass("ins-employer");
					$("#insurance_section").find(".control-group").eq(9).addClass("ins-id");
					$("#insurance_section").find(".control-group").eq(10).addClass("ins-groupnum");
					$("#insurance_section").find(".control-group").eq(11).addClass("ins-carrierphone");
					
					$('#schedule_subscriber_first_name').keyup(function(){
					   $('#schedule_subscriber_name').val(this.value+' '+$('#schedule_subscriber_last_name').val());
					});

					$('#schedule_subscriber_last_name').keyup(function(){
					   $('#schedule_subscriber_name').val($('#schedule_subscriber_first_name').val()+' '+this.value);
					});
					
					$(".ins-subscribername").hide();
					$(".subscriberinfo").hide();
					
					$('#schedule_subscriber_relationship').change(function(){
						if($(this).val() == 'PARENT' || $(this).val() == 'CHILD' || $(this).val() == 'SPOUSE' || $(this).val() == 'DOMESTIC_PARTNER' || $(this).val() == 'SIBLING' || $(this).val() == 'GRANDPARENT' || $(this).val() == 'GRANDCHILD' || $(this).val() == 'UNCLE' || $(this).val() == 'AUNT' || $(this).val() == 'FRIEND' || $(this).val() == 'NEPHEW' || $(this).val() == 'NIECE'){
							$('.subscriberinfo').show();
						} else {
							$('.subscriberinfo').hide();
					}
					});
					
					
					$(".control-group.yes-no-insurance").detach().appendTo("#step1.stepone.left");
					
					$(".control-group.ins-relationship").detach().appendTo(".insurance_section.right");
					$(".control-group.ins-subscriber2").detach().appendTo(".insurance_section.right");
					$(".control-group.ins-gender").detach().appendTo(".insurance_section.right");
					$(".control-group.ins-employer").detach().appendTo(".insurance_section.right");
					$(".control-group.ins-groupnum").detach().appendTo(".insurance_section.right");
					//$(".control-group.yes-no-insurance").detach().appendTo(".stepone.left");
					
					$(".subscribercity").detach().appendTo(".insurance_section.right");
					$(".subscriberzip").detach().appendTo(".insurance_section.right");
					$(".control-group.ins-carrierphone").detach();
					
					$("input#schedule_firstname").attr("tabindex","1");
					$("input#schedule_lastname").attr("tabindex","2");
					$("select#schedule_sex").attr("tabindex","3");
					$("input#schedule_birthday").attr("tabindex","4");
					$("input#schedule_email").attr("tabindex","5");
					$("input#schedule_homephone").attr("tabindex","6");
					$("input#schedule_address").attr("tabindex","7");
					$("input#schedule_city").attr("tabindex","8");
					$("select#schedule_state").attr("tabindex","9");
					$("input#schedule_zip").attr("tabindex","10");
					
					$("#schedule_insurance").attr("tabindex","11");
					$("#schedule_subscriber_relationship").attr("tabindex","12");
					$("#schedule_subscriber_first_name").attr("tabindex","13");
					$("#schedule_subscriber_last_name").attr("tabindex","14");
					$("#schedule_subscriber_birthday").attr("tabindex","15");
					$("#schedule_subscriber_sex").attr("tabindex","16");
					$("#schedule_subscriber_ssn1").attr("tabindex","17");
					$("#schedule_subscriber_ssn2").attr("tabindex","18");
					$("#schedule_subscriber_ssn3").attr("tabindex","19");
					$("#schedule_subscriber_employer").attr("tabindex","20");
					$("#schedule_subscriber_id").attr("tabindex","21");
					$("#schedule_group_num").attr("tabindex","22");
					$("#schedule_subscriber_address").attr("tabindex","23");
					$("#schedule_subscriber_city").attr("tabindex","24");
					$("#schedule_subscriber_state").attr("tabindex","25");
					$("#schedule_subscriber_zip").attr("tabindex","26");
					$("#submitBtn").attr("tabindex","27");
					
					$('#schedule_birthday').keyup(function(){
						$('#schedule_subscriber_birthday').val($('#schedule_birthday').val());
					});
					
					$("#schedule_subscriber_relationship").change(function(){    
						$('#schedule_subscriber_birthday').val('');  
					});
					
					$('#same-as-patient').click(function() {
						
						var schedule_address = $("#schedule_address").val();
						var schedule_city = $("#schedule_city").val();
						var schedule_state = $("#schedule_state").val();
						var schedule_zip = $("#schedule_zip").val();
						
						if ($(this).prop("checked")) {
							$("#schedule_subscriber_address").val( schedule_address );
							$("#schedule_subscriber_city").val( schedule_city );
							$("#schedule_subscriber_state").val( schedule_state );
							$("#schedule_subscriber_zip").val( schedule_zip );
						}
					});
										
					$("#schedule_ssn1").parent().parent().addClass("schedule-ssn");
					$(".schedule-ssn").hide();
					
					$("#schedule_preferred_language").parent().prev().addClass("languagelabel");
					
					$("#schedule_preferred_language").hide();
					$(".languagelabel").hide();
					
					$("#schedule_has_insurance3").parent().addClass("hasins3");
					$(".hasins3").hide();
					
					$(".phonenum").each(function() {
						  $(this).text(function(i, text) {
								text = text.replace(/(\d\d\d)(\d\d\d)(\d\d\d\d)/, "($1) $2-$3");
								return text;
							});
						});
					
					$('.phonenav a').each(function() {
						$(this).click(function() {
    						$(this).on("change", null, function() {
      							$('select#schedule_phone_type').val($(this).attr('class'))
    						});
						});
					});
					
  				});
				
				if ( $( ".error" ).length ) {

					$("input[type='radio'][name='schedule_has_insurance']").prop( "checked", false );

				}
				
			

          $("input[type='radio'][name='schedule_has_insurance']").change(function() {
              if (this.value === 'Yes') { 
				  
				  $('.requiredField2').each(function (i, el) {
					var data = $(el).val();
					// console.log(i + ': ' + data);
					var len = data.length;
					if (len<1) {
						$(this).css("border-color","red");
						$("input[type='radio'][name='schedule_has_insurance']").prop( "checked", false );
					} else {
						$(this).css("border-color","#cccccc");
					}
				});
				  
                  $("#insurance_section").slideDown(function(){
                     checkInsuranceRequiredFields();
                     checkSubscriberRequiredFields();
                  });
				  $(".insurance_section.right").slideDown();
              }
              else {
				  $('.requiredField2').each(function (i, el) {
					var data = $(el).val();
					// console.log(i + ': ' + data);
					var len = data.length;
					if (len<1) {
						$(this).css("border-color","red");
						$("input[type='radio'][name='schedule_has_insurance']").prop( "checked", false );
					} else {
						$(this).css("border-color","#cccccc");
					}
				});
				  
                  $("#insurance_section").slideUp(function(){
                    $(".insuranceRequiredField").removeAttr("required").removeAttr("invalid");
                    $(".subscriberRequiredField").removeAttr("required").removeAttr("invalid");
                  });
				  $(".insurance_section.right").slideUp();
              }
          });
				
				
					
					$(".smallInfo.smallmoveme2").detach().prependTo(".insurance_section.left");
					$(".movebr").detach().prependTo(".insurance_section.left");
					$(".smallInfo.smallmoveme1").detach().prependTo(".insurance_section.left");

  				$("#schedule_sex").change(function(){
  					$("#schedule_subscriber_sex option:contains("+ $(this).val() +")").attr('selected', true);
  				});

  				$("#schedule_subscriber_relationship").change(function(){
  					$('#schedule_subscriber_ssn1').val('');
  					$('#schedule_subscriber_ssn2').val('');
  					$('#schedule_subscriber_ssn3').val('');
  				});

  				var $viewportMeta = $('meta[name="viewport"]');
  				$('input, select, textarea').bind('focus blur', function(event) {
  				$viewportMeta.attr('content', 'width=device-width,initial-scale=1,maximum-scale=' +        (event.type == 'blur' ? 10 : 1));
  				});

  			</script>

<style>
	#schedule_ssn1, #schedule_ssn3, #schedule_subscriber_ssn1, #schedule_subscriber_ssn3 {width: 65px;}
	#schedule_ssn2, #schedule_subscriber_ssn2 {width: 25px;}
</style>
  		</form>
  	</div>

    <?
    }
  }
}
    include("foot.php");
    ?>
