<?

if (defined('PORTAL_MAIL_DOWN') && PORTAL_MAIL_DOWN) {
	$error = "We're sorry, but the online scheduler is not currently available.  We are working to bring it back up, and apologize for the inconvenience.";
} else if ((!isset($_GET['loc'])) && (!isset($_SESSION['schedule_location']))) {
	if (sessionExpired()) {
		$error = "We're sorry, but your session has been idle too long and has expired.  You must come back here from the ".
				"patient portal's <a class=\"basicLink\" href=\"schedule_choose.php\">Schedule Appointment</a> page, or from " .
				"the <a class=\"basicLink\" href=\"https://www.webeca.com/locations/\">Find a Location</a> page.";
	} else {
		$error = "You must come to this page from the <a class=\"basicLink\" href=\"https://www.webeca.com/locations/\">" .
				"Find a Location</a> page, or from the patient portal's <a class=\"basicLink\" href=\"schedule_choose.php\">" .
				"Schedule Appointment</a> page in order to schedule appointments for the appropriate office.";
	}
}

//Get the location for the number passed in, or the session's location if already set
$location = null;
$locationNumber = $_GET['loc'];
if ($locationNumber != null) {
  if (strlen($locationNumber) == 32) {
    //Assume it's a UID
    $location = getLocationByUID($locationNumber);
  } else {
    //Priority goes to $_GET['loc'], so location can be overridden even if already set
    $location = getLocationByNumber($locationNumber);
  }
} else if (isset($_SESSION['schedule_location']) && isset($_SESSION['schedule_location_db'])) {
  //If $_GET['loc'] isn't set, it may be that they clicked a back link - see if loc is already set
  $locationUID = $_SESSION['schedule_location'];
  $locationDB = $_SESSION['schedule_location_db'];

  $location = new Location($locationDB);
  if (!$location->setFromFirstWhere('uid', $locationUID, '=', array($locationDB), true)) {
    $location = null;
  }
}

//After those options, if location is still null, it's a fatal error
if ($location == null) {
  if (sessionExpired()) {
    $error = "We're sorry, but your session has been idle too long and has expired.  You must come back here from the ".
        "patient portal's <a class=\"basicLink\" href=\"schedule_choose.php\">Schedule Appointment</a> page, or from " .
        "the <a class=\"basicLink\" href=\"https://www.webeca.com/locations/\">Find a Location</a> page.";
  } else {
    $error = "You must come to this page from the <a class=\"basicLink\" href=\"https://www.webeca.com/locations/\">" .
        "Find a Location</a> page, or from the patient portal's <a class=\"basicLink\" href=\"schedule_choose.php\">" .
        "Schedule Appointment</a> page in order to schedule appointments for the appropriate office.";
  }
}
?>
