<?
require_once('includes/conf.php');
enforcedSessionStart();

require_once('includes/portalutils.php');
require_once('secure_message.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/location.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/backend/axis/GetCurrentContactRxsMessage.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/backend/axis/GetCurrentExamRxsMessage.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/backend/axis/GetCurrentLensRxsMessage.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/fullnameformatter.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/dateformatter.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/phonenumberformatter.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/ContactRxFormatter.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/LensRxFormatter.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/ExamRxFormatter.php');

$employee = getEmployee(true);
if ($employee != null) {
	$continue = true;
	
	$getContacts = ($_GET['contacts'] == 1);
	$getExamLens = ($_GET['exam_lens'] == 1);

	$error = null;
	if ($_GET['error'] != null) {
		if ($_GET['error'] == 'no_response') {
			$error = "You did not select a default response to send.  Please select one and try again.";
		} else {
			$error = "An unknown error occurred when choosing those prescriptions.  The IT department has been notified of the issue.  Please try again.";
		}
	} else if ($_POST['formSubmit'] != null) {
		//Form posted back to this page.  Interpret appropriately.
		$found = false;
		$map = array('Contact'=>array(), 'Exam'=>array(), 'Lens'=>array());
		//Get all "final_[type]rx_[uid]" post vars
		foreach ($_POST as $postField=>$postVal) {
			$uid = null;
			if (strlen($postField) > 11 && substr($postField, 0, 11) == 'final_clrx_') {
				$map['Contact'][] = $postVal;
				$uid = substr($postField, 11);
				$found = true;
			} else if (strlen($postField) > 13 && substr($postField, 0, 13) == 'final_examrx_') {
				$map['Exam'][] = $postVal;
				$uid = substr($postField, 13);
				$found = true;
			} else if (strlen($postField) > 13 && substr($postField, 0, 13) == 'final_lensrx_') {
				$map['Lens'][] = $postVal;
				$uid = substr($postField, 13);
				$found = true;
			}
			//Look for associated notes
			if ($uid != null) {
				$notes = $_POST['notes_' . $uid];
				if ($notes != null && $notes != '') {
					$map['Notes'][$uid] = $notes;
				}
			}
		}
		if (!$found) {
			$error = "You must choose at least one prescription to mark as final for the patient.";
		} else {
			$_SESSION['final_rxs'] = serialize($map);
			$_SESSION['final_rx_patient'] = $_POST['patUID'];
			$_SESSION['final_rx_message'] = $_POST['message_id'];
			header('location:submit_final_rx.php');
			$continue = false;
		}
	}

	if ($continue) {
		$patUID = "";
		if (isset($_POST['patUID'])) {
			$patUID = $_POST['patUID'];
		} else {
			$patUID = $_GET['patient'];
		}
		if (isset($_POST['message_id'])) {
			$messageId = $_POST['message_id'];
		} else {
			$messageId = $_GET['message_id'];
		}

		if ($patUID == null) {
			$error = "No patient selected.  You must come here from the email request for recent prescriptions.";
		} else {
			$patient = new Patient(null);
			if (!$patient->setFromFirstWhere('uid', $patUID, '=')) {
				$patient = null;
			}
			if ($patient == null) {
				$error = "No patient found.  You must come here from the email request for recent prescriptions.";
			} else {
				//Load contact rx's
				if ($getContacts) {
					$msg = new GetCurrentContactRxsMessage('cec_portal');
					try {
						$clRxs = $msg->getCurrentContactRxs($patUID);
					} catch (Exception $e) {
						$error = "Error loading recent contact rx's for the given patient.";
					}
				}
				
				if ($getExamLens) {
					//Load exam rx's
					$msg = new GetCurrentExamRxsMessage('cec_portal');
					try {
						$examRxs = $msg->getCurrentExamRxs($patUID);
					} catch (Exception $e) {
						$error = "Error loading recent exam rx's for the given patient.";
					}
					
					//Load lens rx's
					$msg = new GetCurrentLensRxsMessage('cec_portal');
					try {
						$lensRxs = $msg->getCurrentLensRxs($patUID);
					} catch (Exception $e) {
						$error = "Error loading recent lens rx's for the given patient.";
					}
				}
				
				if (!($getContacts || $getExamLens)) {
					$error = "Neither contact nor exam/lens prescriptions are chosen.  Make sure you only come to this page from the patient's secure rx request message.  If you did, please inform the IT department so the issue can be investigated further.";
				} else if ((!isset($clRxs) || count($clRxs) == 0) && (!isset($examRxs) || count($examRxs) == 0) && (!isset($lensRxs) || count($lensRxs) == 0)) {
					$error = "No recent prescriptions found for this patient.";
				}
			}
		}
		$title='EyeCare Associates - Select Final Prescriptions';
		include("template.php");

		$subMenu = "portal_menu.jpg";
		$subMenuName = "employee_menu";
		include("head.php");

		$fnf = new FullNameFormatter();
		$dateFormat = new DateFormatter('m/d/Y');
		$patName = $fnf->format($patient);
		
		$formAdded = !isset($error);
		if (isset($error)) {
			echo "<div class=\"error\">$error</div>\n";
		} else {
			$typeStr = "";
			if ($getContacts != $getExamLens) {
				$typeStr = ($getContacts ? "CL " : "Exam/Lens ");
			}
			echo "<h1>" . $typeStr . "Prescription Request for $patName</h1>\n";
			//Load the message with the given ID.  Failure means we can't auto-reply (old rx request messages and alerts didn't include the original message ID).
			$replyToUID = $employee->getFieldValue('uid');
			if ($messageId != null && trim($messageId) != "" && $replyToUID != null && trim($replyToUID) != "") {
				$message = getSecureMessage($replyToUID, $messageId, false);
			}
			if ($message != null) {
			?>
			<div id="dividedSections"><div class="dividedSection">
				<h2>Select Default Response</h2>
				<form id="boilerplateForm" method="POST" action="send_secure_message.php">
					<input type="hidden" id="messageSender" name="messageSender" value="<? echo $replyToUID; ?>" />
					<input type="hidden" id="messageRecipient" name="messageRecipient" value="<? echo $patUID; ?>" />
					<input type="hidden" id="messageSubject" name="messageSubject" value="<? echo getSubject($message); ?>" />
					<textarea id="messageBody" name="messageBody" style="display: none;"></textarea>
					<input type="hidden" id="replyToID" name="replyToID" value="<? echo urlencode($messageId); ?>" />
					<input type="hidden" id="replyToRecipient" name="replyToRecipient" value="<? echo $replyToUID; ?>" />
					<div class="spaced">
						<label for="boilerplateResponse">Response: </label>
						<select id="boilerplateResponse" name="boilerplateResponse">
							<option value=""></option>
							<option value="expired">Your prescription has expired...</option>
							<option value="not_final">Your CL prescription is not yet final...</option>
							<option value="on_vacation">On vacation...</option>
						</select>
					</div>
					<p><strong>Preview:</strong></p>
					<div id="boilerplatePreview" style="display: none;"></div>
					<div id="boilerplateSubmitDiv" class="spaced" style="display:none;"><input type="button" id="boilerplateSubmit" value="Send the Above Reply" /></div>
				</form>
				<script type="text/javascript">
					$("#boilerplateResponse").change(function() {
						var val = $("#boilerplateResponse").val();
						var show = true;
						//Figure out which option was selected.
						<?
						$fnf2 = new FullNameFormatter(null, false);
						$proName = $fnf2->format($employee);
						echo "var drName=\"$proName\";\n\t\t\t\t\t\t";
						$mainPhone = MAIN_PHONE;
						echo "var mainPhone = \"$mainPhone\";\n\t\t\t\t\t\t";
						$lastApp = getLastAppointmentForPatient($patient);
						echo "/*LAST APP: " . dump($lastApp) . "*/";
						if ($lastApp != null) {
							//Format the location by getting its name
							$lastLocationUID = $lastApp->getFieldValue('location');
							$lastLocation = new Location($lastApp->getDatabaseName(), $lastLocationUID);
							$pnf = new PhoneNumberFormatter();
							$locPhone = $pnf->format($lastLocation->getFieldValue('phone1'));
						}
						if ($mainPhone != null) {
							if ($locPhone != null) {
								echo "var phoneStr = \"the office at $locPhone (or call us at $mainPhone)\";\n";
								echo "var expPhoneStr = \", call the office at $locPhone, or call us at $mainPhone today\";\n";
							} else {
								echo "var phoneStr = \"us at $mainPhone\";\n";
								echo "var expPhoneStr = \", or give us a call at $mainPhone today\";\n";
							}
						} else {
							if ($locPhone != null) {
								echo "var phoneStr = \"the office at $locPhone\";\n";
								echo "var expPhoneStr = \", or call the office at $locPhone today\";\n";
							} else {
								//Not much we can do here.  Just tell them to call their local office.
								$practiceName = COMPANY_NAME;
								echo "var phoneStr = \"your local $practiceName office\";\n";
								echo "var expPhoneStr = \", or call your local $practiceName office today\";\n";
							}
						}
						?>
						if (val == 'expired') {
							$("#messageBody").text("Hello <? echo ucwords(strtolower($patient->getFieldValue('firstname'))); ?>,\n\nPlease note all written prescriptions are valid for one year, and your prescriptions are now expired.  Any orders placed with the prescriptions would no longer be valid.\n\nI encourage you to schedule an appointment online at http://www.webeca.com/portal/schedule_choose.php" + expPhoneStr + ". I look forward to seeing you in soon to evaluate the health of your eyes.\n\nSincerely,\n\nDr. " + drName);
						} else if (val == 'not_final') {
							$("#messageBody").text("Hello <? echo ucwords(strtolower($patient->getFieldValue('firstname'))); ?>,\n\nYour contact lens prescription is not yet final.  A follow-up fitting evaluation to ensure your vision and lens comfort is required in order to share this prescription with you. Please call " + phoneStr + " to schedule a contact lens fitting. We look forward to seeing you in soon.\n\nSincerely,\n\nDr. " + drName);
						} else if (val == 'on_vacation') {
							$("#messageBody").text("Hello <? echo ucwords(strtolower($patient->getFieldValue('firstname'))); ?>,\n\nI have received your request, but will not be able to reply in a timely manner. Please call " + phoneStr + " during normal business hours and someone will be happy to help you.\n\nSorry for the inconvenience,\n\nDr. " + drName);
						} else {
							$("#messageBody").text("");
							show = false;
						}
						$("#boilerplatePreview").html($("#messageBody").val().replace(/\n/g, "<br />\n"));
						//Show or hide the preview
						$("#boilerplatePreview").toggle(show);
						$("#boilerplateSubmitDiv").toggle(show);
					});
					
					$("#boilerplateSubmit").click(function() {
						var val = $("#boilerplateResponse").val();
						if (val == '' || val == null) {
							$("#boilerplateError").text("You must select a reply first.");
							$("#boilerplateError").slideDown(500);
						} else {
							displayWaitAnimation('altWaitOverlay', "Sending reply.  Please wait...");
							$("#boilerplateForm").submit();
						}
					});
				</script>
			</div>
			<div class="dividedSection">
				<h2>Or Reply Directly</h2>
				<a class="basicLink" href="<? echo "new_message.php?replyTo=" . urlencode($messageId) . "&replyToUID=$replyToUID"; ?>">Reply directly to the request with a secure message to the patient</a>
			</div>
			<?
			} //End if reply-to message is not null.
			echo "<div class=\"dividedSection\">\n";
			echo "<h2>Or Select Prescriptions Below</h2>\n";
			echo "<form method=\"POST\" action=\"select_final_rx.php\">\n";
			echo "<input type=\"hidden\" name=\"formSubmit\" value=\"1\" />\n";
			echo "<input type=\"hidden\" name=\"patUID\" value=\"$patUID\" />\n";
			echo "<input type=\"hidden\" name=\"message_id\" value=\"$messageId\" />\n";
		}
		
		//Contact prescriptions
		if (isset($clRxs) && count($clRxs) > 0) {
			$selectAll = "";
			$rxFormatter = new ContactRxFormatter();
			echo "<h3 class=\"orange\">CL Prescriptions</h3>\n";
			foreach ($clRxs as $rx) {
				echo "<div class=\"rx\">\n";
				$finalRxUid = $rx->getFieldValue('uid');
				$id = "final_clrx_$finalRxUid";
				echo "<div class=\"rxHeading\"><label for=\"$id\"><input type=\"checkbox\" id=\"$id\" name=\"$id\" value=\"$finalRxUid\" />" .
						$rxFormatter->formatField('contact', $rx->getFieldValue('contact')) . ' on ' . $dateFormat->format($rx->getFieldValue('date')) . "</div>\n";
				$eye = $rx->getFieldValue('eye');
				echo $rxFormatter->formatTable($rx, $eye);
				$notesID = "notes_$finalRxUid";
				if ($rx->getFieldValue('notes') != null) {
					echo "<div style=\"margin-top: 4px; margin-bottom: 6px;\">" . $rx->getFieldValue('notes') . "</div>";
				}
				echo "<div><label for=\"$notesID\">Description: </label><input type=\"text\" id=\"$notesID\" name=\"$notesID\" size=\"50\" /></div>";
				echo "\n</div>";
				$selectAll .= $id . ' ';
				/* if ($eye === 3 || $eye === '3' || $eye === 'Both' || $eye === 1 || $eye === '1' || $eye === 'Right') {
					echo "<div><span style=\"font-weight: bold;\">" . $rxFormatter->formatField('eye', $rx->getFieldValue('eye')) . ": </span>" . $rxFormatter->formatRx($rx, 1) . "</div>\n";
				}
				if ($eye === 3 || $eye === '3' || $eye === 'Both' || $eye === 2 || $eye === '2' || $eye === 'Left') {
					echo "<div><span style=\"font-weight: bold;\">" . $rxFormatter->formatField('eye', $rx->getFieldValue('eye')) . ": </span> " . $rxFormatter->formatRx($rx, 2) . "</div>\n";
				} */
			}
			echo "<div class=\"bulkRxButtons\"><input type=\"button\" value=\"Select All CL\" onclick=\"selectAll('$selectAll', true);\"> <input type=\"button\" value=\"Unselect All CL\" onclick=\"selectAll('$selectAll', false);\"></div>";
		}
		
		//Exam prescriptions
		if (isset($examRxs) && count($examRxs) > 0) {
			$selectAll = "";
			$rxFormatter = new ExamRxFormatter();
			echo "<h3 class=\"orange\">Exam Prescriptions</h3>\n";
			foreach ($examRxs as $rx) {
				echo "<div class=\"rx\">\n";
				$finalRxUid = $rx->getFieldValue('uid');
				$id = "final_examrx_$finalRxUid";
				echo "<div class=\"rxHeading\"><label for=\"$id\"><input type=\"checkbox\" id=\"$id\" name=\"$id\" value=\"$finalRxUid\" ></input>" . 'Rx on ' . $dateFormat->format($rx->getFieldValue('date')) . "</label></div>\n";
				$selectAll .= $id . ' ';
				$eye = $rx->getFieldValue('eye');
				echo $rxFormatter->formatTable($rx, $eye);
				if ($rx->getFieldValue('notes') != null) {
					echo "<div style=\"margin-top: 4px; margin-bottom: 6px;\">" . $rx->getFieldValue('notes') . "</div>";
				}
				$notesID = "notes_$finalRxUid";
				echo "<div><label for=\"$notesID\">Description: </label><input type=\"text\" id=\"$notesID\" name=\"$notesID\" size=\"50\" /></div>";
				echo "\n</div>";
			}
			echo "<div class=\"bulkRxButtons\"><input type=\"button\" value=\"Select All Exam\" onclick=\"selectAll('$selectAll', true);\"> <input type=\"button\" value=\"Unselect All Exam\" onclick=\"selectAll('$selectAll', false);\"></div>";
		}
		
		//Lens prescriptions
		if (isset($lensRxs) && count($lensRxs) > 0) {
			$selectAll = "";
			$rxFormatter = new LensRxFormatter();
			echo "<h3 class=\"orange\">Lens Prescriptions</h3>\n";
			foreach ($lensRxs as $rx) {
				echo "<div class=\"rx\">\n";
				$finalRxUid = $rx->getFieldValue('uid');
				$id = "final_lensrx_$finalRxUid";
				echo "<div class=\"rxHeading\"><label for=\"$id\"><input type=\"checkbox\" id=\"$id\" name=\"$id\" value=\"$finalRxUid\" ></input>" . 'Rx on ' . $dateFormat->format($rx->getFieldValue('date')) . "</label></div>\n";
				$selectAll .= $id . ' ';
				$eye = $rx->getFieldValue('eye');
				echo $rxFormatter->formatTable($rx, $eye);
				if ($rx->getFieldValue('notes') != null) {
					echo "<div style=\"margin-top: 4px; margin-bottom: 6px;\">" . $rx->getFieldValue('notes') . "</div>";
				}
				$notesID = "notes_$finalRxUid";
				echo "<div><label for=\"$notesID\">Description: </label><input type=\"text\" id=\"$notesID\" name=\"$notesID\" size=\"50\" /></div>";
				echo "\n</div>";
			}
			echo "<div class=\"bulkRxButtons\"><input type=\"button\" value=\"Select All Lens\" onclick=\"selectAll('$selectAll', true);\"> <input type=\"button\" value=\"Unselect All Lens\" onclick=\"selectAll('$selectAll', false);\"></div>";
		}
		if ($formAdded) {
			echo "<div><input name=\"submit\" type=\"submit\" value=\"Submit\" /></div></form></div></div>\n";
		}
		include("foot.php");
	} //End if we should show the form
} //End if employee is logged in
?>