<?

require_once('schedule_details.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/dateformatter.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/fullnameformatter.php');
//require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/firstperwordcapsformatter.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/zipcodeformatter.php');

function sendAppointmentConfirmation($location, $patUID, $firstName, $provider, $email) {
	$fullNameFormatter = new FullNameFormatter(null, false);
	//$dateFormatter = new DateFormatter('m/d/Y');
	$dateFormatter = new DateFormatter('F d, Y');
	$timeFormatter = new DateFormatter('h:i A');
	//$firstnameFormatter = new FirstPerWordCapsFormatter();
	$zipFormatter = new ZipCodeFormatter();
	
	//$patientName = $fullNameFormatter->format($patient);
	//$locationName = $location->getFieldValue('name');
	$providerName = 'Dr. ' . $fullNameFormatter->format($provider);
	$apptDate = $dateFormatter->format($_SESSION['schedule_time']);
	$apptTime = $timeFormatter->format($_SESSION['schedule_time']);
	//$firstName = $firstnameFormatter->format($patient->getFieldValue('firstname'));
	$locStreet = $location->getFieldValue('address');
	$locCity = $location->getFieldValue('city');
	$locState = $location->getFieldValue('state');
	$locZip = $zipFormatter->format($location->getFieldValue('zip'));
	
	if ($patUID == RESERVED_PATIENT) {
		$wsHref = "https://www.webeca.com/wp-content/uploads/sites/12/2017/12/Welcome-Sheet_ECA.pdf";
	} else {
		$wsHref = "https://www.webeca.com/portal/online_welcome_sheet.php?patient=$patUID";
	}
	$welcomeSheetText = "<a href=\"$wsHref\" target=\"_blank\"><img src=\"http://www.webeca.com/images/emails/Complete-Pat-Info.jpg\" width=\"373\" height=\"177\" align=\"absbottom\" style=\"display: block;\" alt=\"Click here to Complete Your Patient Info Sheet before your appointment\" title=\"Click here to Complete Your Patient Info Sheet before your appointment\" /></a>";
	
	$practiceLogoUrl = "http://www.webeca.com/images/emails/header-center-eca.jpg";
	$facebookURL = "https://www.facebook.com/EyeCareAssociates";
	$twitterURL = "https://twitter.com/EyeCareAssocia";
	$yelpURL = "http://www.yelp.com/biz/eyecare-associates-inc-birmingham-3";
	
	$subject = "EyeCare Associates Appointment Confirmation";
	$message = "<link href=\"https://fonts.googleapis.com/css?family=Montserrat\" rel=\"stylesheet\" type=\"text/css\">
	<style type=\"text/css\">
table { border-collapse:collapse; mso-table-lspace:0pt; mso-table-rspace:0pt; }
img {
    -ms-interpolation-mode: bicubic;
}</style>
	<div style=\"width: 800px; border: 1px solid #000;\">

<table width=\"800\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">
  <tbody>
    <tr>
      <td width=\"203\" height=\"444\" rowspan=\"2\" valign=\"top\">
      <img src=\"http://www.webeca.com/images/emails/AppntConfirm-left2.jpg\" width=\"203\" height=\"444\" align=\"absbottom\" style=\"display: block;\" />
      </td>
      <td width=\"597\" height=\"130\" valign=\"top\">
<img src=\"$practiceLogoUrl\" align=\"absbottom\" width=\"400\" height=\"130\" style=\"display: block;\" />
      </td>
      <td width=\"197\" height=\"130\" valign=\"top\">
      <img src=\"http://www.webeca.com/images/emails/AllEmails-header-right.jpg\" align=\"absbottom\" width=\"197\" height=\"130\" style=\"display: block;\" />
      </td>
    </tr>
    <tr>
      <td width=\"597\" height=\"314\" colspan=\"2\" valign=\"top\">
      
      <table width=\"597\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">
          <tbody>
            <tr>
              <td width=\"23\" rowspan=\"4\">
              	<img src=\"http://www.webeca.com/images/emails/spacer.png\" align=\"absbottom\" width=\"23\" height=\"5\" style=\"display: block;\" />
              </td>
              <td width=\"574\" height=\"11\"><img src=\"http://www.webeca.com/images/emails/spacer.png\" align=\"absbottom\" width=\"5\" height=\"11\" style=\"display: block;\" /></td>
            </tr>
            <tr>
              <td width=\"574\" height=\"32\" valign=\"top\">
              <font face=\"Montserrat, Verdana, Arial, Helvetica, sans-serif\" color=\"#007bc8\" size=\"4\">
              <span style=\"font-family: 'Montserrat', Verdana, Arial, Helvetica, sans-serif; size: 30px; color: #007bc8;\">
              <strong>Appointment Confirmation</strong>
              </span>
              </font>
              </td>
            </tr>
            <tr>
              <td width=\"574\" height=\"13\">
              	<img src=\"http://www.webeca.com/images/emails/spacer.png\" align=\"absbottom\" width=\"5\" height=\"13\" style=\"display: block;\" />
              </td>
            </tr>
            <tr>
              <td width=\"574\" height=\"210\" valign=\"top\" align=\"left\">
              <table width=\"555\" cellpadding=\"0\" cellspacing=\"0\" border=\"0\">
              <tbody>
              	<tr>
                	<td width=\"555\" height=\"10\" colspan=\"3\"><img src=\"http://www.webeca.com/images/emails/Infobox-Top-555x10.jpg\" align=\"absbottom\" width=\"555\" height=\"10\" style=\"display: block;\" /></td>
                </tr>
              	<tr>
                	<td width=\"28\" height=\"230\"><img src=\"http://www.webeca.com/images/emails/Infobox-left.jpg\" align=\"absbottom\" width=\"28\" height=\"230\" style=\"display: block;\" /></td>
                	<td width=\"499\" height=\"230\" valign=\"top\">
                    	<table width=\"499\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">
                        	<tbody>
                        	<tr>
                              <td colspan=\"2\" width=\"499\" height=\"10\">
                                <img src=\"http://www.webeca.com/images/emails/spacer.png\" align=\"absbottom\" width=\"5\" height=\"10\" style=\"display:block;\" />
                              </td>
                             </tr>
                        <tr>
                          <td colspan=\"2\" valign=\"top\" width=\"499\">
                          <font face=\"Verdana, Arial, Helvetica, sans-serif\" color=\"#007bc8\" size=\"3\">
                                <span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: #007bc8; size: 18px;\">
                                <strong>$firstName,</strong>
                                </span>
                                </font>
                              <img src=\"http://www.webeca.com/images/emails/spacer.png\" align=\"absbottom\" width=\"499\" height=\"2\" style=\"display:block; clear: both;\" /><br>
                                <font face=\"Verdana, Arial, Helvetica, sans-serif\" color=\"#000000\" size=\"3\">
                                <span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: #000; size: 18px;\">
                                Thank you for scheduling an appointment online.
                                </span>
                            </font>
                          </td>
                        <tr>
                          <td colspan=\"2\" width=\"499\" height=\"15\">
                          	<img src=\"http://www.webeca.com/images/emails/spacer.png\" align=\"absbottom\" width=\"5\" height=\"15\" style=\"display: block;\" />
                          </td>
                          </tr>
                        <tr>
                          <td valign=\"top\"> 
                                <font size=\"3\"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: #007bc8; size: 20px;\"><strong>With</strong></span></font><font face=\"Verdana, Arial, Helvetica, sans-serif\" color=\"#007bc8\" size=\"3\"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: #007bc8; size: 20px;\"><strong>:</strong>
                                </span>
                                </font>
                              </td>
                          <td valign=\"top\">
                          <font face=\"Verdana, Arial, Helvetica, sans-serif\" color=\"#000000\" size=\"3\">
                                <span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: #000; size: 20px;\">
                                $providerName
                                </span>
                                </font> 
                              </td>
                        </tr>
                        <tr>
                          <td colspan=\"2\" width=\"499\" height=\"10\">
                          	<img src=\"http://www.webeca.com/images/emails/spacer.png\" width=\"5\" height=\"10\" align=\"absbottom\" style=\"display:block;\" />
                          </td>
                          </tr>
                        <tr>
                          <td valign=\"top\">
                                <font size=\"3\"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: #007bc8; size: 20px;\"><strong>When</strong></span></font><font face=\"Verdana, Arial, Helvetica, sans-serif\" color=\"#007bc8\" size=\"3\"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: #007bc8; size: 20px;\"><strong>:</strong>
                                </span>
                                </font>
                              </td>
                          <td valign=\"top\">
                              <font face=\"Verdana, Arial, Helvetica, sans-serif\" color=\"#000000\" size=\"3\">
                                <span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: #000; size: 20px;\">
                                $apptDate @ $apptTime
                                </span>
                                </font>
                              </td>

                        </tr>
                        <tr>
                          <td colspan=\"2\" width=\"499\" height=\"10\">
                          	<img src=\"http://www.webeca.com/images/emails/spacer.png\" width=\"5\" height=\"10\" align=\"absbottom\" style=\"display:block;\" />
                          </td>
                          </tr>
                        <tr>
                          <td valign=\"top\">
                                <font size=\"3\">
                                <span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: #007bc8; size: 20px;\">
                                <strong>Address:</strong>
                                </span>
                                </font>
                              </td>
                          <td valign=\"top\">
                              <font face=\"Verdana, Arial, Helvetica, sans-serif\" color=\"#000000\" size=\"3\">
                                <span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: #000; size: 20px;\">
                                $locStreet<br>
								$locCity, $locState $locZip
                                </span>
                                </font>
                              </td>
                        </tr>
                            </tbody>
                        </table>
                    </td>
                	<td width=\"28\" height=\"230\"><img src=\"http://www.webeca.com/images/emails/Infobox-right.jpg\" align=\"absbottom\" width=\"28\" height=\"230\" style=\"display: block;\" /></td>
                </tr>
              	<tr>
                	<td width=\"555\" height=\"10\" colspan=\"3\"><img src=\"http://www.webeca.com/images/emails/Infobox-Btm-555x10.jpg\" align=\"absbottom\" width=\"555\" height=\"10\" style=\"display: block;\" /></td>
                </tr>
               </tbody>
              </table>
              </td>
            </tr>
          </tbody>
       </table>
      	<!-- INSERT TABLE -->

      </td>
      </tr>
    <tr>
      <td width=\"800\" height=\"200\" colspan=\"3\" valign=\"top\" bgcolor=\"#007bc8\" style=\"background: #007bc8;\">
      	<table width=\"800\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">
          <tbody>
            <tr>
              <td width=\"373\" height=\"177\" valign=\"top\">
              $welcomeSheetText
              </td>
              <td width=\"427\" rowspan=\"2\" valign=\"top\" align=\"left\">
              <table width=\"415\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">
                <tbody>
                  <tr>
                    <td height=\"13\">
                    <img src=\"http://www.webeca.com/images/emails/spacer-blue.png\" align=\"absbottom\" width=\"5\" height=\"13\" style=\"display: block;\" />
                    </td>
                  </tr>
                  <tr>
                    <td height=\"13\">
                    <img src=\"http://www.webeca.com/images/emails/spacer-blue.png\" align=\"absbottom\" width=\"5\" height=\"13\" style=\"display: block;\" />
                    </td>
                  </tr>
                  <tr>
                    <td height=\"13\">
                    <img src=\"http://www.webeca.com/images/emails/spacer-blue.png\" align=\"absbottom\" width=\"5\" height=\"13\" style=\"display: block;\" />
                    </td>
                  </tr>
                  <tr>
                    <td height=\"13\">
                    <img src=\"http://www.webeca.com/images/emails/spacer-blue.png\" align=\"absbottom\" width=\"5\" height=\"13\" style=\"display: block;\" />
                    </td>
                  </tr>
                </tbody>
              </table></td>
            </tr>
            <tr>
              <td width=\"378\" align=\"left\" valign=\"top\">
                <table width=\"210\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">
                  <tbody>
                    <tr>
                      <td rowspan=\"3\" width=\"15\" height=\"85\">
                        <img src=\"http://www.webeca.com/images/emails/spacer-blue.png\" width=\"15\" height=\"85\" />
                        </td>
                      <td colspan=\"3\">
                        <font face=\"Verdana, Arial, Helvetica, sans-serif\" color=\"#ffffff\" size=\"2\">
                          <span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: #fff; size: 14px;\">
                          <strong>Find us online:</strong>
                          </span>
                          </font>
                        </td>
                      </tr>
                    <tr>
                      <td colspan=\"3\" width=\"160\" height=\"20\">
                        <img src=\"http://www.webeca.com/images/emails/spacer-blue.png\" width=\"5\" height=\"20\" />
                        </td>
                      </tr>
                    <tr>
                      <td valign=\"middle\">
                      <a href=\"$facebookURL\" target=\"_blank\">
                      <img src=\"http://www.webeca.com/images/emails/social-fb.png\" width=\"48\" height=\"48\" align=\"absbottom\" style=\"display: block;\" /></a>
                        </td>
                      <td valign=\"middle\">
                      <a href=\"$twitterURL\" target=\"_blank\">
                      <img src=\"http://www.webeca.com/images/emails/social-twitter.png\" width=\"45\" height=\"45\" align=\"absbottom\" style=\"display: block;\" /></a>
                        </td>
                      <td valign=\"middle\">
                      <a href=\"$yelpURL\" target=\"_blank\">
                      <img src=\"http://www.webeca.com/images/emails/social-yelp.png\" width=\"46\" height=\"46\" align=\"absbottom\" style=\"display: block;\" /></a>
                        </td>
                      </tr>
                    </tbody>
                  </table>
                
              </td>
              </tr>
              <tr>
              	<td colspan=\"2\">
               	  <img src=\"http://www.webeca.com/images/emails/spacer-blue.png\" width=\"800\" height=\"10\" />
                    
                	<img src=\"http://www.webeca.com/images/emails/spacer-blue.png\" width=\"800\" height=\"10\" />
                </td>
              </tr>
          </tbody>
        </table>

      </td>
      </tr>
  </tbody>
</table>

</div>";
	$headers = unserialize(RECEIPT_MAIL_HEADER_ARRAY);
	$headers['Subject'] = $subject;
	return pearMail(SMTP_HOST, SMTP_PORT, SMTP_USERNAME, SMTP_PASSWORD, $email, $message, $headers);
}

function sendAppointmentConfirmationOld($location, $patient, $provider, $email) {
	//Send the patient a confirmation email (unfortunately, tables of tables is still the accepted
	//method of layout for emails, since email clients are all terrible at rendering real HTML).
	$subject = "Webeca.com Online Scheduler Confirmation";
	$message = "<table><tr><td>
		<div style=\"padding-bottom: 6px;\"><img alt=\"EyeCare Associates Logo\" src=\"http://www.webeca.com/images/eyecare-associates-logo.jpg\" /></div>
		<table width='100%' style=\"border-width: 2px; border-style: outset; border-color: #125986;\"><tr>
			<td style=\"background-color: #125986; color: #FFFFFF; font-size: 12pt; text-align: center;\">EyeCare Associates Appointment Confirmation</td>
		</tr>
		<tr><td>";
	$message .= "<div>This message confirms that an appointment has been set up with the following details:</div>\n";
	$message .= getScheduleDetails($location, $patient, $provider);
	$message .= "<table><tr><td><a href=\"http://www.webeca.com/PDFs/Welcome%20Sheet.pdf\">" .
		"<img alt=\"Download Welcome Sheet\" style=\"border-style: none;\" " .
		"src=\"https://www.webeca.com/Imagess/welcome_sheet_link.png\" /></a></td>";
	$message .= "<td>Please click on this link to download your patient welcome sheet.<br />Bring this completed form " .
		"with you to your appointment.</td></tr></table></td></tr></table></td></tr></table>";
	return mail($email, $subject, $message, RECEIPT_MAIL_HEADERS);
}

?>
