<?
require_once('includes/conf.php');
enforcedSessionStart();

require_once('secure_message.php');
require_once('includes/portalutils.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/backend/axis/SendEmployeeMessageMessage.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/backend/axis/SendPatientMessageMessage.php');

function showSendError($message) {
	echo "<head>";
	echo "<meta http-equiv='Content-Type' content='text/html; charset=ISO-8859-1'>";
	echo "<title>Patient Portal Error</title>";
	echo "<link type='text/css' rel='stylesheet' href='//maxcdn.bootstrapcdn.com/bootstrap/2.3.2/css/bootstrap.min.css'>";
	echo "<style type='text/css'>body { background-color:transparent; }</style>";
	echo "<link href='../css/eca_main2.css' rel='stylesheet' type='text/css'>";
	echo "<link href='../css/eca_navmenu2.css' rel='stylesheet' type='text/css'>";
	echo "<link href='/css/responsive-portal.css' rel='stylesheet' type='text/css'>";
	echo "<link href='https://fonts.googleapis.com/css?family=Open+Sans:400,400italic,700,700italic' rel='stylesheet' type='text/css'>";
	echo "<link href='https://fonts.googleapis.com/css?family=Open+Sans+Condensed:700,300' rel='stylesheet' type='text/css'>";
	echo "<link href='../css/portal_enhance.css' rel='stylesheet' type='text/css'>";
	echo "<meta name='viewport' content='width=device-width, initial-scale=1, minimum-scale=1, user-scalable=1'>";
	echo "<link rel='stylesheet' type='text/css' href='../css/gateway.css'>";
	echo "<link rel='stylesheet' type='text/css' href='../css/overlay.css'>";
	echo "<link rel='stylesheet' type='text/css' href='../css/secure_messages.css'>";
	echo "</head>";
	echo "<body>";
	echo "<div id='maincontainer'><div id='toplogo'>";
	echo "<img src='/Imagess/eca-logo.png'>";
	echo "</div><div id='outertopwrapper'><div id='topwrapper'></div></div><div id='bluerule'></div><div class='spacer'></div><div id='bottomwrapper-int'><div class='ew_container'>";
	echo "<h2 class=\"orange\">Error</h2>";
	echo "<div>$message</div>";
	echo "<p><a href='javascript:history.back();'>Go Back</a></p>";
	echo "</div></div>";
}

echo dump($_POST);
$userMode = $_SESSION['userMode'];
$recipient = $_POST['messageRecipient'];
$sender = $_POST['messageSender'];
$subject = $_POST['messageSubject'];
if ($subject != null) {
	//We want subjects returned as-is; no allowing HTML entered here.
	$subject = str_replace("\\\"", "\"", $subject);
	$subject = htmlspecialchars($subject);
}
$body = $_POST['messageBody'];
if ($body != null) {
	//Don't allow adding HTML here either; it should come out exactly as-is.
	$body = str_replace("\\\"", "\"", $body);
	$body = htmlspecialchars($body);
	/*$bodyLines = explode("\n", $body);
	$newBody = "";
	foreach ($bodyLines as $bodyLine) {
		$gts = "";
		//Lines can start with a ">"; all other html special chars must be escaped.
		while (strlen($bodyLine) > 0 && strpos($bodyLine, '>') === 0) {
			$bodyLine = substr($bodyLine, 1);
			$gts .= ">";
		}
		$newBody .= $gts . htmlspecialchars($bodyLine);
	}
	$body = $newBody;
	echo dump($body);
	die();*/
}

//Get the message to which this is a reply
$replyToID = $_POST['replyToID'];
$replyToRecipient = $_POST['replyToRecipient'];
if (isset($replyToID)) {
	$replyTo = getSecureMessage($replyToRecipient, urldecode($replyToID), false);
}

$loggedIn = false;
$uid = "";
if ($userMode == PATIENT_MODE) {
	$patient = getPatient(false);
	$uid = $patient->getFieldValue('uid');
	$loggedIn = ($patient != null && isLoggedIn($patient));
} else if ($userMode == EMPLOYEE_MODE) {
	$employee = getEmployee(false);
	$uid = $employee->getFieldValue('uid');
	$loggedIn = ($employee != null && isEmployeeLoggedIn($employee));
}

if ($loggedIn) {
	if (!(isset($recipient) && isset($sender) && isset($subject) && isset($body))) {
		//Missing some fields
		showSendError("Some required message fields are not set.  You must come to this page from the \"New Message\" page.  Please go back and do so.");
	} else {
		//Message info set - send the message.
		try {
			if ($sender != null && ($sender == $uid || ($userMode == PATIENT_MODE && userHasChild($sender)))) {
				$secureMessage = new SecureMessage();
				$headers = null;
				if ($replyTo != null) {
					$headers = array('In-Reply-To' => $replyTo->getID());
				}
				$secureMessage->setFieldValue('toUID', $recipient);
				$secureMessage->setFieldValue('fromUID', $sender);
				$secureMessage->setFieldValue('subject', $subject);
				$secureMessage->setFieldValue('body', $body);
				$secureMessage->setFieldValue('headers', $headers);
				$secureMessage->setFieldValue('read', false);
				if ($userMode == PATIENT_MODE) {
					$message = new SendEmployeeMessageMessage('cec_messaging');
					$result = $message->sendEmployeeMessage($secureMessage);
				} else {
					$message = new SendPatientMessageMessage('cec_messaging');
					$result = $message->sendPatientMessage($secureMessage);
				}
				if ($result) {
					//Success - go back to messages page, and indicate success
					if ($userMode == PATIENT_MODE) {
						header('location:patient_messages.php?success=1');
					} else {
						header('location:employee_messages.php?success=1');
					}
				}
			} else {
				$childMsg = ($userMode == PATIENT_MODE ? " nor your children" : "");
				showSendError("This message is neither from you$childMsg, and therefore you cannot send it.");
			}
		} catch (Exception $e) {
			showSendError("Error sending the message.  Please try again.  The IT department has been informed of the issue and will work to resolve it as quickly as possible.");
		}
	}
} else {
	//Patient not logged in.
	showSendError("You are not logged in.  Please log into the portal before coming to this page.");
}
?>