<?
require_once('includes/conf.php');
enforcedSessionStart();

require_once('includes/portalutils.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/KeyValuePair.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/backend/axis/SendRxMessageMessage.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/backend/axis/MarkMessageReadMessage.php');

$employee = getEmployee(true);
if ($employee != null) {
	$patUID = $_SESSION['final_rx_patient'];
	if ($_SESSION['final_rxs'] != null && $_SESSION['final_rx_patient'] != null) {
		$finalRxs = unserialize($_SESSION['final_rxs']);
		$messageId = $_SESSION['final_rx_message'];
		//The finalRxs variable should be a map from type (exam, lens, or contact) to arrays of UID's.
		$msg = new SendRxMessageMessage('cec_messaging');
		try {
			//All optical rx's (i.e. both Exam and Lens) go to the same result array.  Fill that array now.
			$opticalRxs = array();
			foreach ($finalRxs['Exam'] as $examRx) {
				$notes = $finalRxs['Notes'][$examRx];
				$notes = ($notes == '' ? null : $notes);
				$opticalRxs[] = new KeyValuePair($examRx, $notes);
			}
			foreach ($finalRxs['Lens'] as $lensRx) {
				$notes = $finalRxs['Notes'][$lensRx];
				$notes = ($notes == '' ? null : $notes);
				$opticalRxs[] = new KeyValuePair($lensRx, $notes);
			}
			//Contact rx's get their own array.  Fill that array now.
			$contactRxs = array();
			foreach ($finalRxs['Contact'] as $contactRx) {
				$notes = $finalRxs['Notes'][$contactRx];
				$notes = ($notes == '' ? null : $notes);
				$contactRxs[] = new KeyValuePair($contactRx, $notes);
			}
			$empUID = $employee->getFieldValue('uid');
			if ($msg->sendRxMessage($_SESSION['final_rx_patient'], $empUID, $opticalRxs, $contactRxs)) {
				try {
					//Mark the original secure message as read, per issue #5947.
					$message = new MarkMessageReadMessage('cec_messaging');
					$result = $message->markMessageRead($empUID, $messageId);
				} catch (Exception $e2) {
					//We don't care about these exceptions; if it can't mark the original message read, just log it and move on.
					klog('Exception occurred while marking secure message as read for final rx selection.\n' . dump($e2), KLogger::ERROR);
				}
				header('location:employee_portal_main.php?success=1');
			} else {
				klog('sendRxMessage() for ' . $_SESSION['final_rx_patient'] . ' returned false', KLogger::ERROR);
				header("location:select_final_rx.php?patient=$patUID&message_id=$messageId&contacts=1&exam_lens=1&error=1");
			}
		} catch (Exception $e) {
			header("location:select_final_rx.php?patient=$patUID&error=2");
		}
	} else {
		if ($patUID != null) {
			header("location:select_final_rx.php?patient=$patUID&error=1");
		} else {
			header("location:select_final_rx.php");
		}
	}
} //End if employee is logged in
?>