<?
require_once('includes/conf.php');
require_once('includes/portalutils.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/fullnameformatter.php');

//Include the header info
$initializeTimeout = false;
$title='EyeCare Associates - Email Error';
include("template.php");
include("head.php");

$patientUID = $_GET['patient'];
$sourceID = $_GET['source'];

$patient = null;
if ($patientUID != null) {
	$patient = getPatientFromDB('cec', $patientUID, false, null);
}
if ($patient == null) {
	echo "\r\n<h1 class=\"orange\">We're Sorry...</h1>\r\n<div>The email error cannot be reported because no associated patient record could be found.  You must come to this page from the link in the email you received from EyeCare Associates.</div>";
} else {
	//Send an email to the ERROR_MAIL_TO address with the issue.
	$subject = "Patient reported unexpected email";
	$fnf = new FullNameFormatter();
	$typeStr = "UNKNOWN";
	if ($sourceID != null) {
		switch ($sourceID) {
			case 1:
				$typeStr = "Welcome Email";
				break;
			case 2:
				$typeStr = "Secure Message Email";
				break;
			default:
				$typeStr = "Unknown Type ($sourceID)";
		}
	}
	$message = "Patient indicated that they received an automated email inappropriately.\r\nPatient: " . $fnf->format($patient) . " with uid $patientUID\r\nAutomated email type: $typeStr";
	klog("Unexpected email:\n$message", KLogger::ERROR);
	$headers = unserialize(ERROR_MAIL_HEADER_ARRAY);
	$headers['Subject'] = $subject;
	if (!pearMail(SMTP_HOST, SMTP_PORT, SMTP_USERNAME, SMTP_PASSWORD, 'compliance@eyecare-partners.com', $message, $headers)) {
		klog("Failed to send \"unexpected email\" message", KLogger::ERROR);
	}
	
	//Thank the user for their help
	echo "\r\n<h1 class=\"orange\">Thank You!</h1>\r\n<div>Thank you for reporting the error with the e-mail you received.  EyeCare Associates has been informed of the issue, and will work to resolve it as soon as possible.</div>";
}

include("foot.php");
?>