<?
require_once('includes/portalutils.php');
require_once(GLOBAL_INCLUDES_DIR . '/springfield/backend/axis/validatewelcomesheetmessage.php');
require_once(GLOBAL_INCLUDES_DIR . '/xml_utils.php');

//TODO - Replace these dummy results with real results based on validation
//$hadError = 'true';
//$results = '[{"name":"patient__firstname","value":"I hate that first name.  Pick a different one."}, {"name":"patient__ssn","value":"You really shouldn\'t type in that SSN online!"}]';

//Echo the results as a JSON object.
//echo '{"hadError":' . $hadError . ', "results":' . $results . '}';

//Build the enumeration choices
$enumChoices = buildWelcomeSheetEnumerations();

$xmlFile = $_POST['xml_file'];
//Get the XML document with field values substituted as named text fields' text
$doc = getDOMFromFile($xmlFile);
$textMap = $_POST;
$keyMap = convertToISODates($textMap, $doc);
$keyMap = array_merge($keyMap, getEnumerationKeys($textMap, $doc));
$textMap = replaceEnumerationText($textMap, $doc, $enumChoices);
$doc = mapToXML($keyMap, $textMap, $doc);
$welcomeSheetStr = $doc->saveXML();

//Get the validation results
$msg = new ValidateWelcomeSheetMessage('cec_welcomesheet');
try {
	$result = $msg->validateWelcomeSheet($_POST['patUID'], $welcomeSheetStr);
} catch (Exception $e) {
	//In the case of an exception, $result will be null.  This indicates something went wrong.
}

//Parse the validation results
if (isset($result)) {
	if ($result->isValid()) {
		//Results were valid - just inform the caller as such in a JSON object
		echo '{"hadError":false,"hadException":false}';
	} else {
		//Results were invalid - include invalid items in the resulting JSON object
		$str = '{"hadError":true,"hadException":false,"results":[';
		//Add a result for each invalid element
		$invalidElements = $result->getInvalidElements();
		foreach ($invalidElements as $invalidElement) {
			$str .= '{"name":"patient__' . $invalidElement->getName() . '","value":"' . $invalidElement->getReason() . '"}';
		}
		echo $str . ']}';
	}
} else {
	//Result is null - this means an exception occurred, or something weird happened when sending the message.
	echo '{"hadError":true,"hadException":true,"results":[]}';
}
?>