<?
require_once('includes/conf.php');
enforcedSessionStart();

require_once('includes/portalutils.php');
require_once(GLOBAL_INCLUDES_DIR . 'process_xslt.php');
require_once(GLOBAL_INCLUDES_DIR . 'config.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/invalidelement.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/formatters/fullnameformatter.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/backend/emrdatacenter/healthquery.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/backend/emrdatacenter/emrdatacenterresult.php');
require_once(GLOBAL_INCLUDES_DIR . 'springfield/backend/emrdatacenter/emrresultfactory.php');

//Make sure patient is logged in first
$mainPatient = getPatient();
$logged_in = isLoggedIn($mainPatient);
$patientNum = $_GET['patientNum'];
$chosenPatient = null;
if (!isset($patientNum)) {
	$patientNum = 0;
	$chosenPatient = $mainPatient;
}

if (!$logged_in) {
	$_SESSION['referral_page'] = $_SERVER['PHP_SELF'];
	header('location:login.php');
} else {
	//Include the header info
	$title='EyeCare Associates - View Health Information';
	include("template.php");
	
	$drawArrow = false;
	$subMenu = "portal_menu.jpg";
	$rightPadding = 50;
	include("head.php");
	
	//echo "<h1 class=\"orange\">Health Information Overview</h1>\n";
	
	//Loop through each patient under the account
	$patients = getAllUnderAccount($mainPatient);
	$fnf = new FullNameFormatter(null, false);
	$num = 0;
	
	//Only list patients under the account if > 1
	if (isset($patients) && count($patients) > 1) {
		echo "<div class=\"bigorange spaced\">Choose Patient</div>\n<div class=\"spaced\">";
		foreach ($patients as $patient) {
			echo "<div class=\"basicMedium boldText\">";
			if ($num == $patientNum) {
				//This is the chosen patient; just show their name
				$chosenPatient = $patient;
				echo "-&gt;" . $fnf->format($patient);
			} else {
				//This is another patient, allow user to choose them
				echo "<a class=\"basicLink boldLink\" href=\"" . $_SERVER['PHP_SELF'] . "?patientNum=$num\">" . $fnf->format($patient) . "</a>";
			}
			echo "</div>\n";
			$num++;
		}
		echo "</div><br />\n";
	}
	
	if (isset($chosenPatient)) {
		//Load the patient's CCR
		$query = new HealthQuery('ExportCCR', $chosenPatient->getFieldValue('uid'));
		$results = $query->run();
		if (isset($results) && count($results) > 0 && !($results[0]->getData() instanceof InvalidElement)) {
			$patientLink = $results[0]->getData();
			$ccrDoc = null;
			if (isset($patientLink)) {
				$ccrDoc = $patientLink->getFieldValue('document');
			}
			
			//Show the CCR as stylized by the CCR xsl document
			if (isset($ccrDoc)) {
				echo "<div class=\"bigorange spaced\">Health Information For " . $fnf->format($chosenPatient) . "</div>\n";
				echo processXSLT(getDOMFromFile(CCR_STYLE_DOC_LOCATION), getDOM($ccrDoc));
			} else {
				echo "<div class=\"bigorange spaced\">Health information not found for " . $fnf->format($chosenPatient) . "</div>\n";
				echo "<div class=\"smallItem\">Your health information could not be found at this time. Please try again later.</div>";
			}
			echo "<hr>\n";
		} else {
			klog("Error loading CCR for " . $fnf->format($chosenPatient) . ": " . dump($results), KLogger::ERROR);
			echo "<div class=\"bigorange spaced\">Health information not found for " . $fnf->format($chosenPatient) . "</div>\n";
			echo "<div class=\"smallItem\">Your health information could not be loaded at this time. Please try again later.</div>";
		}
	} else {
		echo "<div class=\"bigorange spaced\">Health information not found</div>\n";
		echo "<div class=\"smallItem\">Your health information could not be found at this time. Please try again later.</div>";
	}
	
	include "foot.php";
} //end if logged in
?>